#include <bits/stdc++.h>

using namespace std;

const int MAXA = 1000000;
const int MAXN = 100000;
const long long MUL = 1000 * 1000 * 1000;
long long dp[MAXA];
int l[MAXN], r[MAXN], c[MAXN];

int better(int x, int y)
{
	if (dp[x] < dp[y]) return x;
	return y;
}
struct minStack
{
	vector<pair<int, int> > st;
	void push(int x)
	{
		int y = x;
		if (!st.empty())
		{
			y = better(y, st.back().second);
		}
		st.push_back(make_pair(x, y));
	}
	void pop()
	{
		st.pop_back();
	}
	long long getMin()
	{
		if (st.empty()) return (long long)1e18;
		return dp[st.back().second];
	}
	bool empty()
	{
		return st.empty();
	}
	int top()
	{
		return st.back().first;
	}
};
struct Qmin
{
	minStack pushStack, popStack;
	void push(int x)
	{
		pushStack.push(x);
	}
	void pop()
	{
		if (popStack.empty())
		{
			while (!pushStack.empty())
			{
				popStack.push(pushStack.top());
				pushStack.pop();
			}
		}
		popStack.pop();
	}
	long long get_min()
	{
		return min(pushStack.getMin(), popStack.getMin());
	}
};
int A;
Qmin q[MAXN];


int main() {
  freopen("anti.in", "r", stdin);
  freopen("anti.out", "w", stdout);
  int n;
  scanf("%d%d", &n, &A);

  for (int i = 0; i < n; i++) {
    scanf("%d%d%d", &l[i], &r[i], &c[i]);
  }

  for (int i = A; i >= 0; i--) {
    dp[i] = 1LL * MUL * i;
    for (int j = 0; j < n; j++) {
      if (i + l[j] <= A) {
        q[j].push(i + l[j]);
      }
      if (i + r[j] < A) {
        q[j].pop();
      }
    }
    for (int j = 0; j < n; j++) {
      if (i + r[j] > A) continue;
      dp[i] = max(dp[i], q[j].get_min() - c[j]);
    }
  }
 // cerr << dp[0] << " " << dp[0] / MUL << " " << dp[0] % MUL << endl; 
  printf("%lld\n", dp[0]);
}
