#include <bits/stdc++.h>

using namespace std;

struct vect {
    int x, y;
    vect(int x1 = 0, int y1 = 0) {
        x = x1;
        y = y1;
    }
    vect operator+(const vect &b) {
        return vect(x + b.x, y + b.y);
    }
    vect operator-(const vect &b) {
        return vect(x - b.x, y - b.y);
    }
    long long operator*(const vect &b) {
        return (long long)x * b.x + (long long)y * b.y;
    }
    long long operator%(const vect &b) {
        return (long long)x * b.y - (long long)y * b.x;
    }
    long long len2() {
        return (long long)x * x + (long long)y * y;
    }
    bool operator==(const vect &b) {
        return x == b.x && y == b.y;
    }
};

int n;
vect st;

map <pair<int, int> , int> number;

bool cmp(vect a, vect b) {
    if (a == st) return true;
    if (b == st) return false;
    return (a - st) % (b - st) > 0;
}

void solve(vector <vect> a, vector <vect> ch) {
    while (ch.size() > 3) {
        int k = ch.size() / 2 + 1;
        cout << "? " << k << " ";
        for (int i = 0; i < k; i++) {
            cout << number[{ch[i].x, ch[i].y}] << " ";
        }
        cout << endl;
        fflush(stdout);
        string s;
        cin >> s;
        vector <vect> chnew;
        if (s == "Yes") {
            for (int i = 0; i < k; i++) {
                chnew.push_back(ch[i]);
            }
        } else {
            chnew.push_back(ch[0]);
            for (int i = k - 1; i < ch.size(); i++) {
                chnew.push_back(ch[i]);
            }
        }
        ch = chnew;
    }
    vector <vect> a1;
    for (auto i : a) {
        if ((i - ch[0]) % (ch[1] - i) < 0 && (i - ch[1]) % (ch[2] - i) < 0 && (i - ch[2]) % (ch[0] - i) < 0) {
            a1.push_back(i);
        }
        if ((i - ch[0]) % (ch[1] - i) > 0 && (i - ch[1]) % (ch[2] - i) > 0 && (i - ch[2]) % (ch[0] - i) > 0) {
            a1.push_back(i);
        }
    }
    srand(n + abs(ch[0].x));
    while (a1.size() > 0) {
        int k = rand() % a1.size();
        cout << "? 3 ";
        cout << number[{ch[0].x, ch[0].y}] << " ";
        cout << number[{ch[1].x, ch[1].y}] << " ";
        cout << number[{a1[k].x, a1[k].y}] << endl;
        fflush(stdout);
        string s;
        cin >> s;
        if (s == "Yes") {
            ch[2] = a1[k];
        } else {
            cout << "? 3 ";
            cout << number[{ch[0].x, ch[0].y}] << " ";
            cout << number[{ch[2].x, ch[2].y}] << " ";
            cout << number[{a1[k].x, a1[k].y}] << endl;
            fflush(stdout);
            cin >> s;
            if (s == "Yes") {
                ch[1] = a1[k];
            } else {
                ch[0] = a1[k];
            }
        }
        vector <vect> a1new;
        for (auto i : a1) {
            if ((i - ch[0]) % (ch[1] - i) < 0 && (i - ch[1]) % (ch[2] - i) < 0 && (i - ch[2]) % (ch[0] - i) < 0) {
                a1new.push_back(i);
            }
            if ((i - ch[0]) % (ch[1] - i) > 0 && (i - ch[1]) % (ch[2] - i) > 0 && (i - ch[2]) % (ch[0] - i) > 0) {
                a1new.push_back(i);
            }
        }
        a1 = a1new;
    }
    cout << "! 3 ";
    cout << number[{ch[0].x, ch[0].y}] << " ";
    cout << number[{ch[1].x, ch[1].y}] << " ";
    cout << number[{ch[2].x, ch[2].y}] << endl;
    fflush(stdout);
}

int main()
{
    cin >> n;
    vector <vect> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        number[{a[i].x, a[i].y}] = i + 1;
    }
    st = a[0];
    for (int i = 0; i < n; i++) {
        if (a[i].x < st.x) {
            st = a[i];
        }
    }
    sort(a.begin(), a.end(), cmp);
    a.push_back(st);
    vector <vect> ch;
    int siz = 0;
    for (vect i : a) {
        if (siz < 2) {
            ch.push_back(i);
            siz++;
        } else {
            while (siz >= 2 && (ch[siz - 1] - ch[siz - 2]) % (i - ch[siz - 1]) < 0) {
                ch.pop_back();
                siz--;
            }
            ch.push_back(i);
            siz++;
        }
    }
    /*for (auto i : ch) {
        cout << i.x << " " << i.y << endl;
    }*/
    ch.pop_back();
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        solve(a, ch);
    }
    return 0;
}
