#include <iostream>

using namespace std;

#define f first
#define s second

int n;
string s, t;

pair<char, pair<int, int> > group[1000001];
int arr_s[1000001];

int skolko_left(int ind)
{
    int res = group[ind--].s.s;
    while(ind >= 0 and group[ind].f == group[ind+1].f)
        res += group[ind--].s.s;
    return res;
}

int skolko_right(int ind, int ind_end)
{
    int res = group[ind++].s.s;
    while(ind <= ind_end and group[ind].f == group[ind-1].f)
        res += group[ind++].s.s;
    return res;
}

void action()
{
    cin >> s >> t;
    group[0].s.s = 1;
    group[0].s.f = 0;
    group[0].f = s[0];
    arr_s[0] = 0;

    for(int i = 1; i < s.size(); i++){
        if(s[i] == s[i-1] and t[i] != t[i-1]){
            cout << "No" << endl;
            return;
        }
    }

    int ind = 0;
    for(int i = 1; i < s.size(); i++){
        if(s[i] != s[i-1]){
            group[++ind].s.f = i;
            group[ind].f = s[i];
            group[ind].s.s = 0;
        }
        arr_s[i] = ind;
        group[ind].s.s++;
    }
    int is = 1;
    while(is){
        is = 0;
        for(int i = 0; i <= ind; i++){
            if(s[group[i].s.f] != t[group[i].s.f]){
                if(i != 0 and skolko_left(i-1) > group[i].s.s){
                    for(int j = 0; j < group[i].s.s; j++){
                        s[group[i].s.f + j] = t[group[i].s.f];
                    }
                    group[i].f = s[group[i].s.f];
                    is = 1;
                }
                else if(i != ind and skolko_right(i+1, ind) > group[i].s.s){
                    for(int j = 0; j < group[i].s.s; j++){
                        s[group[i].s.f + j] = t[group[i].s.f];
                    }
                    group[i].f = s[group[i].s.f];
                    is = 1;
                }
            }
        }
    }
    if(s == t)
        cout << "Yes" << endl;
    else
        cout << "No" << endl;
}

int main()
{
    cin >> n;
    for(int i = 0; i < n; i++)
        action();
    return 0;
}
