#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 2e6 + 100;

const int inf = 1e9 + 100;

int p[2097152 + 100], q[2097152 + 100];

int fun(int x, int y, int t){
    if (t == 0)
        return min(x, y);
    return max(x, y);
}

int finf(int t){
    if (t == 0)
        return inf;
    return -inf;
}

void build(int v, int l, int r){
    q[v] = -inf;
    if (l == r)
        return;
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
}

int get(int v, int tl, int tr, int l, int r, int t){
    if (l > r)
        return finf(t);
    if (tl == l && tr == r)
        return q[v];
    int m = (tl + tr) / 2;
    return fun(get(2 * v, tl, m, l, min(r, m), t), get(2 * v + 1, m + 1, tr, max(l, m + 1), r, t), t);
}

void update(int v, int l, int r, int id, int val, int t){
    if (l == r){
        q[v] = val;
        return;
    }
    int m = (l + r) / 2;
    if (id <= m)
        update(2 * v, l, m, id, val, t);
    else
        update(2 * v + 1, m + 1, r, id, val, t);
    q[v] = fun(q[2 * v], q[2 * v + 1], t);
}

void build1(int v, int l, int r, int t){
    if (l == r){
        p[v] = l;
        return;
    }
    int m = (l + r) / 2;
    build1(2 * v, l, m, t);
    build1(2 * v + 1, m + 1, r, t);
    p[v] = fun(p[2 * v], p[2 * v + 1], t);
}

int get1(int v, int tl, int tr, int l, int r, int t){
    if (l > r)
        return finf(t);
    if (tl == l && tr == r)
        return p[v];
    int m = (tl + tr) / 2;
    return fun(get1(2 * v, tl, m, l, min(r, m), t), get1(2 * v + 1, m + 1, tr, max(l, m + 1), r, t), t);
}

void update1(int v, int l, int r, int id, int val, int t){
    if (l == r){
        p[v] = val;
        return;
    }
    int m = (l + r) / 2;
    if (id <= m)
        update1(2 * v, l, m, id, val, t);
    else
        update1(2 * v + 1, m + 1, r, id, val, t);
    p[v] = fun(p[2 * v], p[2 * v + 1], t);
}

struct heap{
    stack<int> a, b;
    stack<int> am, bm;
};

void push(heap &a, int x, int t){
    if (a.b.empty())
        a.b.push(x), a.bm.push(x);
    else{
        int v = a.bm.top();
        a.b.push(x);
        a.bm.push(fun(v, x, t));
    }
}

void pop(heap &a, int t){
    if (!a.a.empty())
        a.a.pop(), a.am.pop();
    else{
        int v = finf(t);
        while (!a.b.empty()){
            int x = a.b.top();
            a.b.pop();
            a.bm.pop();
            v = fun(v, x, t);
            a.a.push(x);
            a.am.push(v);
        }
        pop(a, t);
    }
}

int get(heap &a, int t){
    int x = finf(t), y = finf(t);
    if (!a.a.empty())
        x = a.am.top();
    if (!a.b.empty())
        y = a.bm.top();
    return fun(x, y, t);
}

void clear(heap &a){
    while (!a.a.empty())
        a.a.pop();
    while (!a.b.empty())
        a.b.pop();
    while (!a.am.empty())
        a.am.pop();
    while (!a.bm.empty())
        a.bm.pop();
}

int n, A;

int pmas[maxn];

pair<pair<int, int>, int> seg[110];

heap g[110], e[110];

const ll ww = 1e9;

int ST = 2097152;
//2097152
int main()
{
    #ifdef ONPC
    ifstream cin("a.in");
    ofstream cout("a.out");
    #else
    ifstream cin("anti.in");
    ofstream cout("anti.out");
    #endif // ONPC
    ios::sync_with_stdio(0);
    cin >> n >> A;
    //ST = A + 1;
    for (int i = 0; i < n; i++)
        clear(g[i]), clear(e[i]), cin >> seg[i].first.first >> seg[i].first.second >> seg[i].second, swap(seg[i].first.first, seg[i].first.second);
    sort(seg, seg + n);
    for (int i = 0; i < n; i++)
        swap(seg[i].first.first, seg[i].first.second);
    //build1(1, 0, ST - 1, 0);
    for (int i = A; i >= 0; i--){
        int val = i;
        for (int j = 0; j < n; j++){
            if (seg[j].first.second + i <= A)
                val = max(val, get(g[j], 0));
        }
        p[i] = val;
        pmas[i] = val;
        for (int j = 0; j < n; j++){
            int id;
            id = seg[j].first.first + i - 1;
            if (id >= 0 && id <= A){
                push(g[j], p[id], 0);
            }
            id = seg[j].first.second + i;
            if (id <= A){
                pop(g[j], 0);
            }
        }
    }
    for (int i = 0; i <= A; i++)
        q[i] = -inf;
    for (int i = 0; i < n; i++)
        clear(g[i]);
    //build(1, 0, ST - 1);
    q[pmas[0]] = 0;
    //update(1, 0, ST - 1, pmas[0], 0, 1);
    for (int i = A; i >= 0; i--){
        if (pmas[i] == pmas[0]){
            int x = inf;
            for (int j = 0; j < n; j++){
                if (seg[j].first.second + i <= A){
                    if (get(g[j], 0) >= pmas[0]){
                        int y = get(e[j], 1);
                        if (y != -inf)
                            x = min(x, y + seg[j].second);
                    }
                }
            }
            if (x != inf)
                q[i] = x;
            //update(1, 0, ST - 1, i, x, 1);
        }
        for (int j = 0; j < n; j++){
            int id;
            id = seg[j].first.first + i - 1;
            if (id >= 0 && id <= A){
                push(g[j], p[id], 0);
                push(e[j], q[id], 1);
            }
            id = seg[j].first.second + i;
            if (id <= A){
                pop(g[j], 0);
                pop(e[j], 1);
            }
        }
    }
    cout << ww * pmas[0] - q[0];
}
