#include <iostream>
#include <vector>
#include <set>
#include <bitset>

using namespace std;

typedef long long ll;
const ll maxn = 21280;
const ll inf = 1e9;
vector<pair<ll, ll>> g[maxn];
ll d[maxn];
ll ans[maxn];
pair<pair<ll, ll>, ll> a[maxn];
ll b[maxn];
ll n, m;
set<pair<ll, ll>> q;

int main()
{
    cin >> n >> m;
    for (ll i = 0; i < m; ++i)
    {
        ll s;
        cin >> s;
        for (ll j = 0; j < 2 * s + 1; ++j)
            cin >> b[j];
        ll l = 0;
        for (ll j = 0; j <= 2 * s - 2; j += 2)
        {
            a[l++] = {{b[j], b[j + 2]}, b[j + 1]};
        }
        for (ll j = 0; j < s; ++j)
        {
            ll sum = 0;
            ll fr = a[j].first.first;
            for (ll k = j; k < s; ++k)
            {
                ll to = a[k].first.second;
                sum += a[k].second;
                g[fr - 1].push_back({to - 1, sum});
            }
        }
    }
    for (ll i = 0; i < n; ++i)
        d[i] = inf;
    d[0] = 0;
    q.insert({0, 0});
    while (!q.empty())
    {
        ll v = q.begin()->second;
        q.erase(q.begin());
        for (ll i = 0; i < g[v].size(); ++i)
        {
            ll to = g[v][i].first;
            ll cost = g[v][i].second;
            if (d[v] + cost == d[to])
                ans[to] = max(ans[to], ans[v] + cost * cost);
            if (d[v] + cost < d[to])
            {
                q.erase({d[to], to});
                d[to] = d[v] + cost;
                q.insert({d[to], to});
                ans[to] = ans[v] + cost * cost;
            }
        }
    }
    cout << d[n - 1] << " " << ans[n - 1];
    return 0;
}
