#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <bitset>
#include <algorithm>
#define ll long long
#define mp make_pair
#define MOD 1000000007

using namespace std;

const int mx = 2000000, log = 31;
int n, temp, pow2[log], a[mx][log], zero[log], one[log], q, p, u;

void up (int x, int mult) {
    for (int i = (log-1); i >= 0; --i) {
        if ((a[x][i] == 0) && (a[x+1][i] == 1)) {
            zero[i] += mult;
            return;
        }
        if ((a[x][i] == 1) && (a[x+1][i] == 0)) {
            one[i] += mult;
            return;
        }
    }
}

int get() {
    int res = 0;
    for (int i = 0; i < log; ++i) {
        if ((zero[i] > 0) && (one[i] > 0))
            return -1;
        if (one[i] > 0)
            res += pow2[i];
    }
    return res;
}

int main()
{
    pow2[0] = 1;
    for (int i = 1; i < log; ++i) {
        pow2[i] = pow2[i-1] * 2;
    }
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> temp;
        for (int j = 0; j < log; ++j) {
            a[i][j] = (temp % 2);
            temp /= 2;
        }
    }
    for (int i = 0; i < log; ++i) {
        zero[i] = 0;
        one[i] = 0;
    }
    for (int i = 0; i < (n-1); ++i) {
        up(i, 1);
    }
    cout << get() << '\n';
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> p >> u;
        p--;
        if (p != 0)
            up(p-1, -1);
        if (p != (n-1))
            up(p, -1);
        for (int i = 0; i < log; ++i) {
            a[p][i] = (u % 2);
            u /= 2;
        }
        if (p != 0)
            up(p-1, 1);
        if (p != (n-1))
            up(p, 1);
        cout << get() << '\n';
    }
    return 0;
}
