#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <bitset>
#include <algorithm>
#include <string>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#define ll long long
#define mp make_pair
#define MOD 1000000007

using namespace std;

const ll INF = 1000000000000000000ll;
const ll mx = 300000;
ll n, l[mx], r[mx], t[mx];
pair<ll, ll> send_l[mx], send_r[mx];

int main()
{
    cin >> n;
    for (ll i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (ll i = 0; i < (n-1); ++i) {
        cin >> l[i] >> r[i];
    }
    send_l[0] = {0, INF};
    send_r[n-1] = {0, INF};
    for (int i = 1; i < n; ++i) {
        ll L = send_l[i-1].first, R = send_l[i-1].second;
        ll L1 = max(L, l[i-1]), R1 = min(R, r[i-1]);
        if (L1 > R1) {
            for (int j = i; j < n; ++j)
                send_l[j] = {-1, -1};
            break;
        }
        if (L > l[i-1])
            send_l[i].first = L;
        else
            send_l[i].first = l[i-1] - t[i];
        send_l[i].second = R1;
    }
    for (int i = (n-2); i >= 0; --i) {
        ll L = send_r[i+1].first, R = send_r[i+1].second;
        ll L1 = max(L, l[i]), R1 = min(R, r[i]);
        if (L1 > R1) {
            for (int j = i; j >= 0; --j)
                send_r[j] = {-1, -1};
            break;
        }
        if (L > l[i])
            send_r[i].first = L;
        else
            send_r[i].first = l[i] - t[i];
        send_r[i].second = R1;
    }
    for (int i = 0; i < n; ++i) {
        if ((send_l[i].second < 0) || (send_r[i].second < 0))
            cout << -1 << '\n';
        else {
            ll L = max(send_l[i].first, send_r[i].first), R = min(send_l[i].second, send_r[i].second);
            if ((R < 0) || (L > R))
                cout << -1 << '\n';
            else
                cout << max(L, 0ll) << '\n';
        }
    }
    return 0;
}
