#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
int n;
vector<pair<int, int>> points;

double s(pair<int, int> a, pair<int, int> b, pair<int, int> c) {
    double pl = 0;
    pl += (a.second + b.second) / 2 * (b.first - a.first);
    pl += (b.second + c.second) / 2 * (c.first - b.first);
    pl += (c.second + a.second) / 2 * (a.first - c.first);
    return abs(pl);
}

int main() {
    cin >> n;
    string ans;
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        points.push_back(make_pair(a, b));
    }
    int q;
    cin >> q;
    for (int t = 0; t < q; t++) {
        bool find = false;
        int i, j, k;
        for (i = 1; i <= n - 2 && !find; i++) {
            for (j = i + 1; j <= n - 1 && !find; j++) {
                for (k = j + 1; k <= n && !find; k++) {
                    cout << "? " << "3 " << i << " " << j << " " << k << endl;
                    cin >> ans;
                    if (ans[0] == 'Y') {
                        find = true;
                    }
                    if (find) {
                        double s1 = s(points[i - 1], points[j - 1], points[k - 1]);
                        for (int z = 0; z < n; z++) {
                            if (z != i - 1 && z != j - 1 && z != k - 1) {
                                double pl = (s(points[z], points[j - 1], points[k - 1]) +
                                             s(points[i - 1], points[z], points[k - 1]) +
                                             s(points[i - 1], points[j - 1], points[z]));

                                if (pl == s1) {
                                    find = false;
                                    break;
                                }
                            }
                        }
                    }

                }
            }
        }
        cout << "! " << "3 " << i-1 << " " << j-1 << " " << k-1 << endl;
    }
    return 0;
}