#include <cstdlib>
#include <cmath>
#include <iostream>
#include <vector>
#include <cstdio>
#include <set>
#include <map>
#include <algorithm>

#pragma comment(linker, "/STACK:265000000")
#pragma warning(disable : 4996)

#define forn(i_, s_t, f_i) for(int i_ = s_t; i_ < f_i; i_++)
#define ff first
#define ss second
#define IN_FILE "order.in"
#define OUT_FILE "order.out"

using namespace std;
typedef long long ll;
typedef pair<int,int> pii;

const int MAXN = 1e6 + 10;
int a[MAXN];
int q = 0;
int n = 0;
set<int> bad;

pii rec(int l, int r, int lev) {
	
	int st = -1;
	forn(i, l + 1, r) {
		if (((a[i]>>lev)&1) != ((a[i - 1]>>lev)&1)) {
			if (st == -1) {
				st = i;
			}
			else {
				
				return{ -1, 0};
			}
		}
	}

	if (lev == 0) {
		if (st == -1) {
			return {0, 0};
		}
		else {
			if ((a[l] & 1) == 0) {
				
				return{ 0, 1 };
			}
			else {//cout << "000" << " " << a[l] << " " << l << " " << r << " " << lev << endl;
				return{ 1, 1 };
			}
		}

	}


	if (st == -1) {
		//cout << lev << endl;
		return rec(l, r, lev - 1);
	}


	int b = 0;
	int c = 0;
	if (((a[l] >>lev)& 1) == 0) {
		b = 0;
		c = (1<<lev);
	}
	else {
		b = (1<<lev);
		c = (1<<lev);
	}

	pii pl = rec(l, st, lev - 1);
	pii pr = rec(st, r, lev - 1);
	if (pl.ff == -1 || pr.ff == -1) {
		return {-1, c};
	}
	b |= pl.ff;
	b |= pr.ff;
	c |= pl.ss;
	c |= pr.ss;
	//cout <<  l << " " << r << " " << lev << "\n";
	//cout << b << " " << c << " " << pl.ff << " " << pr.ff << endl;


	for (int i = 0; i < lev; i++) {
		if (((b>>i)&1) != ((pl.ff >> i)&1) && ((pl.ss >> i)&1) == 1) {
			//cout <<b << " " <<  l << " " << r << " " << lev << "\n";
			return{ -1, c };
		}
		if (((b >> i)&1) != ((pr.ff >> i)&1) && ((pr.ss >> i)&1) == 1) {
			//cout << b << " " <<l << " " << r << " " << lev << "\n";
			return{ -1, c };
		}
	}

	return{ b,c };
}

void solve() {
	pii ans = rec(0, n, 30);
	printf("%d\n", ans.ff);
	forn (test, 0, q) {
		int p, v;
		scanf("%d %d", &p, &v);
		p--;
		a[p] = v;
		ans = rec(0, n, 30);
		printf("%d\n", ans.ff);
	}
}

inline bool check(int b) {
	forn(i, 1, n) {
		if ((a[i - 1] ^ b) > (a[i] ^ b)) {
			return false;
		}
	}
	return true;
}

void solve_sil() {
	int b = 0;
	int mx =( 1 << 9)+ 2;
	bool w = false;
	while (b < mx) {
		if (check(b)) {
			w = true;
			printf("%d\n", b);
			break;
		}
		b++;
	}
	if (!w) {
		printf("%d\n", -1);
	}

	forn(i, 0, q) {
		b = 0;
		int p, v;
		scanf("%d%d", &p, &v);
		a[p - 1] = v;
		bool w = false;
		while (b < mx) {
			if (check(b)) {
				w = true;
				printf("%d\n", b);
				break;
			}
			b++;
		}
		if (!w) {
			printf("%d\n", -1);
		}
	}
}


int main() {
	freopen(IN_FILE, "r", stdin);
	freopen(OUT_FILE, "w", stdout);

	scanf("%d", &n);
	forn(i, 0, n) {
		scanf("%d", &a[i]);
	}
	scanf("%d", &q);
	solve();
	//while (true) {}

	return 0;
}