#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())
#define endl '\n'

const bool judge = true, stress = false;

int cnt_tests = 1;

typedef long long llong;

const int INF = 2e9 + 29;
const llong LINF = 4e18 + 17;

// JUST DO IT!

// Code below

int n, q;

vector<llong> a;
vector<pair<int, llong> > qs;

void inp() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cin >> q;
    qs.resize(q);
    for (int i = 0; i < q; i++) {
         cin >> qs[i].fi >> qs[i].se;
    }
}

inline int Bit(llong num, int val) {
    return (num >> val) & 1ll;
}

const int LOG = 32;

int B[LOG];

bool calcB(int l, int r, int bit, vector<llong> &a) {
    if (bit == -1) {
        return true;
    }
    int cnt = 0, ind = n;
    for (int i = l; i + 1 <= r; i++) {
        if (Bit(a[i], bit) != Bit(a[i + 1], bit)) {
            cnt++;
            ind = i;
            if (cnt > 1) {
                return false;
            }
        }
    }
    //cout << l << ' ' << r << ' ' << bit << ' ' << cnt << endl;
    if (cnt == 0) {
        return calcB(l, r, bit - 1, a);
    } else {
        if (B[bit] == 3) {
            B[bit] = Bit(a[ind], bit);
        }
        if (B[bit] != Bit(a[ind], bit)) {
            return false;
        }
        if (!calcB(l, ind, bit - 1, a))
            return false;
        if (!calcB(ind + 1, r, bit - 1, a))
            return false;
    }
    return true;
}

llong buildQ(vector<llong> &a) {
    for (int i = 0; i < LOG; i++) {
        B[i] = 3;
    }
    bool r = calcB(0, sz(a) - 1, LOG - 1, a);
    if (!r) {
        return -1;
    }
    llong res = 0;
    for (int i = LOG - 1; i >= 0; i--) {
        //cout << B[i];
        llong bit = 0;
        if (B[i] == 3) {
            bit = 0;
        } else {
            bit = B[i];
        }
        res = ((res << 1ll) | bit);
    }
   // cout << endl;
    return res;
}

const int N = 2e5 + 25;

bool used[N];
int to[N];

void solve() {
    cout << buildQ(a) << endl;
    int SQRT = 1 + (int)sqrt(q);
    set<int> frozen;
    vector<pair<int, llong> > cur;
    int calm = 0;
    for (int i = 0; i < sz(qs); i++) {
        qs[i].fi--;
        calm++;
        used[qs[i].fi] = true;
        cur.pb(qs[i]);
        if (calm == SQRT || i == sz(qs) - 1) {
            vector<llong> base, res;
            for (int j = 0; j < n; j++) {
                if (used[j]) {
                    if (!base.empty()) {
                        llong num = buildQ(base);
                        base.clear();
                        res.pb(num);
                    }
                    res.pb(a[j]);
                    to[j] = sz(res) - 1;
                } else {
                    base.pb(a[j]);
                }
            }
            if (!base.empty()) {
                llong num = buildQ(base);
                base.clear();
                res.pb(num);
            }
            for (auto x: cur) {
                res[to[x.fi]] = x.se;
                llong num = buildQ(res);
                cout << num << endl;
            }
            for (int j = 0; j < n; j++) {
                used[j] = false;
            }
            cur.clear();
            res.clear();
            calm = 0;
        }
    }
}

void run() {
    if (!stress) {
        inp();
        solve();
        cout << endl;
    }
}

int main() {
    if (!judge) {
        freopen("input.txt", "r", stdin);
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    }
    for (int i = 0; i < cnt_tests; i++) {
        run();
    }
}
