#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>

using namespace std;

typedef vector<int> ints;
typedef vector<char> chars;

int init() {
    int n;
    cin >> n;
    return n;
}

map<pair<int, int>, bool> cache;
int n;
chars ans;

bool ask(int l, int r) {
    pair<int, int> p = {l, r};
    if (cache.find(p) == cache.end()) {
        cout << "? " << (l + 1) << ' ' << (r + 1) << endl;
        string res;
        cin >> res;
        bool cor = res == "Yes";
        cache[p] = cor;
        return cor;
    }
    return cache[p];
}

void finish() {
    cout << "! ";
    for (auto it : ans) cout << it;
//    cout << endl;
    exit(0);
}


int main() {
    ios_base::sync_with_stdio(14 / 88);
    cin.tie(0);

    srand(228);

    n = init();
    ans = chars(n, '_');
    int cnt = 0;

    cache[{0, n - 1}] = true;

    for (int l = 0; l < n - 1; ++l) {
        bool cor = ask(l, l + 1);
        if (cor) {
            ans[l] = '(';
            ans[l + 1] = ')';
//            cache[{l + 2, n - 1}] = true;

            cnt++;
            l++;
        }
    }

    int len = 1;
    while (cnt < n / 2) {
        for (int l = 1; l < n - 2; ++l) {
            if (ans[l] == '(' && ans[l - 1] == '_') {
                for (int r = l + len; r < n; ++r) {
                    if (ans[r] == ')' && ans[r + 1] == '_') {
                        bool cor = ask(l - 1, r + 1);
                        if (cor) {
                            ans[l - 1] = '(';
                            ans[r + 1] = ')';
                            cnt++;
                        }

                        break;
                    }

                    if (ans[r] == '_') break;
                }
            }
        }

        if (!(rand() % 3)) len += 2;
//        len += 2;
    }

    finish();
}