#include <iostream>
#include <vector>

using namespace std;
#define long long long
#define INF (1ll << 50)

typedef pair<int, int> pii;

/*
1
10

2
3 5
6 8

3
1 2 4
7 10
3 5

4
1 0 3 2
4 6
5 5
7 10
 */

int main() {
    int n;
    cin >> n;
    vector<long> t(n);
    vector<pii> c(n - 1);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int i = 0; i < n - 1; ++i) {
        cin >> c[i].first >> c[i].second;
    }

    vector<long> lmin(n, INF);
    vector<long> lmax(n, 0);
    vector<long> rmin(n, INF);
    vector<long> rmax(n, 0);
    lmin[0] = rmin[n - 1] = 0;
    lmax[0] = rmax[n - 1] = INF;
    for (int i = 1; i < n; ++i) {
        if (c[i - 1].second < lmin[i - 1]) {
            break;
        }

        lmin[i] = max(0ll, max(lmin[i - 1], (long) c[i - 1].first - t[i]));
        if (lmin[i] > c[i - 1].second) {
            lmin[i] = INF;
            break;
        }

        lmax[i] = min((long) c[i - 1].second, lmax[i - 1]);

        if (max(lmin[i], (long) c[i - 1].first) > lmax[i - 1]) {
            lmin[i] = INF;
            lmax[i] = 0;
            break;
        }
    }
    for (int i = n - 2; i >= 0; --i) {
        if (c[i].second < rmin[i + 1]) {
            break;
        }

        rmin[i] = max(0ll, max(rmin[i + 1], (long) c[i].first - t[i]));
        if (rmin[i] > c[i].second) {
            rmin[i] = INF;
            break;
        }

        rmax[i] = min((long) c[i].second, rmax[i + 1]);

        if (max(rmin[i], (long) c[i].first) > rmax[i + 1]) {
            rmin[i] = INF;
            rmax[i] = 0;
            break;
        }
    }

    for (int i = 0; i < n; ++i) {
        long res = max(lmin[i], rmin[i]);
        if (res >= INF) {
            res = -1;
        } else {
            if (lmax[i] < lmin[i] || rmax[i] < rmin[i]) {
                res = -1;
            }
        }
        cout << res << '\n';
    }

    return 0;
}