#include <iostream>
#include <vector>

using namespace std;
#define long long long
#define INF (1ll << 50)

typedef pair<int, int> pii;

/*
1
10

2
3 5
6 8

3
1 2 4
7 10
3 5

4
1 0 3 2
4 6
5 5
7 10
 */

int main() {
    int n;
    cin >> n;
    vector<long> t(n);
    vector<pii> c(n - 1);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int i = 0; i < n - 1; ++i) {
        cin >> c[i].first >> c[i].second;
    }

    for (int i = 0; i < n; ++i) {
        vector<long> time(n, INF);
        bool gg = false;
        long st;
        for (st = max(0ll,
                      max((i < n - 1) ? (long) c[i].first : 0ll,
                          (i > 0) ? (long) c[i - 1].first : 0ll) - t[i]);

             st <= min((i < n - 1) ? (long) c[i].second : INF,
                       (i > 0) ? (long) c[i - 1].second : INF); ++st) {

            time[i] = st;

            bool ok = true;
            bool fatal = false;
            for (int j = i; j < n - 1; ++j) {
                if (c[j].second < time[j]) {
                    ok = false;
                    fatal = true;
                    break;
                }
                if (c[j].first > time[j] + t[j]) {
                    ok = false;
                    break;
                } else {
                    time[j + 1] = max(time[j], (long) c[j].first);
                }
            }

//            if (!ok)
                for (int j = i; j > 0; --j) {
                    if (c[j - 1].second < time[j]) {
                        ok = false;
                        fatal = true;
                        break;
                    }
                    if (c[j - 1].first > time[j] + t[j]) {
                        ok = false;
                        break;
                    } else {
                        time[j - 1] = max(time[j], (long) c[j - 1].first);
                    }
                }

            if (ok) {
                gg = true;
                break;
            }
            if (fatal) break;
        }

        if (!gg) {
            cout << "-1\n";
        } else {
            cout << st << '\n';
        }
    }

    return 0;
}