#include <bits/stdc++.h>

#define pb push_back
#define REP(i, a, b) for (int  i = (a); i <= (b); ++i)
#define sz(v) int((v).size())
#define all(v) (v).begin(), (v).end()

using namespace std;

typedef long long ll;

struct pt
{
    ll x, y;
    pt (ll x, ll y) : x(x), y(y) {}
    pt () {}
} data[100];

int n;

pt operator - (const pt &a, const pt &b)
{
    return pt(a.x - b.x, a.y - b.y);
}

ll operator ^ (const pt &a, const pt &b)
{
    return a.x*b.y - a.y*b.x;
}

void ask(int i, int j, int k)
{
    cout << '?' << ' ' << 3 << ' ' << i << ' ' << j << ' ' << k << endl;
}

bool get()
{
    string s;
    cin >> s;
    return s[0] == 'Y';
}

inline int signll(ll x)
{
    if (x > 0)
        return 1;
    return 0;
}

void solve()
{
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++)
            for (int k = j + 1; k < n; k++)
            {
                ask(i + 1, j + 1, k + 1);

                bool ans = get();
                if (!ans) continue;

                bool ok = true;
                for (int w = 0; w < n; ++w)
                {
                    if (w == i) continue;
                    if (w == j) continue;
                    if (w == k) continue;

                    int a = signll((data[w] - data[i]) ^ (data[j] - data[i]));
                    int b = signll((data[w] - data[j]) ^ (data[k] - data[j]));
                    int c = signll((data[w] - data[k]) ^ (data[i] - data[k]));
                    if (a == b && a == c)
                    {
                        ok = false;
                        break;
                    }
                }

                if (ok)
                {
                    cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
                    return;
                }
            }

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin >> n;

    REP (i, 0, n - 1)
        cin >> data[i].x >> data[i].y;

    int q;
    cin >> q;

    REP (i, 0, q - 1)
        solve();
    return 0;
}
