#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long int ll;
typedef pair<int, int> pii;

template<typename T> using ordered_set = tree<T, null_type, less<T>,
        rb_tree_tag, tree_order_statistics_node_update>;

bool correct(int a, int b) {
    cout << "? " << a + 1 << " " << b + 1 << endl;
    string s;
    cin >> s;
    return s == "Yes";
}

int n;
string s;
ordered_set<pii> st;

void merge(int & a, int & b) {
    int order = st.order_of_key({a, b});
    if (order == 0)
        return;
    pii prev = (*st.find_by_order(order - 1));
    if (prev.second == a - 1)
        a = prev.first;
}

void eras(int a, int b) {
    int order = st.order_of_key({a, b});
    while (order + 1 < st.size()) {
        pii cur = *st.find_by_order(order + 1);
        if (cur.first >= a && cur.second <= b) {
            st.erase(cur);
        } else {
            break;
        }
    }
}

void extend(int a, int b) {
    s[a] = '(';
    s[b] = ')';
    merge(a, b);
    st.insert({a, b});
    eras(a, b);

    if (a - 1 >= 0 && b + 1 < n) {
        if (correct(a - 1, b + 1))
            extend(a - 1, b + 1);
    }
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++)
        s += "?";

    vector<pii> vec;
    for (int i = 0; i < n - 1; i++) {
        if (correct(i, i + 1)) {
            st.insert({i, i + 1});
            vec.push_back({i, i + 1});
            i++;
        }
    }

    for (auto it : vec)
        extend(it.first, it.second);

    cout << s << endl;
}