#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int n;
vector<pll> vec;

ll sqr(int a, int b, int c) {
    ll ank = vec[a].first * (vec[b].second - vec[c].second) +
             vec[b].first * (vec[c].second - vec[a].second) +
             vec[c].first * (vec[a].second - vec[b].second);
    return abs(ank);
}

bool correct(int a, int b, int c) {
    ll sq = sqr(a, b, c);
    for (int i = 0; i < n; i++) {
        if (i == a || i == b || i == c)
            continue;
        ll nsq = sqr(a, b, i) + sqr(a, i, c) + sqr(i, b, c);
        if (nsq == sq)
            return false;
    }
}

bool can(int a, int b, int c) {
    cout << "? 3 " << a + 1 << " " << b + 1 << " " << c + 1 << endl;
    string s;
    cin >> s;
    return s == "Yes";
}

void ans(int a, int b, int c) {
    cout << "! 3 " << a + 1 << " " << b + 1 << " " << c + 1 << endl;
}

int main() {
    cin >> n;
    vec.resize(n);
    for (int i = 0; i < n; i++)
        cin >> vec[i].first >> vec[i].second;
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        bool cc = false;
        for (int a = 0; a < n && !cc; a++) {
            for (int b = a + 1; b < n && !cc; b++) {
                for (int c = b + 1; c < n && !cc; c++) {
                    if (!correct(a, b, c))
                        continue;
                    if (can(a, b, c)) {
                        ans(a, b, c);
                        cc = true;
                    }
                }
            }
        }
    }
}