#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>

using namespace std;

const int INF = 1e9 + 13;

int main() {
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<int> t(n);
	for (int i = 0; i < n; i++)
		cin >> t[i];
	vector< pair<int, int> > a(n - 1);
	for (int i = 0; i < n - 1; i++)
		cin >> a[i].first >> a[i].second;
	vector<int> mnl(n), mxl(n);
	mnl[0] = 0;
	mxl[0] = INF;
	for (int i = 1; i < n; i++) {
		if (mxl[i - 1] < a[i - 1].first)
			mnl[i] = INF + 1;
		else {
			if (a[i - 1].first >= mnl[i - 1])
				mnl[i] = max(0, a[i - 1].first - t[i]);
			else {
				mnl[i] = mnl[i - 1];
			}
		}
		mxl[i] = min(mxl[i - 1], a[i - 1].second);
		if (mnl[i - 1] > mxl[i - 1])
			mnl[i] = INF + 1;
	}
	vector<int> mnr(n), mxr(n);
	mnr[n - 1] = 0;
	mxr[n - 1] = INF;
	for (int i = n - 2; i >= 0; i--) {
		if (mxr[i + 1] < a[i].first)
			mnr[i] = INF + 1;
		else {
			if (a[i].first >= mnr[i + 1])
				mnr[i] = max(0, a[i].first - t[i]);
			else {
				mnr[i] = mnr[i + 1];
			}
		}
		mxr[i] = min(mxr[i + 1], a[i].second);
		if (mnr[i + 1] > mxr[i + 1])
			mnr[i] = INF + 1;
	}
	for (int i = 0; i < n; i++) {
		int mn = max(mnl[i], mnr[i]);
		int mx = min(mxl[i], mxr[i]);
		if (mx < mn)
			cout << -1 << '\n';
		else
			cout << max(mn, 0) << '\n';
	}
	return 0;
}