#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int MAXN = 5023;
int t[MAXN], l[MAXN], r[MAXN];
int n;
bool ok(int x, int T) {
	int curt = T;
	for (int i = x; i < n - 1; i++) {
		int prev = curt;
		curt = max(curt, l[i]);
		if (curt > t[i] + prev) return 0;
		if (curt > r[i]) return 0;
	}
	curt = T;
	for (int i = x - 1; i >= 0; i--) {
		int prev = curt;
		curt = max(curt, l[i]);
		if (curt > t[i + 1] + prev) return 0;
		if (curt > r[i]) return 0;
	}
	return 1;
}

int solve() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}
	for (int i = 0; i < n - 1; i++) {
		cin >> l[i] >> r[i];
	}

	for (int i = 0; i < n; i++) {
		bool cant = 1;
		for (int T = 0; T <= 5000; T++) {
			if (ok(i, T)) {
				cout << T << '\n';
				cant = 0;
				break;
			}
		}
		if (cant) cout << "-1\n";
	}
	return 0;
}