#include <bits/stdc++.h>
#define fi first
#define se second
#define pb push_back

using namespace std;
typedef  long long ll;

const long long testing = 0;
void open_file() {
    if (testing) {
        freopen("C:\\Users\\roi\\CLionProjects\\untitled2\\input.txt", "r", stdin);
        freopen("C:\\Users\\roi\\CLionProjects\\untitled2\\output.txt", "w", stdout);
    } else {
        freopen("sequence.in", "r", stdin);
        freopen("sequence.out", "w", stdout);
    }
}

struct node {
    node *l, *r;
    int size, y;
    ll x;
    bool d;
    node (ll key) : x(key), l(NULL), r(NULL), y(rand()), d(0), size(1) {}
};

void push(node * t) {
    if (!t || !t->d) return;
    if (t->l) {
        t->l->d = !t->l->d;
    }
    if (t->r) {
        t->r->d = !t->r->d;
    }
    swap(t->l, t->r);
    t->d = 0;
}

int getsize(node * t) {
    return t ? t->size : 0;
}

void recalc(node * t) {
    if (!t) {
        return;
    }
    t->size = getsize(t->l) + getsize(t->r) + 1;
}

node ** split(node * t, int x) {
    if (!t) {
        return new node * [2] { NULL, NULL };
    }
    node ** res;
    push(t);
    int sizeleft = getsize(t->l);
    if (x <= sizeleft) {
        res = split(t->l, x);
        t->l = res[1];
        res[1] = t;
    } else {
        res = split(t->r, x - sizeleft - 1);
        t->r = res[0];
        res[0] = t;
    }
    recalc(res[0]);
    recalc(res[1]);
    return res;
}

node * merge(node * l, node * r) {
    if (!l || !r) return l ? l : r;
    push(l); push(r);
    node * res;
    if (l->y > r->y) {
        l->r = merge(l->r, r);
        res = l;
    } else {
        r->l = merge(l, r->l);
        res = r;
    }
    recalc(res);
    return res;
}

node * add(node * t, node * p, int id) {
    if (!t) {
        t = p;
        recalc(t);
        return t;
    }
    auto k = split(t, id);
    p = merge(k[0], p);
    p = merge(p, k[1]);
    t = p;
    recalc(t);
    return t;
}

void out(node * t) {
    if (!t) return;
    push(t);
    out(t->l);
    cout << t->x << ' ';
    out(t->r);
}

int main() {
    open_file();
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    node * t = NULL;
    ll x;
    int i = 0;
    while (cin >> x) {
        t = add(t, new node(x), i);
        i++;
    }
    t->d = 1;
    out(t);
    return 0;
}