#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <cassert>
#include <algorithm>
#include <cmath>

using namespace std;
int n;
int a[510];
int res;
vector <int> nks;

bool lower(int b, int l, int r) {
	int prev = (a[l] & (1 << b));
	for (int i = l + 1; i < r; i++) {
		if (prev > (a[i] & (1 << b))) return false; else prev = (a[i] & (1 << b));
	}
	for (int i = l + 1; i < r; i++) {
		if ((a[i] & (1 << b)) != (a[i - 1] & (1 << b))) nks.push_back(i);
	}
}

bool higher(int b, int l, int r) {
	int prev = (a[l] & (1 << b));
	for (int i = l + 1; i < r; i++) {
		if (prev < (a[i] & (1 << b))) return false; else prev = (a[i] & (1 << b));
	}
	for (int i = l + 1; i < r; i++) {
		if ((a[i] & (1 << b)) != (a[i - 1] & (1 << b))) nks.push_back(i);
	}
}

bool eq(int b, int l, int r) {
	int prev = (a[l] & (1 << b));
	for (int i = l + 1; i < r; i++) {
		if (prev != (a[i] & (1 << b))) return false;
	}
	return true;
}

void solve() {
	res = 0;
	vector <int> ks = { 0, n };
	for (int i = 30; i >= 0; i--) {
		nks.clear();
		int ts[2] = { 0, 0 };
		for (int j = 0; j < ks.size() - 1; j++) {
			if (eq(i, ks[j], ks[j + 1])) continue;
			if (lower(i, ks[j], ks[j + 1])) ts[0]++; else if (higher(i, ks[j], ks[j + 1])) ts[1]++; else {
				res = -1;
				return;
			}
		}
		for (int j : ks) nks.push_back(j);
		sort(nks.begin(), nks.end());
		int sz = unique(nks.begin(), nks.end()) - nks.begin();
		nks.resize(sz);
		if (ts[1] && !ts[0]) res += (1 << i);
		if (ts[0] && ts[1]) {
			res = -1;
			return;
		}
		ks = nks;
	}
	vector <int> na;
	for (int i = 0; i < n; i++) na.push_back(a[i] ^ res);
	//assert(is_sorted(na.begin(), na.end()));
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	solve();
	cout << res << '\n';
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int pos, val;
		cin >> pos >> val;
		a[pos - 1] = val;
		solve();
		cout << res << '\n';
	}
}