#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <bitset>
#include <utility>
#include <iterator>
#include <sstream>
#include <fstream>

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define mp make_pair

#define TASK ""
#define SEED 322

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9;
const ll LINF = 3e18;
const int MOD = 1e9 + 7;
const double PI = acos(-1.0);
const double EPS = 1e-8;

//SAY HELLO TO MY LIL' FRIEND

int n, q;
vector<int> a;

int bit(int mask, int id) {
	return ((mask >> id) & 1);
}

int find_power(int x, int y, int b) {
	x ^= b;
	y ^= b;
	if (x <= y) 
		return 0;

	for (int i = 29; i >= 0; i--) {
		if (bit(x, i) && !bit(y, i)) {
			return (1 << i);
		}
	}
}

void find_b() {
	int b = 0;
	for (int i = 1; i < n; i++) {
		b += find_power(a[i - 1], a[i], b);
	}

	bool flag = true;
	for (int i = 1; i < n; i++) {
		if ((a[i - 1] ^ b) >(a[i] ^ b)) {
			flag = false;
			break;
		}
	}

	if (flag)
		cout << b << '\n';
	else
		cout << "-1\n";
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif
	//srand(SEED);

	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	cin >> q;
	
	find_b();
	for (int i = 0; i < q; i++) {
		int p, x;
		cin >> p >> x;
		p--;

		a[p] = x;
		find_b();
	}

	return 0;
}