#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <deque>
#include <list>
#include <bitset>
#include <utility>
#include <iterator>
#include <fstream>
#include <sstream>

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define mp make_pair

#define TASK "storage"
#define SEED 322

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9;
const ll LINF = 3e18;
const int MOD = 1e9 + 7;
const double PI = acos(-1.0);
const double EPS = 1e-8;

//oh boi oh boi what's that

bool sign(char c) {
	return c == '+';
}

void solve() {
	string a, b;
	cin >> a >> b;

	vector<int> gr;
	vector<bool> as, bs;

	gr.push_back(0);
	as.push_back(!sign(a[0]));
	bs.push_back(!sign(a[0]));
	for (int i = 0; i < a.size(); i++) {
		if (i == 0) {
			gr.push_back(1);
			as.push_back(sign(a[i]));
			bs.push_back(sign(b[i]));
		}
		else {
			if (a[i] == a[i - 1]) {
				if (b[i] != b[i - 1]) {
					cout << "No\n";
					return;
				}
				else {
					gr.back()++;
				}
			}
			else {
				gr.push_back(1);
				as.push_back(sign(a[i]));
				bs.push_back(sign(b[i]));
			}
		}
	}
	gr.push_back(0);
	as.push_back(!sign(a.back()));
	bs.push_back(!sign(a.back()));

	int n = gr.size() - 2;

	bool flag = false;
	for (int i = 1; i <= n; i++) {
		if (as[i] != bs[i]) {
			flag = true;
			if (gr[i] < gr[i - 1] || gr[i] < gr[i + 1]) {
				flag = false;
				as[i] = bs[i];
				int val = gr[i - 1] + gr[i] + gr[i + 1];
				
				int p = i;
				while (p > 1 && as[p - 1] == as[p])
					p--;
				gr[p++] = val;
				while (p < n && as[p] == as[p - 1]) {
					gr[p++] = val;
				}
				i = 0;
			}
		}
	}

	if (flag) {
		cout << "No\n";
	}
	else {
		cout << "Yes\n";
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	//srand(SEED);

	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;

	for (int i = 0; i < t; i++) {
		solve();
	}

	return 0;
}