#include <bits/stdc++.h>

typedef long long ll;
typedef double ld;

using namespace std;

bool ask(int l, int r)
{
    cout << "? " << l << " " << r << endl;
    string s;
    cin >> s;
    return s == "Yes";
}

vector<int> used, ans;
vector<pair<int, int>> last, last1;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    used.assign(n + 1, 0);
    ans.assign(n + 1, 0);
    int q = 0, timer = 0;
    for (int i = 1; i < n; i++)
    {
        if (!used[i])
        {
            bool ok = ask(i, i + 1);
            if (ok)
            {
                used[i] = 1;
                used[i + 1] = 1;
                ans[i] = 1;
                ans[i + 1] = 2;
                q += 2;
                last.push_back({i, i + 1});
            }
        }
    }
    while (q < n)
    {
        timer++;
        last1.clear();
        for (auto it : last)
        {
            int i = it.first, j = it.second;
            while (i > 0 && used[i])
                i--;
            if (i == 0)
                continue;
            while (j <= n && used[j])
                j++;
            if (j > n)
                continue;
            bool ok = ask(i, j);
            if (ok)
            {
                used[i] = 1;
                used[j] = 1;
                ans[i] = 1;
                ans[j] = 2;
                last1.push_back({i, j});
                q += 2;
            }
        }
        last = last1;
    }
    cout << "! ";
    for (int i = 1; i <= n; i++)
        cout << (ans[i] == 1 ? "(" : ")");
    cout << endl;
    return 0;
}
