#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstdlib>
#include <stack>
using namespace std;
#define forn(a, b) for (int i = a; i < b; ++i)
#define fore(i, a, b) for (int i = a; i < b; ++i)
#define all(a) a.begin(), a.end()
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define x first
#define y second
#define INF 2000000000
typedef long long ll;
typedef long double ld;
struct seg {
    int l, r;
    seg() {}
    seg(int _l, int _r) {
        l = _l;
        r = _r;
    }
};
bool check(const seg &a, const seg &b) {
    if ((a.l == -INF && a.r == -INF) || (b.l == -INF && b.r == -INF))
        return false;
    else
        return (a.l <= b.l && b.l <= a.r) || (a.l <= b.r && b.r <= a.r) || (b.l <= a.l && a.l <= b.r) || (b.l <= a.r && a.r <= b.r);
}
seg operator & (const seg &a, const seg &b) {
    if (check(a, b))
        return seg(max(a.l, b.l), min(a.r, b.r));
    else
        return seg(-INF, -INF);
}
seg pref[200000];
seg suff[200000];
int timeout[200000];
seg way[200000];
void solve() {
    int n;
    cin >> n;
    forn (0, n)
        cin >> timeout[i];
    forn (0, n - 1)
        cin >> way[i].l >> way[i].r;
    if (n == 1) {
        cout << 0;
        return;
    }
    pref[0] = seg(-INF, INF);
    suff[n - 1] = seg(-INF, INF);
    pref[1].l = way[0].l - timeout[1];
    pref[1].r = way[0].r;
    forn (2, n) {
        if (!check(way[i - 1], pref[i - 1]))
            pref[i] = seg(-INF, -INF);
        else
            pref[i] = seg(way[i - 1].l - timeout[i], way[i - 1].r) & pref[i - 1];

    }
    suff[n - 2] = seg(way[n - 2].l - timeout[n - 2], way[n - 2].r);
    for (int i = n - 3; i >= 0; --i)
        suff[i] = suff[i + 1] & seg(way[i].l - timeout[i], way[i].r);
    forn (0, n)
        cout << ((suff[i] & pref[i]).l == -INF ? -1 : max(0, (suff[i] & pref[i]).l)) << endl;

    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    return 0;
}
/*
4
1 0 3 2
4 6
5 5
7 10
*/
