#include <bits/stdc++.h>
using namespace std;
typedef long double ld;
//#define int long long

struct point { int x, y; };

const ld eps = 1e-7;
const int N = 500;
int n, q, cnt, f[N][N][N], flag;
point p[N];
string res;

point vc(point a, point b) { return {b.x - a.x, b.y - a.y}; }
int vect(point a, point b) { return a.x * b.y - a.y * b.x; }
int scal(point a, point b) { return a.x * b.x + a.y * b.y; }

int belong(int a, int b, int c, int i) {
    if (i == a || i == b || i == c) return 0;
    ld ans = 0;
    point P = p[i], A = p[a], B = p[b], C = p[c];
    point PA = vc(P, A), PB = vc(P, B), PC = vc(P, C);
    int f1 = 1, f2 = 1;
    int v1 = vect(PA, PB), v2 = vect(PB, PC), v3 = vect(PC, PA);
    if (v1 > 0 && v2 > 0 && v3 > 0) return 1;
    if (v1 < 0 && v2 < 0 && v3 < 0) return 1;
    return 0;
}

get(int a, int b, int c) {
    for (int i = 0; i < n; ++i)
        if (belong(a, b, c, i))
            return 0;
    return 1;
}

int32_t main() {
    scanf("%lld", &n);
    vector <int> perm(n);
    for (int i = 0; i < n; ++i)
        perm[i] = i;
    for (int i = 0; i < n; ++i)
        scanf("%lld%lld", &p[i].x, &p[i].y);
    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j)
            for (int k = j + 1; k < n; ++k)
                f[i][j][k] = get(i, j, k);
    scanf("%lld", &q);
    random_shuffle(perm.begin(), perm.end());
    while (q--) {
        flag = 1;
        cnt = 0;
        if (rand() % 3 == 0) random_shuffle(perm.begin(), perm.end());
        for (int ii = 0; ii < n && flag; ++ii)
            for (int jj = ii + 1; jj < n && flag; ++jj)
                for (int kk = jj + 1; kk < n && flag; ++kk) {
                    int i = perm[ii], j = perm[jj], k = perm[kk];
                    if (!f[i][j][k]) continue;
                    printf("? 3 %lld %lld %lld\n", i + 1ll, j + 1ll, k + 1ll);
                    fflush(stdout);
                    cin >> res;
                    cnt++;
                    if (res == "Yes") {
                        printf("! 3 %lld %lld %lld\n", i + 1ll, j + 1ll, k + 1ll);
                        fflush(stdout);
                        flag = 0;
                    }
                }
    }
    return 0;
}
