#include <bits/stdc++.h>

using namespace std;

long long mn[(int)8e6 + 10];
int l[300], r[300], c[300];

void init(int v, int l, int r)
{
    mn[v] = 0;
    if (r - l > 1)
    {
        int m = (l + r) / 2;
        init(2 * v + 1, l, m);
        init(2 * v + 2, m, r);
    }
}

void ins(int v, int l, int r, int q, long long a)
{
    if (r - l == 1)
    {
        mn[v] = a;
        return;
    }
    int m = (l + r) / 2;
    if (q < m)
        ins(2 * v + 1, l, m, q, a);
    else
        ins(2 * v + 2, m, r, q, a);
    mn[v] = min(mn[2 * v + 1], mn[2 * v + 2]);
}

long long get(int v, int l, int r, int q, int w)
{
    if (l >= w || r <= q)
        return (long long)1e18;
    if (q <= l && r <= w)
        return mn[v];
    int m = (l + r) / 2;
    return min(get(2 * v + 1, l, m, q, w), get(2 * v + 2, m, r, q, w));
}

vector<long long> v1[101], v2[101], m1[101], m2[101];
long long dp[(int)2e6 + 10];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, a;
    cin >> n >> a;
    long long sl = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> l[i] >> r[i] >> c[i];
        sl += r[i] - l[i] + 1;
    }
    if (sl > (long long)1e5 * 65)
    {
        init(0, 0, a + 1);
        for (int i = a; i >= 0; i--)
        {
            long long s = i * ((long long)1e9);
            for (int j = 0; j < n; j++)
            {
                if (i + r[j] <= a)
                    s = max(s, get(0, 0, a + 1, i + l[j], i + r[j] + 1) - c[j]);
            }
            ins(0, 0, a + 1, i, s);
        }
        cout << get(0, 0, a + 1, 0, 1) << endl;
    }
    else
    {
        long long mx = (long long)1e18;
        for (int i = 0; i < n; i++)
        {
            v1[i].push_back(mx);
            v2[i].push_back(mx);
            m1[i].push_back(mx);
            m2[i].push_back(mx);
        }
        for (int i = 0; i <= a; i++)
            dp[i] = (long long)1e9 * i;
        for (int i = a - 1; i >= 0; i--)
        {
            for (int j = 0; j < n; j++)
            {
                if (i + r[j] <= a)
                {
                    if (i + r[j] == a)
                    {
                        for (int q = a; q > a - (r[j] - l[j] + 1); q--)
                        {
                            v1[j].push_back(dp[q]);
                            m1[j].push_back(min(dp[q], m1[j][m1[j].size() - 1]));
                        }
                    }
                    else
                    {
                        if (v2[j].size() == 1)
                        {
                            while (v1[j].size() > 1)
                            {
                                long long a = v1[j][v1[j].size() - 1];
                                v1[j].pop_back();
                                m1[j].pop_back();
                                v2[j].push_back(a);
                                m2[j].push_back(min(a, m2[j][m2[j].size() - 1]));
                            }
                        }
                        m2[j].pop_back();
                        v2[j].pop_back();
                        v1[j].push_back(dp[i + l[j]]);
                        m1[j].push_back(min(dp[i + l[j]], m1[j][m1[j].size() - 1]));
                    }
                    dp[i] = max(dp[i], min(m1[j][m1[j].size() - 1], m2[j][m2[j].size() - 1]) - c[j]);
                }
            }
        }
        cout << dp[0] << endl;
    }
    return 0;
}
