#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define int int64_t
#define fi first
#define se second
#define mp make_pair

istream & operator >> (istream & in, vector <int> & arr)
{
    for (int i = 0; i < arr.size(); ++i)
        in >> arr[i];
    return in;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector <int> a(n);
    vector <int> x(n);
    cin >> a >> x;
    vector <int> b(m);
    vector <int> y(m);
    cin >> b >> y;

    vector <int> prefa(n + 1);
    prefa[0] = 0;
    for (int i = 1; i <= n; ++i)
        prefa[i] = prefa[i - 1] + x[i - 1];

    vector <int> prefb(m + 1);
    prefb[0] = 0;
    for (int i = 1; i <= m; ++i)
        prefb[i] = prefb[i - 1] + y[i - 1];

    int ans = 0;
    int la = 0, ra = 0, lb = 0, rb = 0;

    for (int i = 0; i < n; ++i)
    {
        vector <bool> used(n + m + 1, false);
        for (int j = i; j < n; ++j)
        {
            if (used[a[j]])
                break;
            used[a[j]] = true;
            vector <bool> arr(m, true);
            for (int k = 0; k < m; ++k)
            {
                if (used[b[k]])
                    arr[k] = false;
            }
            int sum1 = prefa[j + 1] - prefa[i];
            if (sum1 > ans)
            {
                ans = sum1;
                la = i + 1;
                ra = j + 1;
                lb = 0;
                rb = 0;
            }
            for (int k = 0; k < m; ++k)
            {
                if (!arr[k])
                    continue;
                int kk = k;
                while (kk < m && arr[kk])
                    ++kk;
                int sum2 = prefb[kk] - prefb[k];
                if (sum1 + sum2 > ans)
                {
                    ans = sum1 + sum2;
                    la = i + 1;
                    ra = j + 1;
                    lb = k + 1;
                    rb = kk;
                }
                k = kk;
            }
        }
    }
    for (int i = 0; i < m; ++i)
    {
        vector <bool> used(n + m + 1, false);
        for (int j = 0; j < m; ++j)
        {
            if (used[b[j]])
                break;
            used[b[j]] = true;
            int sum = prefb[j + 1] - prefb[i];
            if (sum > ans)
            {
                ans = sum;
                la = 0;
                ra = 0;
                lb = i + 1;
                rb = j + 1;
            }
        }
    }
    cout << ans << " " << la << " " << ra << " " << lb << " " << rb << endl;
    return 0;
}
