#include <algorithm>
#include <iostream>
#include <vector>

using ll = long long;

struct kek {
	ll l;
	ll r;
	ll c;
};

bool Compare(kek a, kek b) {
	return 1000000000 * a.l - a.c > 1000000000 * b.l - b.c;
}

int main() {
	ll n = 0, a = 0;
	std::cin >> n >> a;
	if (n == 1) {
		ll l = 0, r = 0, c = 0;
		std::cin >> l >> r >> c;
		ll t = (a - r + 1) % l, k = (a - r + 1) / l;
		if (k * (r - l) >= t) {
			std::cout << 1000000000 * (a - r + 1) - k * c << '\n';
		}
		else {
			std::cout << 1000000000 * (k + 1) * l - (k + 1) * c << '\n';
		}
	}
	else {
		int x = 0, y = 0;
		std::vector< kek > op(n);
		for (int i = 0; i < n; ++i) {
			std::cin >> op[i].l >> op[i].r >> op[i].c;
		}
		std::sort(op.begin(), op.end(), Compare);
		for (int i = 0; i < n; ++i) {
			while (x + op[i].l <= a) {
				x += op[i].l;
				y += op[i].c;
			}
		}
		std::cout << 1000000000 * x - y;
		
	}
	//system("pause");
	return 0;
}