#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

//void operator delete (void *) {}


const int MX = 2e3;
//vector < int > a(n), b(m), in_a(n + m, -1), in_b(n + m, -1), pa(n), pb(m);
int a[MX], b[MX], in_a[MX], in_b[MX], pa[MX], pb[MX], ra[MX], rb[MX];

int get(int *pr, int l, int r) {
	return pr[r] - (l ? pr[l - 1] : 0);
}

void del(int x, set < pair < int, int > > &cur, set < pair < int, pair < int, int > > > &sum) {
	auto j = cur.upper_bound({ x, 1e9 });
	j--;
	sum.erase(sum.find({ get(pb, j->first, j->second), *j }));
	int l = j->first, r = j->second;
	pair < int, int > n1 = { l, x - 1 }, n2 = { x + 1, r };
	if (n1.first <= n1.second) {
		sum.insert({ get(pb, l, x - 1), {l, x - 1} });
		cur.insert(n1);
	}
	if (n2.first <= n2.second) {
		sum.insert({ get(pb, x + 1, r), {x + 1, r} });
		cur.insert(n2);
	}
	cur.erase(j);
	return;
}

int main() {
	iostream::sync_with_stdio(0);

	int n, m;
	cin >> n >> m;
	memset(in_b, -1, sizeof(in_b));
	memset(in_a, -1, sizeof(in_a));
	for (int i = 0; i < n; i++) {
		int cur;
		cin >> cur;
		cur--;
		a[i] = cur;
		in_a[cur] = i;
	}
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		pa[i] = (i ? pa[i - 1] : 0) + t;
	}
	for (int i = 0; i < m; i++) {
		int cur;
		cin >> cur;
		cur--;
		b[i] = cur;
		in_b[cur] = i;
	}
	for (int i = 0; i < m; i++) {
		int t;
		cin >> t;
		pb[i] = (i ? pb[i - 1] : 0) + t;
	}
	int ans = 0;
	int a1, a2, b1, b2;
	for (int i = 0; i < n; i++) {
		set < pair < int, int > > cur;
		set < pair < int, pair < int, int > > > sum;
		cur.insert({ 0, m - 1 });
		sum.insert({ pb[m - 1], {0, m - 1} });
		for (int j = i; j < n; j++) {
			if (in_b[a[j]] != -1) {
				int x = in_b[a[j]];
				del(x, cur, sum);
			}
			if (!sum.empty()) {
				auto k = sum.end();
				k--;
				long long x = k->first + get(pa, i, j);
				if (x > ans) {
					ans = x;
					a1 = i, a2 = j;
					b1 = k->second.first, b2 = k->second.second;
				}
			}
		}
	}

	if (pa[n - 1] > ans) {
		ans = pa[n - 1];
		a1 = 0, a2 = n - 1;
		b1 = -1, b2 = -1;
	}
	if (pb[m - 1] > ans) {
		ans = pb[m - 1];
		b1 = 0, b2 = m - 1;
		a1 = -1, a2 = -1;
	}

	cout << ans << '\n';

	cout << a1 + 1 << ' ' << a2 + 1 << ' ' << b1 + 1 << ' ' << b2 + 1;

	return 0;
}