#include <iostream>
#include <iomanip>
#include <cmath>
#include <climits>
#include <utility>
#include <functional>
#include <algorithm>
#include <cstring>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <list>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <bitset>

#define forn(i,s,n) for(auto (i) = (s); (i) < (n); (i)++)
#define forb(i,s,n) for(auto (i) = (s); (i) >= (n); (i)--)
#define fora(i,a) for(auto (i) : (a))
#define foraa(i,a) for(auto & (i) : (a))
#define size(a) ((int)(a).size())
#define vec vector
#define fs first
#define sc second
#define pr pair
#define eb emplace_back

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int uint;

using namespace std;
const int N = 1000;
struct item
{
	ll v, t, c;
	item() {}
	item(ll a, ll b, ll c)
	{
		v = a;
		t = b;
		this->c = c;
	}
};
vec < item > g[N];
int main()
{
	//freopen("input.txt", "r", stdin);
	iostream::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, m;
	cin >> n >> m;
	forn(i, 0, m)
	{
		ll s, last, now, t;
		cin >> s >> now;
		forn(j, 0, s)
		{
			last = now;
			cin >> t >> now;
			g[last - 1].emplace_back(now - 1, t, i);
		}
	}
	ll d1[N];
	ll d2[N];
	int c[N];
	forn(i, 0, n)
		d1[i] = 1e8, d2[i] = -1, c[i] = -1;
	d1[0] = d2[0] = 0;
	char used[N];
	forn(i, 0, n)
		used[i] = 0;
	forn(i, 0, n)
	{
		int v = -1;
		forn(j, 0, n)
			if (!used[j] && (v == -1 || (d1[v] > d1[j] || (d1[v] == d1[j] && d2[j] > d2[v]))))
				v = j;
		if (v == -1)
			break;
		used[v] = 1;
		fora(i, g[v])
		{
			ll newc;
			if (i.c == c[v])
				newc = i.t * i.t + d2[v];
			else
				newc = i.t * i.t;
			if (d1[i.v] > d1[v] + i.t ||
				d1[i.v] == d1[v] + i.t && d2[i.v] < newc)
			{
				d1[i.v] = d1[v] + i.t;
				d2[i.v] = newc;
				used[i.v] = 0;
			}
		}
	}
	cout << d1[n - 1] << ' ' << d2[n - 1];
	return 0;
}