#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <algorithm>

using namespace std;

int main() {
    long long n, m;
    cin >> n >> m;
    vector<long long> a(n), b(m), x(n), y(m);
    for (long long i = 0; i < n; ++i)
        cin >> a[i];
    for (long long i = 0; i < n; ++i)
        cin >> x[i];
    for (long long i = 0; i < m; ++i)
        cin >> b[i];
    for (long long i = 0; i < m; ++i)
        cin >> y[i];
    long long ttl1 = 0;
    long long ttl2 = 0;
    long long ans = 0;
    long long al1, al2, ar1, ar2;
    vector<vector<set<long long>>> use1(n, vector<set<long long>> (n + 1));
    vector<vector<set<long long>>> use2(m, vector<set<long long>> (m + 1));
    for (long long l1 = 0; l1 < n; ++l1) {
        for (long long r1 = l1 + 1; r1 <= n; ++r1) {
                use1[l1][r1] = use1[l1][r1 - 1];
                use1[l1][r1].insert(a[r1 - 1]);
        }
    }
    for (long long l2 = 0; l2 < m; ++l2) {
        for (long long r2 = l2 + 1; r2 <= m; ++r2) {
                use2[l2][r2] = use2[l2][r2 - 1];
                use2[l2][r2].insert(b[r2 - 1]);
        }
    }
    for (long long l1 = 0; l1 < n; ++l1) {
        ttl1 = 0;
        for (long long r1 = l1; r1 <= n; ++r1) {
            if (r1 != l1)
                ttl1 += x[r1 - 1];
            for (long long l2 = 0; l2 < m; ++l2) {
                ttl2 = 0;
                for (long long r2 = l2; r2 <= m; ++r2) {
                    if (r2 != l2)
                        ttl2 += y[r2 - 1];
                    bool pass = true;
                    for (long long i : use1[l1][r1])
                        if (use2[l2][r2].find(i) != use2[l2][r2].end()) {
                            pass = false;
                            break;
                        }
                    if (pass) {
                        if (ttl1 + ttl2 > ans) {
                            al1 = (l1 == r1 ? l1 - 1 : l1);
                            ar1 = r1;
                            al2 = (l2 == r2 ? l2 - 1 : l2);
                            ar2 = r2;
                            ans = ttl1 + ttl2;
                        }
                    }
                    else
                        break;
                }
            }
        }
    }
    cout << ans << endl;
    cout << al1 + 1 << ' ' << ar1 << endl;
    cout << al2 + 1 << ' ' << ar2 << endl;
}

/*
7 5
3 1 4 8 6 9 2
2 7 4 10 1 5 3
9 2 11 3 8
3 5 3 4 12
*/

/*
2 3
1 2
1 4
2 3 1
17 2 15
*/

/*
3 3
4 2 1
10 1 2
5 4 2
1 2 9
*/
