#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

int sumfr[2000500];
int lfr[2000500];

int l[100], r[100], c[100];

long long INF = 1e9;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cerr.tie(0);
	int n;
	int ms;
	cin >> n >> ms;
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i] >> c[i];
	}
	for (int i = 0; i <= ms; i++) {
		for (int j = 0; j < n; j++) {
			if (r[j] + i <= ms) {
				if (lfr[i] + l[j] == lfr[i + r[j]]) {
					sumfr[i + r[j]] = min(sumfr[i] + c[j], sumfr[i + r[j]]);
				}
				if (lfr[i] + l[j] > lfr[i + r[j]]) {
					sumfr[i + r[j]] = sumfr[i] + c[j];
					lfr[i + r[j]] = lfr[i] + l[j];
				}
			}
		}
	}
	long long ans = 0;
	for (int i = 0; i <= ms; i++) {
		ans = max(ans, INF * (long long)(lfr[i]) - (long long)(sumfr[i]));
	}
	cout << ans;
}