#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <vector>
#include <random>
#include <algorithm>
#include <functional>

struct {
    int l, r, c;
} ways[101];

int main()
{
    int n, a;
    scanf("%d%d", &n, &a);
    for (int i = 0; i < n; ++i) {
        scanf("%d%d%d", &ways[i].l, &ways[i].r, &ways[i].c);
    }
    int min_r = 1<<30;
    for (int i = 0; i < n; ++i)
        min_r = std::min(min_r, ways[i].r);

    std::vector<int> min_cost(a+1, -1);
    min_cost[0] = 0;

    for (int i = 0; i <= a; ++i) if (min_cost[i] != -1)
        for (int j = 0; j < n; ++j) if (i+ways[j].r <= a)
            for (int k = ways[j].l; k <= ways[j].r; ++k)
                if (min_cost[i+k] < min_cost[i] + ways[j].c)
                    min_cost[i+k] = min_cost[i] + ways[j].c;

    for (int i = a - min_r + 1; i >= 0; --i)
        if (min_cost[i] != -1) {
            printf("%lld", int64_t(1e9)*i - min_cost[i]);
            return 0;
        }
}
