#include <iostream>
#include <vector>
#include <set>

using namespace std;
const int INF = 1000000000;

int main()
{
	int n, m;
	cin >> n >> m;
	vector<vector<pair<int, int> > > g(n);
	for (int i = 0; i < m; i++) {
		int s;
		cin >> s;
		int u, w, v;
		cin >> u >> w >> v;
		g[u - 1].push_back({ v - 1, w });
	}
	vector<pair<int, int> > dist(n, { INF, 0 });
	dist[0] = { 0, 0 };
	set<pair<int, int> > s;
	s.insert({ 0, 0 });
	while (!s.empty()) {
		int v = (*(s.begin())).second;
		s.erase(s.begin());
		for (pair<int, int> elem : g[v]) {
			int u = elem.first;
			int w = elem.second;
			if (dist[u].first > dist[v].first + w) {
				s.erase({ dist[u].first, u });
				dist[u] = { dist[v].first + w, dist[v].second + w * w };
				s.insert({ dist[u].first, u });
			}
			if (dist[u].first == dist[v].first + w && dist[u].second < dist[v].second + w * w) {
				dist[u].second = dist[v].second + w * w;
			}
		}
	}
	cout << dist[n - 1].first << ' ' << dist[n - 1].second << endl;
    return 0;
}

