#include<iostream>
#include<string>
#include<vector>
#include<stack>
#include<bitset>

using namespace std;
bitset<32> K[1000113];
bitset<32> K2[1000113];
vector<long long> D;
vector<long long> D2;

void func(int s, int v)
{
	D[v] = s;
	for (int i = 0; i < 31; i++)
		K[v][i] = 0;
	int i = 31;
	while (s != 0)
	{
		K[v][i] = s % 2;
		s /= 2;
		i--;
	}
}

long long func2(int n)
{
	long long otv = 0;
	bitset<32> q;
	for (int i = 0; i < 32; i++)
	{
		int m1 = -1, m2 = -1;
		for (int j = 0; j + 1 < n; j++)
		{
			if (K[j][i] < K[j + 1][i] && D[j] > D[j + 1])
				if (m2 == -1)
					m1 = j;
				else
					return -1;
			if (K[j][i] > K[j + 1][i] && D[j] > D[j + 1])
				if (m1 == -1)
					m2 = j;
				else
					return -1;
		}
		if (m1 != -1 && m2 != -1)
			return -1;
		if (m2 == -1)
			q[i] = 0;
		else
			q[i] = 1;
		if (q[i])
			for (int j = 0; j < n; j++)
			{
				D[j] ^= (1 << (31 - i));
				K[j][i] = (K[j][i] ^ q[i]);
			}
	}
	long long w = 1;
	for (int i = 31; i >= 0; i--)
	{
		if (q[i] == 1)
			otv += w;
		w *= 2;
	}
	return otv;
}

int main()
{
	/*ios_base::sync_with_stdio;
	cout.tie(NULL);*/
	/*cout.setf(ios::fixed);
	cout.precision(10);*/
	int n, a, b;
	cin >> n;
	D.resize(n); D2.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a;
		func(a, i);
	}
	for (int i = 0; i < n; i++)
	{
		K2[i] = K[i];
		D2[i] = D[i];
	}
	long long t = func2(n);
	if (t == -1)
	{
		cout << t << endl;
		for (int i = 0; i < n; i++)
		{
			K[i] = K2[i];
			D[i] = D2[i];
		}
	}
	else
	{
		bool tr = true;
		vector<int> e;
		for (int i = 0; i < D2.size(); i++)
			e.push_back(D2[i] ^ t);
		for (int i = 0; i + 1 < e.size(); i++)
			if (e[i] > e[i + 1])
				tr = false;
		if (tr)
			cout << t << endl;
		else
		{
			cout << -1 << endl;
			for (int i = 0; i < n; i++)
			{
				K[i] = K2[i];
				D[i] = D2[i];
			}
		}
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		cin >> a >> b;
		func(b, a - 1);
		for (int i = 0; i < n; i++)
		{
			K2[i] = K[i];
			D2[i] = D[i];
		}
		long long t = func2(n);
		if (t == -1)
		{
			cout << t << endl;
			for (int i = 0; i < n; i++)
			{
				K[i] = K2[i];
				D[i] = D2[i];
			}
		}
		else
		{
			bool tr = true;
			vector<int> e;
			for (int i = 0; i < D2.size(); i++)
				e.push_back(D2[i] ^ t);
			for (int i = 0; i + 1 < e.size(); i++)
				if (e[i] > e[i + 1])
					tr = false;
			if (tr)
				cout << t << endl;
			else
			{
				cout << -1 << endl;
				for (int i = 0; i < n; i++)
				{
					K[i] = K2[i];
					D[i] = D2[i];
				}
			}
		}
	}
}
/*
3 
0 1 4
3
2 7
3 3
1 4
*/