#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
using namespace std;
#define rep(i, n) for (int i = 0; i < n; i++)
#define repp(i, a, b) for (int i = a; i < b; i++)
#define all(v) v.begin(), v.end()
typedef long long ll;
typedef pair<int, int> pii;
int res(int l1, int r1, int l2, int r2) {
	int m1 = max(l1, l2);
	int m2 = min(r1, r2);
	if (m1 > m2) return -1;
	return m1;
}
int main() {
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	vector<int> t(n);
	rep(i, n) cin >> t[i];
	vector<int> l(n - 1), r(n - 1);
	rep(i, n - 1) cin >> l[i] >> r[i];
	vector<int> grl(n), grr(n), gll(n), glr(n);
	grr[n - 1] = 1e9;
	glr[0] = 1e9;
	for (int i = n - 2; i >= 0; i--) {
		if (grl[i + 1] == -1) {
			grl[i] = grr[i] = -1;
			continue;
		}
		if (l[i] < grl[i + 1]) grl[i] = grl[i + 1];
		else grl[i] = max(0, l[i] - t[i]);
		grr[i] = min(grr[i + 1], r[i]);
		if (grr[i + 1] < l[i] || grl[i + 1] > r[i]) grl[i] = grr[i] = -1;
		if (grr[i] < grl[i]) grr[i] = grl[i] = -1;
	}
	repp(i, 1, n) {
		if (gll[i - 1] == -1) {
			gll[i] = glr[i] = -1;
			continue;
		}
		if (l[i - 1] < gll[i - 1]) gll[i] = gll[i - 1];
		else gll[i] = max(0, l[i - 1] - t[i]);
		glr[i] = min(glr[i - 1], r[i - 1]);
		if (glr[i - 1] < l[i - 1] || gll[i - 1] > r[i - 1]) gll[i] = glr[i] = -1;
		if (glr[i] < gll[i]) glr[i] = gll[i] = -1;
	}
	vector<int> ans(n);
	rep(i, n) {
		if (i == 0) ans[i] = grl[i];
		else if (i == n - 1) ans[i] = gll[i];
		else if (gll[i] == -1 || glr[i] == -1) ans[i] = -1;
		else ans[i] = res(gll[i], glr[i], grl[i], grr[i]);
	}
	rep(i, n) cout << ans[i] << "\n";
}