#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
using namespace std;
#define rep(i, n) for (int i = 0; i < n; i++)
#define repp(i, a, b) for (int i = a; i < b; i++)
#define all(v) v.begin(), v.end()
typedef long long ll;
typedef pair<int, int> pii;
const ll prof = 1e9;
int main() {
	ios_base::sync_with_stdio(0);
	int n, a;
	cin >> n >> a;
	vector<int> l(n), r(n), cost(n);
	rep(i, n) cin >> l[i] >> r[i] >> cost[i];
	vector<int> dp(a + 1, -1);
	dp[0] = 0;
	if (n == 1) {
		repp(i, 1, a + 1) {
			repp(j, l[0], r[0] + 1) {
				if (i - j < 0 || dp[i - j] == -1) continue;
				dp[i] = max(dp[i], dp[i - j] + 1);
			}
		}
		ll ans = 1e18;
		repp(i, a + 1 - r[0], a + 1) {
			if (dp[i] == -1) continue;
			ans = min(ans, prof * i - cost[0] * dp[i]);
		}
		cout << ans;
	}
}