#include <bits/stdc++.h>
 
using std::cin;
using std::cout;
using std::cerr;
 
using std::vector;
using std::set;
using std::pair;
using std::swap;
using std::map;
using std::string;
using std::bitset;
 
using std::min;
using std::max;
using std::abs;
 
 
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
 
#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) {\
    vector<string> _v;\
    string _cur, _loc;\
    std::stringstream _ss(#as);\
    while (getline(_ss, _cur, ',')) {\
        while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
            getline(_ss, _loc, ',');\
            _cur += _loc;\
        }\
        _v.pb(_cur);\
    }\
    err(_v.begin(), as);\
}
#else
#define dbg(as...)
#endif
 
template<typename T> 
void err(vector<string>::iterator it, T a) {
    cerr << *it << " = " << a << '\n';
}
template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
    cerr << *it << " = " << a << ',';
    err(++it, as...);
}
 
struct init{
    init() {
        std::iostream::sync_with_stdio(0);
        cin.tie(0);
        cout << std::fixed << std::setprecision(10);
        cerr << std::fixed << std::setprecision(3);
        srand(300);
    }
    ~init() {
        #ifdef LOCAL
        cerr << "Time elapsed: " << (double)clock() / CLOCKS_PER_SEC << " s.\n";
        #endif
    }
} init;
 
int ask(int x) {
    cout << x << std::endl;
    int res;
    cin >> res;
    if (res == 0) exit(0);
    return res;
}
 
int main() {
     
    int n;
    cin >> n;
    int l = 0, r = n + 1;
    while (r - l > 1) {
        int m = l + r >> 1;
        if (ask(m) == 1) l = m;
        else r = m - 1;
    }
 
    ask(r);
 
    return 0;
}

// 500000000
// 1
// 750000000
// 1
// 875000000
// 1
// 937500000
// 1
// 968750000
// 1
// 984375000
// 1
// 992187500
// 1
// 996093750
// 1
// 998046875
// 1
// 999023438
// 1
// 999511719
// 1
// 999755860
// 1
// 999877930
// 1
// 999938965
// 1
// 999969483
// 1
// 999984742
// 1
// 999992371
// 1
// 999996186
// 1
// 999998093
// 1
// 999999047
// 1
// 999999524
// 1
// 999999762
// 1
// 999999881
// 1
// 999999941
// 1
// 999999971
// 1
// 999999986
// 1
// 999999993
// 1
// 999999997
// 1
// 999999999
// 1
// 1000000000
// 0


// 1000000000
// 500000000
// 1
// 750000000
// 1
// 875000000
// 1
// 937500000
// 1
// 968750000
// 1
// 984375000
// 1
// 992187500
// 1
// 996093750
// 1
// 998046875
// 1
// 999023437
// 1
// 999511718
// 1
// 999755859
// 1
// 999877929
// 1
// 999938964
// 1
// 999969482
// 1
// 999984741
// 1
// 999992370
// 1
// 999996185
// 1
// 999998092
// 1
// 999999046
// 1
// 999999523
// 1
// 999999761
// 1
// 999999880
// 1
// 999999940
// 1
// 999999970
// 1
// 999999985
// 1
// 999999992
// 1
// 999999996
// 1
// 999999998
// 1
// 999999999
// 1
// 1000000000
// 0