#include <bits/stdc++.h>

using namespace std;
typedef long long nagai;

struct v
{
	nagai x, y;
	int id;
	v(nagai x, nagai y, int id)
		: x(x), y(y), id(id)
	{}
	v(){}
	v operator -(v b) const
	{
		return v(x - b.x, y - b.y, 0);
	}
	nagai operator /(v b) const
	{
		return x * b.x + y * b.y;
	}
	nagai operator %(v b) const
	{
		return x * b.y - y * b.x;
	}
};

v zero;

bool cmp(v a, v b)
{
	a = a - zero;
	b = b - zero;
	if (a.y >= 0 && b.y < 0)
		return true;
	if (a.y <= 0 && b.y > 0)
		return false;
	if (a.y == 0 && b.y == 0)
	{
		if (a.x > 0 && b.x > 0)
			return a.x < b.x;
		else if (a.x < 0 && b.x < 0)
			return a.x > b.x;
		else
			return a.x > b.x;
	}
	return a % b > 0;
}

bool que(vector<v> arr)
{
	//TODO make query counter
	cout << "? ";
	cout << arr.size() << ' ';
	for (v x : arr)
		cout << x.id + 1 << ' ';
	cout << endl;
	cout.flush();
	string s;
	cin >> s;
	bool b = s[0] == 'Y';
//	if (b)
//		cerr << "kek" << endl;
	return b;
}

vector<v> ch(vector<v> pol)
{
	int p = 0;
	for (int i = 0; i < pol.size(); ++i)
	{
		if (pol[i].y < pol[p].y || pol[i].y == pol[p].y && pol[i].x < pol[p].x)
			p = i;
	}
	//cerr << p << endl;
	zero = pol[p];
	pol.erase(pol.begin() + p);
	sort(pol.begin(), pol.end(), cmp);
	pol.insert(pol.begin(), zero);
	vector<v> st;
	for (auto& x : pol)
	{
		while (st.size() >= 2 && (x - st[st.size() - 2]) % (st.back() - st[st.size() - 2]) >= 0)
			st.pop_back();
		st.push_back(x);
	}
	return st;
}

int main()
{
	srand(239);
	int n;
	cin >> n;
	vector<v> pol;
	for (int i = 0; i < n; ++i)
	{
		nagai x, y;
		cin >> x >> y;
		pol.push_back(v(x, y, i));
	}
	vector<v> st = ch(pol);
//	for (v x : st)
		//cerr << x.id + 1 << ' ';
	//cerr << endl;
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i)
	{
		vector<v> cur = st;
		vector<bool> good(n, true);
		vector<int> order(n);
		iota(order.begin(), order.end(), 0);
		random_shuffle(order.begin(), order.end());
		bool lst = false;
		while (true)
		{
			cur = ch(cur);
			bool f = false;
			for (int j : order)
			{
				if (!good[j])
					continue;
				auto it = lower_bound(cur.begin(), cur.end(), pol[j], cmp);
				auto v2 = *it;
				if (it == cur.begin() || it == cur.end())
				{
					good[j] = false;
					continue;
				}
				--it;
				if (it == cur.begin())
				{
					good[j] = false;
					continue;
				}
				auto v1 = *it;
				//cerr << j << endl;
//				cerr << v1.id << ' ' << j << "                               " << endl;
				if ((pol[j] - v1) % (v2 - v1) >= 0)
				{
					good[j] = false;
					continue;
				}
				vector<v> p1, p2, p3;
//				p3.push_back(cur[0]);
//				p3.push_back(pol[j]);
				for (v x : cur)
				{
					if (p3.size() || x.id == v2.id)
						p3.push_back(x);
					else
						p1.push_back(x);
				}
				p2 = {pol[j], v1, v2};
				p1.push_back(pol[j]);
				vector<v> p31;
				p31.push_back(cur[0]);
				p31.push_back(pol[j]);
				for (auto& x : p3)
					p31.push_back(x);
				p3 = p31;
//				for (v x : p3)
//					cerr << x.id << ' ';
//				cerr << endl;
				if (que(p2))
					cur = p2;
				else if (que(p1))
					cur = p1;
				else
					cur = p3;
				f = true;
				break;
			}
			if (!f)
				break;
		}
		cout << "! " << cur.size() << ' ';
		for (auto& x : cur)
			cout << x.id + 1 << ' ';
		cout << endl;
		cout.flush();
	}
}
