#include <iostream>
#include <vector>

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wsign-conversion"
using namespace std;

int main() {

    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> t(n), l(n - 1), r(n - 1);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < n - 1; i++) {
        cin >> l[i] >> r[i];
    }

    vector<pair<int, int>> left(n), right(n);
    left[0] = make_pair(0, 1000000000);
    for (int i = 1; i < n; i++) {
        if (left[i - 1].second == -1 || max(left[i - 1].first, l[i - 1]) > min(left[i - 1].second, r[i - 1])) {
            left[i] = make_pair(0, -1);
        } else {
            if (left[i - 1].first > l[i - 1]) {
                left[i] = make_pair(left[i - 1].first, min(left[i - 1].second, r[i - 1]));
            } else {
                left[i] = make_pair(max(l[i - 1] - t[i], 0), min(left[i - 1].second, r[i - 1]));
            }
        }
    }
    right[n - 1] = make_pair(0, 1000000000);
    for (int i = n - 2; i > -1; i--) {
        if (right[i + 1].second == -1 || max(right[i + 1].first, l[i]) > min(right[i + 1].second, r[i])) {
            right[i] = make_pair(0, -1);
        } else {
            if (right[i + 1].first > l[i]) {
                right[i] = make_pair(right[i + 1].first, min(right[i + 1].second, r[i]));
            } else {
                right[i] = make_pair(max(l[i] - t[i], 0), min(right[i + 1].second, r[i]));
            }
        }
    }

    for (int i = 0; i < n; i++) {
        int ll = max(left[i].first, right[i].first), rr = min(left[i].second, right[i].second);
        if (ll > rr) {
            cout << "-1\n";
        } else {
            cout << ll << '\n';
        }
    }

    return 0;

}

#pragma clang diagnostic pop