#include <iostream>
#include <vector>

#define long long long

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wsign-conversion"
using namespace std;

struct wtfcpp {
    int l, r, cost;

    wtfcpp() {}

    wtfcpp(int l, int r, int cost) : l(l), r(r), cost(cost) {}
};

int main() {

    freopen("anti.in", "r", stdin);
    freopen("anti.out", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, a;
    long COST = 1000000000L;
    cin >> n >> a;
    vector<wtfcpp> e(n);
    vector<int> res(a + 1, 0);

    for (int i = 0; i < n; i++) {
        int l, r, cost;
        cin >> l >> r >> cost;
        e[i] = wtfcpp(l, r, cost);
    }


    long ans = COST * COST;
    if (n == 1) {
        for (int i = 0; i < a; i++) {
            if (i + e[0].r <= a) {
                for (int t = e[0].l; t <= e[0].r; t++) {
                    res[i + t] = max(res[i + t], res[i] + e[0].cost);
                }
            } else {
                ans = min(ans, COST * i - res[i]);
            }
        }
    } else {
        for (int i = 0; i < a; i++) {
            int count = 0;
            for (int j = 0; j < n; j++) {
                if (i + e[j].r <= a) {
                    count++;
                    for (int t = e[j].l; t <= e[j].r; t++) {
                        res[i + t] = max(res[i + t], res[i] + e[j].cost);
                    }
                }
            }
            if (count == 0) {
                ans = min(ans, COST * i - res[i]);
            }
        }
    }

    cout << ans << '\n';

    return 0;

}

#pragma clang diagnostic pop