#include <bits/stdc++.h>
#define ll long long

using namespace std;

struct TVector {
    ll x, y;
    int num;
};

TVector operator+(TVector &a, TVector &b) {
    return {a.x + b.x, a.y + b.y};
}

TVector operator-(TVector &a, TVector &b) {
    return {a.x - b.x, a.y - b.y};
}

ll operator*(TVector a, TVector b) {
    return a.x * b.y - a.y * b.x;
}

ll operator%(TVector a, TVector b) {
    return a.x * b.x + a.y * b.y;
}

bool inTriangle(TVector A, TVector B, TVector C, TVector D) {
    TVector a = B - A;
    TVector b = C - A;
    TVector c = D - A;
    if (c * a > 0 == c * b > 0) {
        return false;
    }
    a = A - B;
    b = C - B;
    c = D - B;
    if (c * a > 0 == c * b > 0) {
        return false;
    }
    return true;
}

bool cmp1(TVector A, TVector B) {
    if (A.x == B.x) {
        return A.y < B.y;
    }
    return A.x < B.x;
}

TVector N;

bool cmp2(TVector B, TVector C) {
    TVector a = B - N;
    TVector b = C - N;
    return a * b < 0;
}

int main() {
    ll n;
    cin >> n;
    vector <TVector> points;
    vector <TVector> res_points;
    for (ll i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        points.push_back({x, y, i});
    }
    res_points = points;
    sort(points.begin(), points.end(), cmp1);
    reverse(points.begin(), points.end());
    N = points.back();
    points.pop_back();
    sort(points.begin(), points.end(), cmp2);
    vector <TVector> st;
    st.push_back(N);
    for (int i = 0; i < n - 1; i++) {
        while (st.size() > 1 && (st[st.size() - 1] - st[st.size() - 2]) * (points[i] - st[st.size() - 2]) > 0) {
            st.pop_back();
        }
        st.push_back(points[i]);
    }
    while (st.size() > 1 && (st[st.size() - 1] - st[st.size() - 2]) * (N - st[st.size() - 2]) > 0) {
        st.pop_back();
    }
    ll q;
    cin >> q;
    for (int k = 0; k < q; k++) {
        auto res_st = st;
        //cout << st.size() << endl;
        while (st.size() > 3) {
            int new_sz = (st.size() + 2) / 2;
            cout << "? " << new_sz << " ";
            for (int j = 0; j < new_sz; j++) {
                cout << st[j].num + 1 << " ";
            }
            cout << endl;
            string ans;
            cin >> ans;
            if (ans == "Yes") {
                while (st.size() != new_sz) {
                    st.pop_back();
                }
            } else {
                vector <TVector> new_st;
                for (int i = st.size() - 1; i >= new_sz - 1; i--) {
                    new_st.push_back(st[i]);
                }
                new_st.push_back(st[0]);
                st = new_st;
            }
        }
        TVector A = st[0], B = st[1], C = st[2];
        st = res_st;
        points = res_points;
        bool fl = 1;
        while (fl) {
            fl = 0;
            for (int i = 0; i < n; i++) {
                if (A.num == i) continue;
                if (B.num == i) continue;
                if (C.num == i) continue;
                if (inTriangle(A, B, C, points[i])) {
                    fl = 1;
                    int a = A.num + 1, b = B.num + 1, c = C.num + 1, d = points[i].num + 1;
                    cout << "? 3 " << a << " " << b << " " << d << endl;
                    string s;
                    cin >> s;
                    if (s == "Yes") {
                        C = points[i];
                        break;
                    }
                    cout << "? 3 " << a << " " << c << " " << d << endl;
                    cin >> s;
                    if (s == "Yes") {
                        B = points[i];
                    } else {
                        A = points[i];
                    }
                }
            }
        }
        cout << "! 3 " << A.num + 1 << " " << B.num + 1 << " " << C.num + 1 << endl;
    }
}
/*
6
3 0
0 2
2 4
4 2
5 5
6 1
4

4
0 0
4 0
2 3
2 1
*/
