#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
typedef unsigned long long ll;
const ll infinite = 1000000000000000000;

struct Experiment {
	ll l, r, c;
	Experiment(ll l = 0, ll r = 0, ll c = 0) : l(l), r(r), c(c) {};
};

Experiment exps[100];
ll n, a;

ll recur(ll t,ll c) {
	ll res = 0;
	
	for (int i = 0; i < n; i++) {
		bool flag = true;
		for (int l = exps[i].l; l <= exps[i].r; l++) {
			if (t + l > a)
				flag = false;
		}
		
		if (flag) {
			ll pres = infinite;
			for (int l = exps[i].l; l <= exps[i].r; l++) {
				pres = min(pres,recur(t + l, c + exps[i].c));
			}
			res = max(res, pres);
		}
		
	}

	return max(res, 1000000000*t - c);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	cin >> n >> a;
	for (int i = 0; i < n; i++) {
		cin >> exps[i].l >> exps[i].r >> exps[i].c;
	}
	cout << recur(0, 0);
	return 0;
}