#include <bits/stdc++.h>


using namespace std;


template<typename T1, typename T2>inline void chkmin(T1 &x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2>inline void chkmax(T1 &x, T2 y) {if (x < y) x = y;}
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
const int MAXN = 1000001;
const int INF = 1000000001;


int n;
int sons[61 * MAXN][2];
int minnum[61 * MAXN];
int maxnum[61 * MAXN];
unordered_map<int, set<int> > s;
int uk = 1;
int path[30];
int g[30];


void adds(int a, int id) {
	int an = a;
	for (int i = 0; i < 30; i++) {
		g[29 - i] = a & 1;
		a >>= 1;
	}
	int cur = 1;
	for (int i = 0; i < 30; i++) {
		path[i] = cur;
		if (sons[cur][g[i]]) {
			cur = sons[cur][g[i]];
		} else {
			uk++;
			sons[cur][g[i]] = uk;
			cur = uk;
			maxnum[uk] = -INF;
			minnum[uk] = INF;
		}
	}
	s[an].insert(id);
	chkmin(minnum[cur], id);
	chkmax(maxnum[cur], id);
	for (int i = 29; i >= 0; i--) {
		int x = path[i];
		chkmin(minnum[x], id);
		chkmax(maxnum[x], id);
	}
}


int cntneeds[30][2];
int cntbads = 0;


inline void proceed(const int &v, const int &deep, const int &t) {
	if (minnum[v] == INF) {
		return;
	}
	if (!sons[v][0] || !sons[v][1]) {
		return;
	}
	if (minnum[sons[v][0]] > minnum[sons[v][1]]) {
		cntneeds[deep][1]+= t;
		if (maxnum[sons[v][1]] != minnum[sons[v][0]] - 1) {
			cntbads+= t;
		}
	} else {
		cntneeds[deep][0]+= t;
		if (maxnum[sons[v][0]] != minnum[sons[v][1]] - 1) {
			cntbads+= t;
		}
	}
}


void dfs(int v, int deep = 0) {
	proceed(v, deep, 1);
	for (int t = 0; t < 2; t++) {
		if (sons[v][t]) {
			dfs(sons[v][t], deep + 1);
		}
	}
}


inline int calc() {
	if (cntbads) {
		return -1;
	}
	int ans = 0;
	int t = 1 << 29;
	for (int i = 0; i < 30; i++) {
		if (cntneeds[i][0] && cntneeds[i][1]) {
			return -1;
		}
		if (cntneeds[i][1]) {
			ans += t;
		}
		t >>= 1;
	}
	return ans;
}


inline void add(int a, const int &id) {
	int an = a;
	for (int i = 0; i < 30; i++) {
		g[29 - i] = a & 1;
		a >>= 1;
	}
	int cur = 1;
	for (int i = 0; i < 30; i++) {
		proceed(cur, i, -1);
		path[i] = cur;
		if (sons[cur][g[i]]) {
			cur = sons[cur][g[i]];
		} else {
			uk++;
			sons[cur][g[i]] = uk;
			cur = uk;
			maxnum[uk] = -INF;
			minnum[uk] = INF;
		}
	}
	s[an].insert(id);
	chkmin(minnum[cur], id);
	chkmax(maxnum[cur], id);
	for (int i = 29; i >= 0; i--) {
		int x = path[i];
		chkmin(minnum[x], id);
		chkmax(maxnum[x], id);
		proceed(x, i, 1);
	}
}


inline void del(int a, const int &id) {
	int an = a;
	for (int i = 0; i < 30; i++) {
		g[29 - i] = a & 1;
		a >>= 1;
	}
	int cur = 1;
	for (int i = 0; i < 30; i++) {
		proceed(cur, i, -1);
		path[i] = cur;
		cur = sons[cur][g[i]];
	}
	s[an].erase(id);
	minnum[cur] = (s[an].empty() ? INF: *s[an].begin());
	maxnum[cur] = (s[an].empty() ? -INF: *s[an].rbegin());
	for (int i = 29; i >= 0; i--) {
		int x = path[i];
		if (minnum[sons[x][g[i]]] == INF) {
			sons[x][g[i]] = 0;
		}
		minnum[x] = INF;
		maxnum[x] = -INF;
		for (int t = 0; t < 2; t++) {
			if (sons[x][t]) {
				chkmin(minnum[x], minnum[sons[x][t]]);
				chkmax(maxnum[x], maxnum[sons[x][t]]);
			}
		}
		proceed(x, i, 1);
	}
}


int a[MAXN];


int main() {
	ios_base::sync_with_stdio(false);
	cin >> n;
	//n = 1000000;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		//a[i] = (1 << 30) - i - 1;
		//cout << i + 1 << ' ' << a[i] << endl;
		adds(a[i], i + 1);
	}
	dfs(1);
	cout << calc() << '\n';
	//return 0;
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int id, num;
		cin >> id >> num;
		id--;
		if (a[id] != num) {
			del(a[id], id + 1);
			a[id] = num;
			add(a[id], id + 1);
		}	
		cout << calc() << '\n';
	}
	return 0;
}
