#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define vec vector
#define pb push_back

const ll INF = 1e18;

ll sqr(int a) { return (ll)a * a; }

int main() {
    freopen("trains.in", "r", stdin);
    freopen("trains.out", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    vec<vec<pii> > g(n);
    for (int k = 0; k < m; k++) {
        int s, v, w, u;
        cin >> s >> v >> w >> u; v--; u--;
        g[v].pb(pii(u, w));
    }

    vec<pll> dp(n, pll(INF, 0));
    vec<char> used(n);

    dp[0] = pll(0ll, 0ll);
    for (int k = 0; k < n - 1; k++) {
        int v = -1;
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                if (v == -1) { v = i; continue; }
                if (dp[v].first > dp[i].first) { v = i; }
                else if (dp[i].first == dp[v].first &&
                         dp[i].second > dp[v].second) { v = i; }
            }
        }

        used[v] = true;
        for (pii to : g[v]) {
            int u = to.first;
            if (to.second + dp[v].first == dp[u].first) {
                dp[u].second = max(dp[u].second, dp[v].second + sqr(to.second));
            }
            if (to.second + dp[v].first < dp[u].first) {
                dp[u] = pll(dp[v].first + to.second, dp[v].second + sqr(to.second));
            }
        }
    }
    cout << dp[n - 1].first << " " << dp[n - 1].second << '\n';
    return 0;
}
