#include <iostream>
#include <vector>
#include <cassert>
#include <cmath>
using namespace std;
#define INF 1791791791
//#define int long long
signed main()
{
	cin.tie();
	cout.tie();
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vector<vector<pair<int, int>>> g(n);
	for (int i = 0; i < m; ++i) {
		int x;
		cin >> x;
		assert(x == 1);
		int a, b, t;
		cin >> a >> t >> b;
		--a, --b;
		g[a].push_back({ b, t });
	}
	vector<pair<int, int>> dist(n, { INF, 0 });
	dist.front() = { 0, 0 };
	vector<bool> used(n);
	for (int i = 0; i < n; ++i) {
		int x = -1;
		for (int i = 0; i < n; ++i)
			if (!used[i] && (x == -1 || dist[i].first < dist[x].first || dist[i].first == dist[x].first && dist[i].second > dist[x].second))
				x = i;
		used[x] = true;
		auto & v1 = dist[x];
		if (v1.first < INF) {
			for (auto y : g[x]) {
				auto & v2 = dist[y.first];
				int nd1 = v1.first + y.second;
				int nd2 = v1.second + y.second * y.second;
				if (nd1 < v2.first || nd1 == v2.first && nd2 > v2.second)
					v2 = { nd1, nd2 };
			}
		}
	}
	cout << dist.back().first << ' ' << dist.back().second;
}
