#include <iostream>
#include <vector>
#include <cassert>
#include <cmath>
using namespace std;
#define INF 1791791791791791791
#define int long long
signed main()
{
	cin.tie();
	cout.tie();
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vector<vector<pair<int, int>>> g(n);
	for (int i = 0; i < m; ++i) {
		int x;
		cin >> x;
		vector<int> p(x + 1);
		vector<int> d(x);
		for (int i = 0; i < x; ++i)
			cin >> p[i] >> d[i];
		cin >> p.back();
		for (int i = 0; i < x; ++i) {
			int sum = d[i];
			for (int j = i + 1; j < x + 1; ++j) {
				g[p[i]-1].push_back({p[j]-1, sum});
				if (j < x)
					sum += d[j];
			}
		}
	}
	vector<pair<int, int>> dist(n, { INF, 0 });
	dist.front() = { 0, 0 };
	vector<bool> used(n);
	for (int i = 0; i < n; ++i) {
		int x = -1;
		for (int i = 0; i < n; ++i)
			if (!used[i] && (x == -1 || dist[i].first < dist[x].first || dist[i].first == dist[x].first && dist[i].second > dist[x].second))
				x = i;
		used[x] = true;
		auto & v1 = dist[x];
		if (v1.first < INF) {
			for (auto y : g[x]) {
				auto & v2 = dist[y.first];
				int nd1 = v1.first + y.second;
				int nd2 = v1.second + y.second * y.second;
				if (nd1 < v2.first || nd1 == v2.first && nd2 > v2.second)
					v2 = { nd1, nd2 };
			}
		}
	}
	cout << dist.back().first << ' ' << dist.back().second;
}
