#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;
#define INF 1791791791791791791

struct node {
	long long x = 0;
	int l, r;
	node *left = nullptr, *right = nullptr;
	node(int L, int R) {
		l = L;
		r = R;
		if (r - l > 1) {
			int m = (r + l) / 2;
			left = new node(l, m);
			right = new node(m, r);
		}
	}
	long long q(int L, int R) {
		if (l >= L && r <= R)
			return x;
		else if (L >= r || R <= l)
			return INF;
		else
			return min(left->q(L, R), right->q(L, R));
	}
	void u(int p, long long y) {
		if (r - l == 1)
			x = y;
		else {
			if (p < (r + l) / 2)
				left->u(p, y);
			else
				right->u(p, y);
			x = min(left->x, right->x);
		}
	}
};

void dpc(int x, vector<long long> & dp, vector<pair<pair<int, int>, int>> & a, int y, node & rmq)
{
	long long res = 0;
	for (const auto & o : a) {
		if (x + o.first.second <= y) {
			res = max(res, rmq.q(x + o.first.first, x + o.first.second + 1) - x * 1000000000ll - o.second);
		}
	}
	dp[x] += res;
}

int main()
{
	cin.tie();
	cout.tie();
	ios::sync_with_stdio(false);
	int n, x;
	cin >> n >> x;
	vector<pair<pair<int, int>, int>> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i].first.first >> a[i].first.second >> a[i].second;
	vector<long long> dp(x + 1);
	for (int i = 0; i < x; ++i)
		dp[i + 1] = dp[i] + 1000000000ll;
	node rmq(0, x + 1);
	for (int i = x; i >= 0; --i) {
		dpc(i, dp, a, x, rmq);
		rmq.u(i, dp[i]);
	}
	cout << dp[0];
}
