#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1000 + 7;
const int MAXM = 100000 + 7;
const long long INF = (long long)1e18;
pair<long long, long long> cost[MAXN][MAXN];
pair<long long, long long> dist[MAXM];
vector<int> pathes[MAXM];
int u[MAXM], v[MAXM], w[MAXM];
bool used[MAXM];
int main()
{
  freopen("trains.in", "r", stdin);
  freopen("trains.out", "w", stdout);
	int n, m = 0, p;
	scanf("%d%d", &n, &p);
	if (n >= MAXN) while(1);
	for (int i = 1; i <= p; i++)
	{
		int sz;
		scanf("%d", &sz);

    int last = 0;
    scanf("%d", &last);
		for (int j = 0; j < sz; j++)
		{
      int next, len;
			scanf("%d%d", &len, &next);
      int id = m++;
      u[id] = last;
      v[id] = next;
      w[id] = len;
      last = next;
			pathes[i].push_back(id);
		}
	}
	for (int i = 1; i <= n; i++)
	{
		dist[i] = make_pair(INF, INF);
		for (int j = 1; j <= n; j++)
		{
			cost[i][j] = make_pair(INF, INF);
		}
	}
	for (int i = 1; i <= p; i++)
	{
		for (int j = 0; j < (int)pathes[i].size(); j++)
		{
			long long sumw = 0;
			for (int k = j; k < (int)pathes[i].size(); k++)
			{
				sumw += w[pathes[i][k]];
				int from = u[pathes[i][j]], to = v[pathes[i][k]];
				cost[from][to] = min(cost[from][to], make_pair(sumw, -sumw * sumw));
			}
		}
	}
	dist[1] = make_pair(0, 0);
	for (int i = 1; i <= n; i++)
	{
		int v = 1;
		while (used[v]) v++;
		for (int j = 1; j <= n; j++)
		{
			if (!used[j] && dist[j] < dist[v]) v = j;
		}
		used[v] = true;
		for (int j = 1; j <= n; j++)
		{
			pair<long long, long long> go = dist[v];
			go.first += cost[v][j].first;
			go.second += cost[v][j].second;
			dist[j] = min(dist[j], go);
		}
	}
	if (dist[n].first == INF)
	{
		printf("-1\n");
	}
	else
	{
		printf("%lld %lld\n", dist[n].first, -dist[n].second);
	}
	return 0;
}
