/*
File name: ry_nt_dp.cpp
Tag: REJECTED
Author: pkunyavskiy
Change time: Thu Mar 30 02:24:33 MSK 2017

*/
#include <iostream>
#include <cstring>
#include <set>
#include <map>
#include <list>
#include <queue>
#include <stack>
#include <bitset>
#define _USE_MATH_DEFINES
#include <math.h>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include <assert.h>
#include <stdlib.h>
using namespace std;

void smain();
int main() {
    ios_base::sync_with_stdio(0);
#ifdef TASK
    freopen(TASK".in","rt",stdin);
    // freopen(TASK".out","wt",stdout);
    const clock_t start = clock();
#endif
    smain();
#ifdef TASK
    cerr << "\nTotal Execution Time: " << float( clock () - start ) /  CLOCKS_PER_SEC << endl;
#endif
    return 0;
}

#ifndef M_PI
#define M_PI 3.14159265358979311599796346854418516
#endif
#define forn(i,n) for (int i=0;i<n;i++)
#define rforn(i,n) for (int i=n-1;i>=0;i--)
#define int long long
#define LL long long
#define mp(a,b) make_pair(a,b)
#define MOD 1000000007
#define EPS 1E-9
#define N 100001
/* --------- END TEMPLATE CODE --------- */

int n, t[N], l[N], r[N];

void smain() {
    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);

    for (; cin >> n; ) { 
        forn(i, n) cin >> t[i];
        forn(i, n - 1) cin >> l[i] >> r[i];

        int T = 0;
        forn(i, n - 1) T = max(T, r[i]);
        
        T += 1;
        vector<vector<bool> > pref(n, vector<bool>(T));
        vector<vector<bool> > suf(n, vector<bool>(T));
        forn(i, T) pref[0][i] = 1;
        forn(i, T) suf[n-1][i] = 1;
        for (int i = 1; i < n; ++i) {
            int lo = max(l[i-1] - t[i], 0LL), hi = r[i-1];
            for (int j = hi; j >= lo; --j) {
                if (j >= l[i - 1] && j <= r[i - 1]) pref[i][j] = pref[i-1][j];
                else if (j + t[i] >= l[i - 1]) pref[i][j] = pref[i-1][l[i-1]];
            }
        }
        for (int i = n - 2; i >= 0; --i) {
            int lo = max(l[i] - t[i], 0LL), hi = r[i];
            for (int j = hi; j >= lo; --j) {
                if (j >= l[i] && j <= r[i]) suf[i][j] = suf[i+1][j];
                else if (j + t[i] >= l[i]) suf[i][j] = suf[i+1][l[i]];
            }
        }
        forn(i, n) {
            int res = -1;
            forn(j, T) if (pref[i][j] && suf[i][j]) { res = j; break; }
            cout << res << '\n';
        }
        cout << endl;
    }
}

