#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 10;

int n, t[200000];
pair<int,int> seg[200000];
pair<int,int> pref[200000], suff[200000];

inline pair<int,int> empty()
{
    return {INF, 0};
}

inline pair<int,int> full()
{
    return {0, INF};
}

inline pair<int,int> intersect(pair<int,int> a, pair<int,int> b)
{
    if(a.second < b.first || b.second < a.first) return empty();
    return {max(a.first, b.first), min(a.second, b.second)};
}

int main()
{
    //freopen("in.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n;
    for(int i = 0; i < n; i++) cin >> t[i];
    for(int i = 0; i < n - 1; i++) cin >> seg[i].first >> seg[i].second;
    pref[0] = suff[n - 1] = full();
    for(int i = 1; i < n; i++)
    {
        pref[i] = intersect({max(0, pref[i - 1].first - (i == 1 || pref[i - 1].first == seg[i - 2].first) * t[i - 1]), pref[i - 1].second}, seg[i - 1]);
    }
    for(int i = n - 2; i >= 0; i--)
    {
        suff[i] = intersect(seg[i], {max(0, suff[i + 1].first - (i == n - 2 || suff[i + 1].first == seg[i + 1].first) * t[i + 1]), suff[i + 1].second});
    }
    //for(int i = 0; i < n; i++) cout << pref[i].first << ' ' << pref[i].second << endl; return 0;
    //for(int i = 0; i < n; i++) cout << suff[i].first << ' ' << suff[i].second << endl; return 0;
    for(int i = 0; i < n; i++)
    {
        int ans = -1;
        for(int t1 = max(0, max(pref[i].first, suff[i].first) - t[i]); t1 <= min(pref[i].second, suff[i].second); t1++)
        {
            if(i > 0 && seg[i - 1].first < pref[i].first && pref[i].first > t1) continue;
            if(i < n - 1 && seg[i].first < suff[i].first && suff[i].first > t1) continue;
            ans = t1;
            break;
        }
        cout << ans << endl;
    }
}
