#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>

using namespace std;

typedef long long ll;

#define forn(i, b, n) for(ll i = b; i < n; ++i)
#define F first
#define S second
#define mp make_pair

string pcp;

void gen(ll n) {

	ll balance = 0;
	forn(i, 0, n) {
		if (balance == 0) {
			pcp.push_back('(');
			balance++;
			continue;
		}
		ll tmp = rand() % 2;
		if (balance + i >= n) continue;
		if (tmp) balance++;
		else balance--;
		if (tmp) pcp.push_back('(');
		else pcp.push_back(')');
	}
	while (balance != 0) {
		balance--;
		pcp.push_back(')');
	}
}

bool check(ll l, ll r) {
	ll balance = 0;
	forn(i, l, r) {
		if (pcp[i] == '(') balance++;
		else balance--;
		if (balance < 0) return 0;
	}
	return (balance == 0);
}


bool req(ll l, ll r) {
	cout << "? " << l + 1 << ' ' << r << '\n';
	cout.flush();
	string tmp;
	cin >> tmp;
	return (tmp == "Yes");
	/*
	return check(l, r);
	*/
}

int source() {
	ll n;
	cin >> n;
	/*
	n = 1000;
	gen(n);
	*/

	string ans;
	vector<pair<ll, string>> p;
	forn(i, 0, n - 1) {
		bool ans = req(i, i + 2);
		if (ans) p.push_back(mp(i, "()"));
		ll pos = p.size() - 1;
		bool z = 0;
		if (p[pos].F > 0 && p[pos].S.size() + p[pos].F < n) {

			z = req(p[pos].F - 1, p[pos].F + p[pos].S.size() + 1);
			if (z) {
				p[pos].second = "(" + p[pos].S + ")";
				p[pos].F--;
			}
		}
		while (z && p[pos].F >= 0 && p[pos].S.size() + p[pos].F < n) {
			z = req(p[pos].F - 1, p[pos].F + p[pos].S.size() + 1);
			if (z) {
				p[pos].second = "(" + p[pos].S + ")";
				p[pos].F--;
			}
		}
		if (p.size() > 1) {
			if (p[pos - 1].F + p[pos - 1].second.size() == p[pos].F) {
				string tmp = p[pos].second;
				p.pop_back();
				p[pos - 1].second = p[pos - 1].second + tmp;
			}
		}
	}
	/*

	if (p[0].S != pcp) {
		cout << pcp;
		exit(0);
	}
	pcp.clear();
	*/
	cout << "! " << p[0].S << '\n';
	cout.flush();
	return 0;
}

int main() {
	srand('1');	
	ios::sync_with_stdio(0);
	//while(1)
		source();
	return 0;
}