#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>
#include <string>
#include <fstream>
#include <set>

using namespace std;

int T;

vector<pair<char, int> > f(string s) {
	int l = 0, r = 0;
	vector<pair<char, int>> ans;
	ans.push_back(make_pair('&', 0));

	while (l < s.size()) {
		while (s[r] == s[l])
			r++;

		ans.push_back(make_pair(s[l], r - l));
		l = r;
	}

	ans.push_back(make_pair('%', 0));
	return ans;
}

vector<pair<char, int> > a, b;

bool stupid_solve() {
	while (a.size() != 3) {
		bool fl = 0;
		for (int i = 1; i < a.size() - 1; i++) {
			if (a[i].second < a[i - 1].second && a[i].first == '-') {
				a[i].first = '+';
			
			}
			if (a[i].second < a[i + 1].second && a[i].first == '-') {
				a[i].first = '+';
				
			}
		}

		vector<pair<char, int>> vec;

		vec.push_back(make_pair('&', 0));
		vec.push_back(a[1]);
		for (int i = 2; i < a.size() - 1; i++) {
			if (a[i].first == a[i - 1].first) {
				vec[vec.size() - 1].second += a[i].second;
				fl = 1;
				continue;
			}
			vec.push_back(a[i]);
		}
		vec.push_back(make_pair('%', 0));
		if (!fl)
			return 0;

		a = vec;
	}
	if (a[1].first != '+') {
		return 0;
	}
	return 1;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("tests.txt");
	
	cin >> T;

	for (; T > 0; T--) {
		string s, t;
		cin >> s >> t;
		a = f(s);
		b = f(t);
		cout << ((stupid_solve()) ? "Yes" : "No") << endl;
	}
	return 0;
}