#include <bits/stdc++.h>

using namespace std;

#define pb push_back

vector <int> v, pos;

const int N = 1000001;

bool was[N], bad[N];
int k, m;

int num[N];
int Rank[N];

int getset(int t){
    if (num[t] == t)
        return t;
    return num[t] = getset(num[t]);
}

void unionset(int a, int b){
    a = getset(a);
    b = getset(b);
    if (a == b)
        return;
    if (Rank[a] > Rank[b])
        swap(a, b);
    num[a] = b;
    Rank[b] += Rank[a];
}

bool check(int i){
    return i >= 0 && i < m && ((i > 0 && v[getset(i)] < v[getset(i - 1)]) || (i < m - 1 && v[getset(i)] < v[getset(i + 1)]));
}

string solve(){
    string a, b;
    cin >> a >> b;
    int n = a.size();
    int pref = 0;
    v.clear();
    pos.clear();
    for (int i = 0; i < N; i++)
        was[i] = bad[i] = false;
    for (int i = 0; i <= n; i++){
        if (i == n || (i > 0 && a[i] != a[i - 1])){
            v.pb(i - pref);
            if (a[i - 1] != b[i - 1]){
                pos.pb(v.size() - 1);
                bad[v.size() - 1] = true;
            }
            num[v.size() - 1] = v.size() - 1;
            Rank[v.size() - 1] = 1;
            pref = i;
        } else if (i > 0 && b[i] != b[i - 1])
            return "No";
    }
    k = pos.size(), m = v.size();
    /*for (int i = 0; i < m; i++)
        cout << num[i] << ' ';
    cout << endl;*/
    for (int i = 1; i < k; i++)
        if (pos[i - 1] + 1 == pos[i])
            return "No";
    /*for (int i = 0; i <  k; i++)
        cout << pos[i] << ' ';*/
    queue <int> q;
    for (auto i : pos)
        if (check(i)){
            q.push(i);
            was[i] = true;
        }
    while (!q.empty()){
        int i = q.front();
        //cout << i << endl;
        q.pop();
        k--;
        int t = v[getset(i)] + (i > 0 ? v[getset(i - 1)] : 0) + (i < m - 1 ? v[getset(i + 1)] : 0);
        if (i > 0)
            unionset(i - 1, i);
        if (i < m - 1)
            unionset(i, i + 1);
        v[getset(i)] = t;
        if (check(i - 2) && bad[i - 2] && !was[i - 2]){
            q.push(i - 2);
            was[i - 2] = true;
        }
        if (check(i + 2) && bad[i + 2] && !was[i + 2]){
            q.push(i + 2);
            was[i + 2] = true;
        }
    }
    //for (int i = 0; i < m; i++)
    //    cout << v[i] << ' ' << getset(i) << endl;
    if (k == 0)
        return "Yes";
    return "No";
}

int main()
{
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> q;
    for (; q > 0; q--)
        cout << solve() << "\n";
    return 0;
}
