#define _CRT_SECURE_NO_DEPRECATE

#include<cstring>
#include<string>
#include<vector>
#include<map>
#include<map>
#include<set>
#include<iostream>
#include<algorithm>

using namespace std;
typedef long long ll;

void solve();
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();
}

map<int, map<int, bool> > U, R;

bool zap(int l, int r) {
	string temp;
	if (!U[l][r]) {
		cout << "? " << l << ' ' << r << endl;
		cin >> temp;
		U[l][r] = true;
		R[l][r] = temp == "Yes";
		return R[l][r];
	}
	else
		return R[l][r];
}

string sol(int l, int r) {
	if (l + 3 == r) {
		if (zap(l + 1, l + 2))
			return "(())";
		else
			return "()()";
	}
	if (l + 1 == r)return "()";
	string b, e;
	while (r - 1 > l + 1) {
		if (zap(l + 1, r - 1)) {
			b.push_back('(');
			e.push_back(')');
			++l;
			--r;
		}
		else {
			for (int m = 1; m < (r - l + 1) / 2; m += 2) {
				if (zap(l, l + m)) {
					b += sol(l, l + m) + sol(l + m + 1, r);
					reverse(e.begin(), e.end());
					return b + e;
				}


				if (zap(r - m, r)) {
					b += sol(l, r - m - 1) + sol(r - m, r);
					reverse(e.begin(), e.end());
					return b + e;
				}
			}
		}
	}
	reverse(e.begin(), e.end());
	return b + "()" + e;
}
inline int sgn(ll a) { if (a < 0) return -1; if (a > 0) return 1; return 0; }
bool intriangle(pair<ll, ll> a, pair<ll, ll> b, pair<ll, ll> c, pair<ll, ll> d) {
	pair<ll, ll> AD(d.first - a.first, d.second - a.second);
	pair<ll, ll> AA(b.first - a.first, b.second - a.second);
	pair<ll, ll> BD(d.first - b.first, d.second - b.second);
	pair<ll, ll> BB(c.first - b.first, c.second - b.second);
	pair<ll, ll> CD(d.first - c.first, d.second - c.second);
	pair<ll, ll> CC(a.first - c.first, a.second - c.second);
	return sgn(AD.first * AA.second - AD.second * AA.first) == sgn(BD.first * BB.second - BD.second * BB.first) &&
		sgn(CD.first * CC.second - CD.second * CC.first) == sgn(BD.first * BB.second - BD.second * BB.first);
}

double waytosg(pair<ll, ll> a, pair<ll, ll> b, pair<ll, ll> c) {
	pair<ll, ll> CA(c.first - a.first, c.second - a.second);
	pair<ll, ll> AB(b.first - a.first, b.second - a.second);
	pair<ll, ll> CB(c.first - b.first, c.second - b.second);
	ll sc = abs(AB.first * CA.second - CA.first * AB.first);
	double rs = sc;
	rs /= sqrt(AB.first * AB.first + AB.second * AB.second);
	if (0 >= (CA.first * CA.second + AB.first * AB.second))
		return sqrt(CA.first * CA.first + CA.second * CA.second);
	if (0 <= (CB.first * CB.second + AB.first * AB.second))
		return sqrt(CA.first * CA.first + CA.second * CA.second);
	return rs;
}

string temp;
void solve() {
	int n;
	cin >> n;
	pair<int, int> p[20];
	for (int i = 0; i < n; ++i)
		cin >> p[i].first >> p[i].second;
	int q;
	cin >> q;
	if (n > 20) {
		while (q--) {
			bool loop = true;
			for (int i = 0; loop && i < n; ++i)
				for (int j = i + 1; loop && j < n; ++j){
						int k = -1;
						for (int c = 0; c < n; ++c) {
							if (c != i && c != j) {
								if (k == -1)k = c;
								else if (waytosg(p[i], p[j], p[c]) < waytosg(p[i], p[j], p[k]))
									k = c;
							}
						}
						cout << "? 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
						cin >> temp;
						if (temp == "Yes") {
							cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
							loop = false;
						}
					}
		}
		exit(0);
	}
	while (q--) {
		bool loop = true;
		for (int i = 0; loop && i < n; ++i)
			for (int j = i + 1; loop && j < n; ++j)
				for (int k = j + 1; loop && k < n; ++k) {
					bool ok = true;
					for (int c = 0; ok && c < n; ++c) {
						if (c != i && c != j && c != k && intriangle(p[i], p[j], p[k], p[c]))
							ok = false;
					}
					if (ok) {
						cout << "? 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
						cin >> temp;
						if (temp == "Yes") {
							cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
							loop = false;
						}
					}
				}
	}
	exit(0);

}

