#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <set>
#include <algorithm>
#include <math.h>
#include <map>
#define p(x,y) pair<x,y>
#define p3(x,y,z) p(p(x,y),z)
#define X first
#define Y second
#define SZ(v) (int)v.size()
using namespace std;
typedef long long ll;
typedef long double ld;
void solve();
const long long INF = (1LL << 61);
const int inf = 2e9;
int main() {
#ifdef _DEBUG
//	freopen("input.txt", "r", stdin);
#endif
	solve();
}
const int N = 65;
const int lg = 30;
int n, x, y, q, ind;
vector<p(int, int)> all;
vector<int> idx;
bool comp2(int i, int j) {
	ld alpha = atan2(all[i].Y - all[ind].Y, all[i].X - all[ind].X);
	ld beta = atan2(all[j].Y - all[ind].Y, all[j].X - all[ind].X);
	return alpha > beta;
}
inline bool cw(int i, int j, int k) {
	p(ll, ll) a = { all[j].X - all[i].X,all[j].Y - all[i].Y };
	p(ll, ll) b = { all[k].X - all[i].X,all[k].Y - all[i].Y };
	ll z = a.X * b.Y - a.Y * b.X;
	return z > 0;
}
inline bool in(int i, int j, int k, int s) {
	if (cw(s, i, j) == cw(s, j, k) && cw(s, i, j) == cw(s, k, i))
		return 1;
	return 0;
}
inline bool check(int i, int j, int k) {
	for (int I = 0; I < SZ(all); I++)if (I != i && I != j && I != k) {
		if (in(i, j, k, I))
			return 0;
	}
	return 1;
}
inline bool query(int i, int j, int k) {
	cout << "? 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
	string res;
	cin >> res;
	return (res == "Yes");
}
vector<int> perm[N];
vector<int> fi, se, th, fo;
void solve() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> x >> y;
		all.push_back({ x,y });
	}
	for (ind = 0; ind < n; ind++) {
		fi.clear();
		se.clear();
		th.clear();
		fo.clear();
		for (int i = 0; i < n; i++)if (i != ind) {
			if (all[i].X > all[ind].X)
				if (all[i].Y > all[ind].Y)
					fi.push_back(i);
				else
					fo.push_back(i);
			else
				if (all[i].Y > all[ind].Y)
					se.push_back(i);
				else
					th.push_back(i);
		}
		sort(fi.begin(), fi.end(), comp2);
		sort(se.begin(), se.end(), comp2);
		sort(th.begin(), th.end(), comp2);
		sort(fo.begin(), fo.end(), comp2);
		for (int i = 0; i < SZ(fi); i++)perm[ind].push_back(fi[i]);
		for (int i = 0; i < SZ(fo); i++)perm[ind].push_back(fo[i]);
		for (int i = 0; i < SZ(th); i++)perm[ind].push_back(th[i]);
		for (int i = 0; i < SZ(se); i++)perm[ind].push_back(se[i]);
	}
	cin >> q;
	while (q--) {
		int a = -1, b = -1, c = -1;
		for (ind = 0; ind < n && a == -1; ind++) {
			for (int j = 0; j < n - 1 && a == -1; j++) {
				int ind1 = perm[ind][j];
				int ind2 = perm[ind][(j + 1) % (n - 1)];
				if (check(ind, ind1, ind2) && query(ind, ind1, ind2)) {
					a = ind + 1;
					b = ind2 + 1;
					c = ind1 + 1;
				}
			}
		}
		cout << "! 3 " << a << " " << b << " " << c << endl;
	}
}