#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <set>
#include <algorithm>
#define p(x,y) pair<x,y>
#define p3(x,y,z) p(p(x,y),z)
#define X first
#define Y second
#define SZ(v) (int)v.size()
using namespace std;
typedef long long ll;
void solve();
const long long INF = (1LL << 61);
const int inf = 2e9;
int main() {
#ifdef _DEBUG
//	freopen("input.txt", "r", stdin);
#endif
	solve();
}
const int N = 5005;
const int lg = 30;
int n, x, y, q;
vector<p3(int, int, int)> all;
bool cw(p(int, int) i, p(int, int) j, p(int, int) k) {
	p(ll, ll) a = { j.X - i.X,j.Y - i.Y };
	p(ll, ll) b = { k.X - i.X,k.Y - i.Y };
	ll z = a.X * b.Y - a.Y * b.X;
	return z > 0;
}
bool in(p(int, int) i, p(int, int) j, p(int, int) k, p(int, int) s) {
	return (cw(s, i, j) == cw(s, j, k) && cw(s, i, j) == cw(s, k, i));
}
void build(vector<p3(int, int, int)> & a, vector<p3(int, int, int)> & del) {
	del.clear();
	vector<p3(int, int, int)> up, down;
	sort(a.begin(), a.end());
	up.push_back(a[0]);
	down.push_back(a[0]);
	for (int i = 1; i < SZ(a); i++) {
		if (i == SZ(a) - 1 || !cw(a[0].X, a[i].X, a.back().X)) {
			while (SZ(up) > 1 && !cw(up[SZ(up) - 2].X, a[i].X, up.back().X))
				del.push_back(up.back()), up.pop_back();
			up.push_back(a[i]);
		}
		if (i == SZ(a) - 1 || cw(a[0].X, a[i].X, a.back().X)) {
			while (SZ(down) > 1 && cw(down[SZ(down) - 2].X, a[i].X, down.back().X))
				del.push_back(down.back()), down.pop_back();
			down.push_back(a[i]);
		}
	}
	a.clear();
	for (int i = 0; i < SZ(up); i++)
		a.push_back(up[i]);
	for (int i = SZ(down) - 2; i > 0; i--)
		a.push_back(down[i]);
}
bool query(int i, int j, int k) {
	cout << "? 3 " << i << " " << j << " " << k << endl;
	string res;
	cin >> res;
	return (res == "Yes");
}
void solve() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> x >> y;
		all.push_back({ {x,y},i + 1 });
	}
	cin >> q;
	while (q--) {
		auto now = all;
		vector<p3(int, int, int)> del;
		while (1) {
			if (SZ(now) == 3) {
				cout << "! 3 " << now[0].Y << " " << now[1].Y << " " << now[2].Y << endl;
				break;
			}
			build(now, del);
			if (SZ(now) == 3) {
				for (int it = 0; it < 3; it++) {
					p3(int, int, int) tmp = now[0];
					now.erase(now.begin());
					del.push_back(now[1]);
					del.push_back(now[0]);
					build(del, now);
					cout << "? " << SZ(del);
					for (int i = 0; i < SZ(del); i++)cout << " " << del[i].Y;
					cout << endl;
					string res;
					cin >> res;
					if (res == "Yes") {
						while (!del.empty())now.push_back(del.back()), del.pop_back();
						break;
					}
				}
			}
			else {
				bool ans = query(now[0].Y, now[1].Y, now[2].Y);
				if (!ans) {
					now.erase(now.begin() + 1);
					while (!del.empty())now.push_back(del.back()), del.pop_back();
				}
				else {
					while (SZ(now) > 3)now.pop_back();
					while (!del.empty()) {
						if (in(now[0].X,now[1].X,now[2].X,del.back().X)) {
							now.push_back(del.back());
						}
						del.pop_back();
					}
				}
			}
		}
	}
}