#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cstring>
#include <queue>
#include <cassert>

using namespace std;
typedef long long ll;

int solve();

int main() {
#ifdef ROII
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int dd = (int)2e6 + 1;
int l[dd], r[dd], c[dd];
ll dp[dd];
ll ans;

void upd(ll &a, ll b) { if (a < b) a = b; }

int solve() {
	int n, a;
	scanf("%d %d", &n, &a);

	for (int i = 0; i < n; i++) {
		scanf("%d %d %d", &l[i], &r[i], &c[i]);
	}

	fill(dp, dp + dd, (ll)1e18);

	dp[0] = 0;
	ans = (ll)1e18;

	for (int w = 0; w <= a; w++) {
		int ok = 0;

		for (int i = 0; i < n; i++) {

			if (w + r[i] <= a) {
				ok = 1;

				for (int j = w + l[i]; j <= w + r[i]; j++) {
					dp[j] = min(dp[j], dp[w] + (j - w) * (ll)1e9 - c[i]);
				}
			}
		}

		if (!ok) {
			ans = min(ans, dp[w]);
		}
	}
	assert(ans != (ll)1e18);
	printf("%lld\n", ans);
	return 0;
}