#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cstring>
#include <queue>

using namespace std;
typedef long long ll;

int solve();

int main() {
#ifdef ROII
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int dd = (int)1e4 + 1;

int A[dd], X[dd], B[dd], Y[dd];
int P[dd + dd];

ll Q[dd];

set<pair<int, int> > S;
set<pair<ll, pair<int, int> > > T;

int solve() {

	int n, m;
	scanf("%d %d", &n, &m);

	ll s1 = 0, s2 = 0;

	for (int i = 0; i < n; i++) {
		scanf("%d", &A[i]);
		A[i]--;
	}
	for (int i = 0; i < n; i++) {
		scanf("%d", &X[i]);
		s1 += X[i];
	}

	for (int i = 0; i < m; i++) {
		scanf("%d", &B[i]);
		B[i]--;
	}
	for (int i = 0; i < m; i++) {
		scanf("%d", &Y[i]);
		s2 += Y[i];
		Q[i] = s2;
	}

	fill(P, P + n + m, -1);
	for (int i = 0; i < m; i++)
		P[B[i]] = i;

	ll ans = -1;
	int i1, j1, i2, j2;

	if (s1 > ans) {
		ans = s1;
		i1 = 0, j1 = n - 1;
		i2 = j2 = -1;
	}

	if (s2 > ans) {
		ans = s2;
		i1 = j1 = -1;
		i2 = 0, j2 = m - 1;
	}


	for (int i = 0; i < n; i++) {
		ll sum = 0;

		S.clear();
		T.clear();

		S.insert({ 0, m - 1 });
		T.insert({ s2, { 0, m - 1 } });

		for (int j = i; j < n; j++) {
			sum += X[j];
			//if (sum + s2 <= ans) continue;

			if (P[A[j]] != -1) {
				int x = P[A[j]];

				auto it = S.upper_bound(make_pair(x, m + 1));
				--it;

				int l = it->first, r = it->second;
				ll s = (Q[r] - (l ? Q[l - 1] : 0));

				T.erase({ s, { l, r } });
				S.erase(it);

				if (l < x) {
					s = Q[x - 1] - (l ? Q[l - 1] : 0);
					S.insert({ l, x - 1 });
					T.insert({ s, { l, x - 1} });
				}

				if (x < r) {
					s = Q[r] - Q[x];
					S.insert({ x + 1, r });
					T.insert({ s, { x + 1, r } });
				}

				
			}
			if (T.empty()) continue;

			if (T.rbegin()->first + sum > ans) {
				ans = T.rbegin()->first + sum;
				i1 = i, j1 = j;
				i2 = T.rbegin()->second.first, j2 = T.rbegin()->second.second;
			}
			
		}
	}
	printf("%lld\n", ans);
	printf("%d %d\n", i1 + 1, j1 + 1);
	printf("%d %d\n", i2 + 1, j2 + 1);
	return 0;
}