#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

typedef long long ll;

int n, m;
int a[2000], b[2000];
ll pref1[2000];
int x[2000], y[2000];
ll pref2[2000];

ll check(int i, const int &j, int k, const int &l) {
    unordered_set <int> used;
    ll ans = 0;

    for (i; i < j; ++i) {
        used.insert(a[i]);
        ans += x[i];
    }
    for (k; k < l; ++k) {
        if (used.find(b[k]) != used.end()) {
            return (ll)0;
        }

        ans += y[k];
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    freopen("internship.in", "r", stdin);
    freopen("internship.out", "w", stdout);
    //cin.tie(0), cout.tie(0);

    cin >> n >> m;

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
        pref1[i] = (i == 0 ? (ll)0 : pref1[i - 1]) + x[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> y[i];
        pref2[i] = (i == 0 ? (ll)0 : pref2[i - 1]) + y[i];
    }

    int ai, aj, ak, al;
    ll r, ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            for (int k = 0; k < m; ++k) {
                for (int l = k + 1; l <= m; ++l) {
                    if (pref1[j - 1] - (i == 0 ? (ll)0 : pref1[i - 1]) +
                        pref2[l - 1] - (k == 0 ? (ll)0 : pref2[k - 1]) <= ans) {

                        continue;
                    }

                    r = check(i, j, k, l);

                    if (r > ans) {
                        ans = r;
                        ai = i, aj = j, ak = k, al = l;
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            if (pref1[j - 1] - (i == 0 ? (ll)0 : pref1[i - 1]) <= ans) {
                continue;
            }

            r = check(i, j, 0, 0);

            if (r > ans) {
                ans = r;
                ai = i, aj = j, ak = -1, al = 0;
            }
        }
    }

    for (int k = 0; k < m; ++k) {
        for (int l = k + 1; l <= m; ++l) {
            if (pref2[l - 1] - (k == 0 ? (ll)0 : pref2[k - 1]) <= ans) {
                continue;
            }

            r = check(0, 0, k, l);

            if (r > ans) {
                ans = r;
                ai = -1, aj = 0, ak = k, al = l;
            }
        }
    }

    cout << ans << endl;
    cout << ai + 1 << " " << aj;
    cout << endl;
    cout << ak + 1 << " " << al;
    cout << endl;

    return 0;
}
