// 5_Collector.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const string YES = "Yes\n";
const string NO = "No\n";

const int LEN = (1e6);

int q, n, m, par[LEN], rang[LEN], numpl[LEN];
string s, t;
vector <bool> str;
vector <pair <int, bool> > pos;
//vector <pair <int, int> > mns;
vector <int> mns;
//set <pair <int, int> > mns, del;
pair <int, int> p;

int get_root(int v)
{
	if (par[v] == v)
		return v;
	par[v] = get_root(par[v]);
	return par[v];
}

void univert(int a, int b)
{
	int v = get_root(a);
	int u = get_root(b);
	if (rang[v] < rang[u])
		par[v] = u;
	else
	{
		par[u] = v;
		if (rang[u] == rang[v])
			rang[v]++;
	}
}

bool inb(int i)
{
	return (0 <= i && i < m);
}

bool eat(int mn, int pl)
{
	if (!inb(mn) || !inb(pl))
		return false;
	if (pos[mn].second)
		return false;
	return (pos[mn].first < pos[get_root(pl)].first);
}

int main()
{
	cin.tie(NULL);

	cin >> q;

	for (int w = 0; w < q; w++)
	{
		cin >> s >> t;
		n = s.length();
		bool ok = true;
		for (int i = 1; i < n; i++)
		{
			if (t[i] != t[i - 1] && s[i] == s[i - 1])
			{
				ok = false;
				break;
			}
		}
		if (!ok)
		{
			cout << NO;
			cout.flush();
			continue;
		}
		for (int i = 0; i < n;)
		{
			int cnt = 0;
			char sign = t[i];
			str.clear();
			for (; i < n && t[i] == sign; i++)
				str.push_back(s[i] == sign);
			if (i < n && t[i - 1] != s[i - 1])
			{
				ok = false;
				break;
			}
			pos.clear();
			pos.push_back(make_pair(1, str[0]));
			m = 0;
			for (int j = 1; j < str.size(); j++)
			{
				if (str[j] == str[j - 1])
					pos[m].first++;
				else
				{
					pos.push_back(make_pair(1, str[j]));
					m++;
				}
			}
			m++;
			//mns.clear();
			//del.clear();
			for (int j = 0; j < m; j++)
			{
			//	if (!pos[j].second)
			//		mns.insert(make_pair(pos[j].first, j));
				rang[j] = 0;
				par[j] = j;
			}
			//sort(mns.begin(), mns.end());
			
			//for (int j = 0; j < m; j++)

			mns.clear();
			for (int j = 0; j < m; j++)
			{
				if (!pos[j].second && (eat(j, j + 1) || eat(j, j - 1)))
					mns.push_back(j);
			}

			for (int j = 0; j < mns.size(); j++)
			{
				if (pos[mns[j]].second)
					continue;
				if (eat(mns[j], mns[j] - 1))
				{
					if (mns[j] + 1 < m)
					{
						pos[get_root(mns[j] + 1)].first += pos[get_root(mns[j] - 1)].first;
						pos[get_root(mns[j] - 1)].first = pos[get_root(mns[j] + 1)].first;
						univert(mns[j] - 1, mns[j] + 1);
					}
					pos[get_root(mns[j] - 1)].first += pos[mns[j]].first;
					pos[mns[j]].first = pos[get_root(mns[j] - 1)].first;
					univert(mns[j], mns[j] - 1);
					pos[mns[j]].second = true;
				}
				else
				{
					if (mns[j] - 1 >= 0)
					{
						pos[get_root(mns[j] + 1)].first += pos[get_root(mns[j] - 1)].first;
						pos[get_root(mns[j] - 1)].first = pos[get_root(mns[j] + 1)].first;
						univert(mns[j] - 1, mns[j] + 1);
					}
					pos[get_root(mns[j] + 1)].first += pos[mns[j]].first;
					pos[mns[j]].first = pos[get_root(mns[j] + 1)].first;
					univert(mns[j], mns[j] + 1);
					pos[mns[j]].second = true;
				}
				if (eat(mns[j] - 2, mns[j] - 1) && !eat(mns[j] - 2, mns[j] - 3))
					mns.push_back(mns[j] - 2);
				if (eat(mns[j] + 2, mns[j] + 1) && !eat(mns[j] + 2, mns[j] + 3))
					mns.push_back(mns[j] + 2);
			}

			/*while (!mns.empty())
			{
				ok = false;
				del.clear();
				while (!mns.empty())
				{
					p = (*mns.begin());
					mns.erase(p);
					if (p.second > 0 && pos[get_root(p.second - 1)].first > p.first)
					{
						if (p.second < m - 1)
						{
							pos[get_root(p.second - 1)].first += pos[get_root(p.second + 1)].first;
							pos[get_root(p.second + 1)].first = pos[get_root(p.second - 1)].first;
							univert(p.second - 1, p.second + 1);
						}
						pos[get_root(p.second - 1)].first += p.first;
						ok = true;
					}
					else if (p.second < m - 1 && pos[get_root(p.second + 1)].first > p.first)
					{
						if (p.second > 0)
						{
							pos[get_root(p.second + 1)].first += pos[get_root(p.second - 1)].first;
							pos[get_root(p.second - 1)].first = pos[get_root(p.second + 1)].first;
							univert(p.second - 1, p.second + 1);
						}
						pos[get_root(p.second + 1)].first += p.first;
						ok = true;
					}
					else
						del.insert(p);
				}
				if (!ok)
					break;
				mns = del;
			}*/
			//if (!ok)
			//	break;
			ok = true;
			for (int j = 0; j < m; j++)
			{
				if (!pos[j].second)
				{
					ok = false;
					break;
				}
			}
		}
		cout << (ok ? YES : NO);
		cout.flush();
	}
	
	return 0;
}


/*
// 5_Collector.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const string YES = "Yes\n";
const string NO = "No\n";

const int LEN = (1e6);

int q, n, m, par[LEN], rang[LEN], numpl[LEN];
string s, t;
vector <bool> str;
vector <pair <int, bool> > pos;
//vector <pair <int, int> > mns;
set <pair <int, int> > mns, del;
pair <int, int> p;

int get_root(int v)
{
if (par[v] == v)
return v;
par[v] = get_root(par[v]);
return par[v];
}

void univert(int a, int b)
{
int v = get_root(a);
int u = get_root(b);
if (rang[v] < rang[u])
par[v] = u;
else
{
par[u] = v;
if (rang[u] == rang[v])
rang[v]++;
}
}

int main()
{
cin.tie(NULL);

cin >> q;

for (int w = 0; w < q; w++)
{
cin >> s >> t;
n = s.length();
bool ok = true;
for (int i = 1; i < n; i++)
{
if (t[i] != t[i - 1] && s[i] == s[i - 1])
{
ok = false;
break;
}
}
if (!ok)
{
cout << NO;
cout.flush();
continue;
}
for (int i = 0; i < n;)
{
int cnt = 0;
char sign = t[i];
str.clear();
for (; i < n && t[i] == sign; i++)
str.push_back(s[i] == sign);
pos.clear();
pos.push_back(make_pair(1, str[0]));
m = 0;
for (int j = 1; j < str.size(); j++)
{
if (str[j] == str[j - 1])
pos[m].first++;
else
{
pos.push_back(make_pair(1, str[j]));
m++;
}
}
m++;
mns.clear();
del.clear();
for (int j = 0; j < m; j++)
{
if (!pos[j].second)
mns.insert(make_pair(pos[j].first, j));
rang[j] = 0;
par[j] = j;
}
//sort(mns.begin(), mns.end());

//for (int j = 0; j < m; j++)
while (!mns.empty())
{
ok = false;
del.clear();
while (!mns.empty())
{
p = (*mns.begin());
mns.erase(p);
if (p.second > 0 && pos[get_root(p.second - 1)].first > p.first)
{
if (p.second < m - 1)
{
pos[get_root(p.second - 1)].first += pos[get_root(p.second + 1)].first;
pos[get_root(p.second + 1)].first = pos[get_root(p.second - 1)].first;
univert(p.second - 1, p.second + 1);
}
pos[get_root(p.second - 1)].first += p.first;
ok = true;
}
else if (p.second < m - 1 && pos[get_root(p.second + 1)].first > p.first)
{
if (p.second > 0)
{
pos[get_root(p.second + 1)].first += pos[get_root(p.second - 1)].first;
pos[get_root(p.second - 1)].first = pos[get_root(p.second + 1)].first;
univert(p.second - 1, p.second + 1);
}
pos[get_root(p.second + 1)].first += p.first;
ok = true;
}
else
del.insert(p);
}
if (!ok)
{
cout << NO;
cout.flush();
break;
}
mns = del;
ok = true;
}
if (!ok)
break;
}
if (ok)
{
cout << YES;
cout.flush();
}
}

return 0;
}
*/