#include <bits/stdc++.h>

using namespace std;

#define f first
#define s second

int n;
vector<int> t, dp;
vector<pair<int, int> > av;

bool check(int start, int time)
{
    dp[start] = time;
    for (int i = start + 1; i < n; ++i){
        dp[i] = max(av[i - 1].f, dp[i - 1]);
        if (dp[i] > dp[i - 1] + t[i - 1] || dp[i] > av[i - 1].s){
            return false;
        }
    }
    for (int i = start - 1; i >= 0; --i){
        dp[i] = max(av[i].f, dp[i + 1]);
        if (dp[i] > dp[i + 1] + t[i + 1] || dp[i] > av[i].s){
            return false;
        }
    }
    return true;
}

void solve1()
{
    vector<int> ans(n, -1);
    dp.resize(n);
    for (int start = 0; start < n; ++start){
        for (int time = 0; time <= 500; ++time){
            if (check(start, time)){
                ans[start] = time;
                break;
            }
        }
    }
    for (auto i : ans){
        cout << i << '\n';
    }
}

void solve2()
{
    vector<int> ans(n, 0);
    int d[5001];
    for (int start = 0; start < n; ++start){
        //cout << start << " : ";
        d[start] = 0;
        for (int i = start + 1; i < n; ++i){
            d[i] = max(av[i - 1].f, d[i - 1]);
            if (av[i - 1].s < d[i]){
                ans[start] = -1;
                break;
            }
        }
        if (ans[start] == -1){
            continue;
        }
        for (int i = start - 1; i >= 0; --i){
            d[i] = max(av[i].f, d[i + 1]);
            if (av[i].s < d[i]){
                ans[start] = -1;
                break;
            }
        }
        /*for (int i = 0; i < n; ++i){
            cout << d[i] << ' ';
        }
        cout << endl;*/
    }
    for (auto i : ans){
        cout << i << '\n';
    }
}

void solve3()
{

}

void solve4()
{
    vector<int> ans(n, 0);
    int d[200001];
    for (auto i : ans){
        cout << i << '\n';
    }
}

int main()
{
    cin >> n;
    t.resize(n);
    av.resize(n);
    bool t5000 = true, r5000 = true, t1e9 = true;
    //vector<pair<int, int> > dp(n), dp_back(n);
    for (int i = 0; i < n; ++i){
        cin >> t[i];
        t5000 &= (t[i] == 5000);
        t1e9 &= (t[i] == 1e9);
    }
    for (int i = 0; i < n - 1; ++i){
        cin >> av[i].f >> av[i].s;
        r5000 &= (av[i].s == 5000);
    }
    if (n <= 500){
        solve1();
        return 0;
    }
    if (t5000){
        solve2();
        return 0;
    }
    if (t1e9){
        solve4();
        return 0;
    }
    if (r5000){
        //solve3();
        return 0;
    }
    return 0;
}
