#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(0);
    int n;
    cin >> n;
    vector <int> t(n);
    for (int i = 0; i < n; i++)
    {
        cin >> t[i];
    }
    vector <int> l(n), r(n);
    for (int i = 0; i < n - 1; i++)
    {
        cin >> l[i] >> r[i];
    }
    l[n - 1] = 0, r[n - 1] = 1e9;
    vector <int> suf_l(n), suf_r(n);
    vector <int> pref_l(n), pref_r(n);
    suf_l[n - 1] = 0, suf_r[n - 1] = 1e9;
    for (int i = 0; i < n - 1; i++)
    {
        suf_l[i] = max(0, l[i] - t[i]);
        suf_r[i] = r[i];
    }
    pref_l[0] = 0;
    pref_r[0] = 1e9;
    for (int i = 1; i < n; i++)
    {
        pref_l[i] = max(0, l[i - 1] - t[i]);
        pref_r[i] = r[i - 1];
    }
    for (int i = 1; i < n; i++)
    {
        pref_l[i] = max(pref_l[i], pref_l[i - 1]);
        pref_r[i] = min(pref_r[i], pref_r[i - 1]);
    }
    for (int i = n - 2; i >= 0; i--)
    {
        suf_l[i] = max(suf_l[i], suf_l[i + 1]);
        suf_r[i] = min(suf_r[i], suf_r[i + 1]);
    }
    vector <int> prekok(n);
    vector <int> sukok(n);
    vector <bool> bad(n);
    for (int i = 0; i < n; i++)
    {
        int pos = max(pref_l[i], suf_l[i]);
        for (int j = i + 1; j < n; j++)
        {
            int was = pos;
            pos = max(pos, l[j - 1]);
            if (pos > r[j - 1] || was + t[j] < pos)
            {
                bad[i] = true;
                break;
            }
        }
        pos = max(pref_l[i], suf_l[i]);
        for (int j = i - 1; j >= 0; j--)
        {
            int was = pos;
            pos = max(pos, l[j]);
            if (pos > r[j] || was + t[j] < pos)
            {
                bad[i] = true;
                break;
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        int A = max(pref_l[i], suf_l[i]);
        int B = min(pref_r[i], suf_r[i]);
        if (A <= B && !bad[i])
        {
            cout << A << '\n';
        }
        else
        {
            cout << -1 << '\n';
        }
    }
}
