#include <cstdlib>
#include <cmath>
#include <iostream>
#include <vector>
#include <cstdio>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <algorithm>

#define forn(i_, s_t, f_i) for(int i_ = s_t; i_ < f_i; i_++)
#define ff first
#define ss second
#define IN_FILE ""
#define OUT_FILE ""

using namespace std;
typedef long long ll;

const int MAXN = 5000 + 10;

struct Vec {
	int x;
	int y;
	Vec(int x=0, int y=0) : x(x), y(y) {}

	Vec operator- (const Vec &v) {
		return Vec(x - v.x, y - v.y);
	}
	/*Vec operator- () {
		return Vec(-x, -y);
	}*/
	Vec operator+ (const Vec &v) {
		return Vec(x + v.x, y + v.y);
	}


	ll operator*(const Vec &v){
		return x * (1ll) * v.x + y * (1ll) * v.y;
	}
	
	ll operator%(const Vec &v) {
		return x * (1ll) * v.y - y * (1ll) * v.x;
	}

	ll len2() {
		return x * (1ll) * x + y * (1ll) * y;
	}
};

int n = 0;
Vec v[MAXN];
int q = 0;

int sign(ll x) {
	if (x > 0) {
		return 1;
	}
	if (x < 0) {
		return -1;
	}
	return 0;
}

bool check(int x, int y, int z) {
	//cerr << x << y << z << endl;
	ll ar = (v[x] - v[y]) % (v[z] - v[y]);
	
	forn(i, 0, n) {
		if (i == x || i == y || i == z) {
			continue;
		}
		ll sm = 0;
		sm += abs((v[x] - v[i]) % (v[y] - v[i]));
		sm += abs((v[y] - v[i]) % (v[z] - v[i]));
		sm += abs((v[z] - v[i]) % (v[x] - v[i]));
		if (sm < ar) {
			return false;
		}
	}
	return true;
}

void solve() {
	forn(t, 0, q) {
		//cerr << q << endl;
		bool found = false;
		forn(i, 0, n) {
			if (found) {
				break;
			}
			forn(j, i + 1, n) {
				if (found) {
					break;
				}
				forn(w, j + 1, n) {
					if (found) {
						break;
					}
					if (!check(i, j, w)) {
						continue;
					}
					cout << "? 3 "<<i + 1 << " " << j + 1 << " " << w + 1 << "\n";
					fflush(stdout);
					string a = "";
					cin >> a;
					if (a == "Yes") {
						found = true;
						cout << "! 3 " << i + 1 << " " << j + 1 << " " << w + 1 << "\n";
						break;
					}
					else {

					}
				}
			}
		}
	}
}

int main() {
	cin >> n;
	forn(i, 0, n) {
		cin >> v[i].x >> v[i].y;
	}
	cin >> q;
	solve();
	//while(true){}
	return 0;
}