#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <string>
#include <stack>
using namespace std;

const int maxn = 200005;
const int maxt = 1000000007;

struct pr
{
    int l;
    int r;
    pr(int l,int r):l(l),r(r){}
    pr():l(-1),r(-1){}
};

pr sl[maxn];
pr vp[maxn];
pr nas[maxn];
int h[maxn];


int main()
{
    freopen("servers.in","r",stdin);
    freopen("servers.out","w",stdout);
    int n;
    cin >> n;
    for(int i = 1; i <= n; ++i)
        scanf("%d",&h[i]);
    for(int i = 1; i <= n-1; ++i)
        scanf("%d%d",&sl[i].l,&sl[i].r);
    vp[n] = pr(0,maxt);
    nas[1] = pr(0,maxt);
    for(int i = n-1; i >= 1; --i)
    {
        if(vp[i+1].r == -1)
            vp[i] = pr(-1,-1);
        else if(sl[i].l > vp[i+1].r || sl[i].r < vp[i+1].l)
            vp[i] = pr(-1,-1);
        else
        {
            if(sl[i].l < vp[i+1].l)
                vp[i].l = vp[i+1].l;
            else
                vp[i].l = max(0,sl[i].l-h[i]);
            vp[i].r = min(sl[i].r,vp[i+1].r);
        }
    }
    for(int i = 2; i <= n; ++i)
    {
        if(nas[i-1].r == -1)
            nas[i] = pr(-1,-1);
        else if(sl[i-1].l > nas[i-1].r || sl[i-1].r < nas[i-1].l)
            nas[i] = pr(-1,-1);
        else
        {
            if(sl[i-1].l < nas[i-1].l)
                nas[i].l = nas[i-1].l;
            else
                nas[i].l = max(0,sl[i-1].l-h[i]);
            nas[i].r = min(sl[i-1].r,nas[i-1].r);
        }
    }
    /*
    for(int i = 1; i <= n; ++i)
        cout << nas[i].l << ' '<< nas[i].r<< ' ';
    cout << '\n';
    for(int i = 1; i <= n; ++i)
        cout << vp[i].l << ' '<< vp[i].r<< ' ';
    cout << '\n';*/
    for(int i = 1; i <= n; ++i)
    {
        int t = 0;
        if(nas[i].r == -1 || vp[i].r == -1)
            t = -1;
        else if(nas[i].l > vp[i].r || nas[i].r < vp[i].l)
            t = -1;
        else
            t = max(vp[i].l,nas[i].l);
        printf("%d\n",t);
    }
    return 0;
}



/*
const int maxn = 1000005;
bool ism[maxn] = {0};
int dl[maxn] = {0};
int nex[maxn] = {0};
int pred[maxn] = {0};
char polog[maxn] = {0};
stack<int> men;

bool obied(int v,int yk)
{
    if(nex[v] > yk || nex[v] < 0 || nex[nex[v]] < 0)
        return false;
    if(ism[v] == ism[nex[v]])
        return false;
    if(ism[v] && dl[v] < dl[nex[v]])
        return true;
    if(!ism[v] && dl[v] > dl[nex[v]])
        return true;
    return false;
}

void obrpos(int yk)
{
    int v = men.top();
    men.pop();
    //cout << v << ' ';
    if(!obied(v,yk))
        return;
    if(ism[v])
    {
        polog[v] = polog[nex[v]];
        ism[v] = false;
        dl[v] += dl[nex[v]];
        if(pred[v] >= 0 && nex[pred[v]] == v)
        {
            dl[v] += dl[pred[v]];
            int p = pred[v];
            pred[v] = pred[pred[v]];
            nex[p] = -1;
        }
        int n = nex[v];
        nex[v] = nex[nex[v]];
        nex[n] = -1;
        if(nex[v] <= yk)
            pred[nex[v]] = v;
        if(pred[v] >= 0)
            nex[pred[v]] = v;
    }
    else
    {
        v = nex[v];
        polog[v] = polog[pred[v]];
        ism[v] = false;
        dl[v] += dl[pred[v]];
        if(nex[v] <= yk)
        {
            dl[v] += dl[nex[v]];
            int n = nex[v];
            nex[v] = nex[nex[v]];
            nex[n] = -1;
        }
        int p = pred[v];
        pred[v] = pred[pred[v]];
        nex[p] = -1;
        if(nex[v] <= yk)
            pred[nex[v]] = v;
        if(pred[v] >= 0)
            nex[pred[v]] = v;
    }
    if(obied(v,yk))
        men.push(v);
    if(pred[v] >= 0 && obied(pred[v],yk))
        men.push(pred[v]);
}
int main()
{
    freopen("storage.in","r",stdin);
    freopen("storage.out","w",stdout);
    int n;
    cin >> n;
    for(int i = 0; i < n; ++i)
    {
        string s;
        string t;
        cin >> s >> t;
        int yk = 0;
        for(int i1 = 0; i1 < s.size();++i1)
        {
            if(i1 == 0)
            {
                polog[yk] = s[i1];
                dl[yk] = 1;
                nex[yk] = yk+1;
                pred[yk] = yk-1;
            }
            else
            {
                if(s[i1] != s[i1-1])
                    ++yk;
                polog[yk] = s[i1];
                nex[yk] = yk+1;
                pred[yk] = yk-1;
                dl[yk]++;
            }
        }
        bool good = true;
        int yk2 = 0;
        for(int i1 = 0; i1 <= yk; ++i1)
        {
            ism[i1] = (s[yk2] != t[yk2]);
            for(int i2 = 1; i2 < dl[i1]; ++i2)
                if(ism[i1] != (s[yk2+i2] != t[yk2+i2]))
                    good = false;
            yk2+=dl[i1];
        }
        if(!good)
            printf("No\n");
        else
        {
            for(int i1 = 0; i1 <= yk; ++i1)
                if(obied(i1,yk))
                    men.push(i1);
            while(!men.empty())
            {
                obrpos(yk);
            }
            for(int i1 = 0; i1 <= yk; ++i1)
                if(ism[i1])
                    good = false;
            if(good)
                printf("Yes\n");
            else
                printf("No\n");
        }
        for(int i1 = 0; i1 <= yk; ++i1)
            dl[i1] = 0;
    }
    return 0;
}
*/
