#include <bits/stdc++.h>
using namespace std;

#define mp(a, b) make_pair((a), (b))
#define int int64_t

const int n = 1100;
const int INF = INT_MAX;

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    vector < vector < pair < int, int > > > gr(n);
    int a, b;
    cin >> a >> b;
    gr[0].push_back(mp(1, a));
    gr[1].push_back(mp(2, b));
    vector < vector < int > > dist(n, vector < int >(n, INF));
    for (int i = 0; i < n; ++i)
    {
        for (auto& x : gr[i])
        {
            dist[i][x.first] = x.second;
        }
    }
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            for (int k = 0; k < n; ++k)
            {
                if (dist[j][i] != INF && dist[i][k] != INF)
                {
                    dist[j][k] = min(dist[j][i] + dist[i][k], dist[j][k]);
                }
            }
        }
    }
    cout << dist[0][2] << endl;
    return 0;
};

