#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <numeric>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

int solve();

int main() {
#ifdef PoDuReM
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)5e4 + 7;

char ans[dd], cur[4];

bool ok(int l, int r) {
	printf("? %d %d\n", l + 1, r + 1);
	fflush(stdout);
	scanf("%s", cur);
	return cur[0] == 'Y';
}

int solve() {
	int n;
	scanf("%d", &n);
	vector<pair<int, int> > C;
	for (int i = 0; i < n - 1;) {
		int l = i, r = i + 1;
		while (l >= 0 && r < n && ok(l, r))
			--l, ++r;
		++l, --r;
		if (l < r) {
			for (int j = l; j <= i; ++j)
				ans[j] = '(';
			for (int j = i + 1; j <= r; ++j)
				ans[j] = ')';
			C.push_back({ l, r });
			while ((int)C.size() > 1 && C.back().first - 1 == C[(int)C.size() - 2].second) {
				C[(int)C.size() - 2].second = C.back().second;
				C.pop_back();
			}
		}
		i = r + 1;
	}
	int cnt = 0;
	for (int i = 0; i < n; ++i)
		cnt += (ans[i] != '(' && ans[i] != ')');

	while (cnt) {
		for (int i = 0; i < n;) {
			if (ans[i] == '(') {
				int ok = 0, j;
				for (j = i + 1; j < n; ++j)
					if (ans[j] != '(' && ans[j] != ')')
						break;
					else
						ok += (ans[j] != ans[j - 1]);
				if (ok == 1 || j == n) {
					i = j;
					continue;
				}

				ans[i - 1] = '(', ans[j] = ')';
				cnt -= 2;
				break;
			} else ++i;
		}
	}

	printf("! %s\n", ans);
	fflush(stdout);
	system("pause");
	return 0;
}