#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cassert>
#include <cstring>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)4e3 + 7;

int a[dd], x[dd], y[dd], b[dd], used[dd], used2[dd];
int p[dd];

int cnt;
inline bool is_tl() {
	if (++cnt == 1000) {
		cnt = 0;
		return clock() > 1.9 * CLOCKS_PER_SEC;
	}
	return false;
}

int solve() {
	int n, m;
	scanf("%d %d", &n, &m);
	for (int i = 0; i < n; ++i)
		scanf("%d", &a[i]);
	for (int i = 0; i < n; ++i)
		scanf("%d", &x[i]);
	for (int i = 0; i < m; ++i)
		scanf("%d", &b[i]);
	for (int i = 0; i < m; ++i)
		scanf("%d", &y[i]);


	ll ans = -1ll;
	int L1, R1, L2, R2;

	ll sm = 0;
	for (int i = 0; i < n; ++i)
		sm += x[i];
	if (ans <= sm) {
		ans = sm;
		L1 = 0, R1 = n - 1;
		L2 = R2 = -1;
	}
	sm = 0;
	for (int i = 0; i < m; ++i)
		sm += y[i];
	if (ans <= sm) {
		ans = sm;
		L1 = -1, R1 = -1;
		L2 = 0, R2 = m - 1;
	}

	for (int i = 0; i < n; ++i)
		p[i] = i;
	random_shuffle(p, p + n);

	for (int lol = 0; lol < n; ++lol) {
		int i = p[lol];
		memset(used, 0, sizeof(int) * (n + m + 1));
		ll sum1 = 0;
		ll mx = 0;
		int l = -1, r = -1;
		for (int j = i; j < n; ++j) {
			if (is_tl())
				return 0 * printf("%lld\n%d %d\n%d %d", ans, L1 + 1, R1 + 1, L2 + 1, R2 + 1);
			used[a[j]] = 1;
			sum1 += x[j];
			if (l == -1 || used2[a[j]]) {
				if (l != -1)
					for (int o = l; o <= r; ++o)
						used2[b[o]] = 0;
				mx = 0;
				for (int ii = 0; ii < m; ++ii) if (!used[b[ii]] && (ii == 0 || used[b[ii - 1]])) {
					ll sum2 = 0;
					int jj;
					for (jj = ii; jj < m && !used[b[jj]]; ++jj)
						sum2 += y[jj];
					if (mx < sum2) {
						mx = sum2;
						l = ii, r = jj - 1;
					}
				}
				for (int o = l; o <= r; ++o)
					used2[b[o]] = 1;
			}
			if (ans < sum1 + mx) {
				ans = sum1 + mx;
				L1 = i, R1 = j, L2 = l, R2 = r;
			}
		}
		if (l != -1)
			for (int o = l; o <= r; ++o)
				used2[b[o]] = 0;
	}

	printf("%lld\n%d %d\n%d %d", ans, L1 + 1, R1 + 1, L2 + 1, R2 + 1);
	return 0;
}