#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll maxn = 200101;
const ll inf = numeric_limits<ll>::max() / 2 - 100;
const ll nn = 1e9;
ll n, a;

struct exper {
    ll l, r, c;

    exper() {}
};

struct myqueue {
    stack<pair<ll, ll>> st[2];
    ll mydesc = 0;
    ll mysz = 0;

    void push(ll val, bool f) {
        if (st[f].empty()) st[f].push({val - (!f) * mydesc * nn, val - (!f) * mydesc * nn});
        else st[f].push({val - (!f) * mydesc * nn, min(st[f].top().second, val - (!f) * mydesc * nn)});
        if (!f)
            mydesc++, mysz++;
    }

    ll getmin() {
        ll ans = inf;
        if (!st[0].empty()) ans = st[0].top().second;
        if (!st[1].empty()) ans = min(ans, st[1].top().second);
        if (ans == inf) return 0;
        return ans + mydesc * nn;
    }

    void pop() {
        if (st[1].empty()) {
            while (!st[0].empty()) {
                ll val = st[0].top().first;
                st[0].pop();
                push(val, 1);
            }
        }
        st[1].pop();
        mysz--;
    }
};

vector<exper> vec;
vector<myqueue> exvec;
vector<ll> curl;
ll minans[maxn];

int run() {
    for (int i = 0; i < maxn; ++i) {
        minans[i] = -1;
    }
    cin >> n >> a;
    a++;
    vec.resize(n);
    exvec.resize(n);
    curl.resize(n, a);
    for (int i = 0; i < n; ++i) {
        cin >> vec[i].l >> vec[i].r >> vec[i].c;
    }
    for (int v = a - 1; v >= 0; v--) {
        for (int i = 0; i < n; ++i) {
            if (v + vec[i].r + 1 < a) {
                exvec[i].pop();
            }
            if (v + vec[i].l < a)
                exvec[i].push(minans[v + vec[i].l], 0);
        }
        ll ans = 0;
        for (int i = 0; i < n; ++i) {
            if (v + vec[i].r < a) {
                ll newans = 0;
                ll myadd = (vec[i].l - 1) * nn;
                newans = exvec[i].getmin() + myadd;
                newans -= vec[i].c;
                ans = max(ans, newans);
            }
        }
        minans[v] = ans;
        //cerr << v << " " << ans << endl;
        if (v == 0) {
            cout << ans;
        }
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    run();
    return 0;
}