#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cassert>
using namespace std;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int MAXN = 5e4 + 23;
char ans[MAXN];

bool ask(int l, int r) {
	cout << "? " << l << ' ' << r << endl;
	string s;
	cin >> s;
	return s == "Yes";
}

int solve() {
	int n;
	cin >> n;
	int l = 1, r = 2, prevl = -1;
	int L = 0;
	while (r <= n) {
		while (r <= n && !ask(l, r)) {
			l++, r++;
		}
		ans[l] = '(';
		ans[r] = ')';
		if (prevl == -1) prevl = l - 1;
		l = r + 1;
		r += 2;
		if (prevl == L) { prevl = -1; L = l - 1; continue; }
		while (r <= n && ask(l, r)) {
			ans[l] = '(';
			ans[r] = ')';
			l = r + 1;
			r += 2;
		}
		int curl = l;
		while (prevl > L && curl <= n && ask(prevl, curl)) {
			ans[prevl] = '(';
			ans[curl] = ')';
			prevl--; curl++;
		}
		if (prevl == L) L = curl - 1;
		l = curl;
		r = l + 1;
	}

	cout << "! ";
	for (int i = 1; i <= n; i++) {
		cout << ans[i];
		assert(ans[i] == '(' || ans[i] == ')');
	}
	cout << endl;
	//system("pause");
	return 0;
}