#include <iostream>
#include <stack>
#include <string>
#include <cstdlib>
#include <vector>
#include <set>
#include <cmath>

using namespace std;

typedef long long ll;
typedef pair < ll, ll > pll;

double s(pll a1, pll a2, pll a3) {
  double x1 = (double)(a1.first);
  double y1 = (double)(a1.second);
  double x2 = (double)(a2.first);
  double y2 = (double)(a2.second);
  double x3 = (double)(a3.first);
  double y3 = (double)(a3.second);

  double a = sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
  double b = sqrt((x1 - x3) * (x1 - x3) + (y1 - y3) * (y1 - y3));
  double c = sqrt((x3 - x2) * (x3 - x2) + (y3 - y2) * (y3 - y2));

  double p = (a + b + c) / 2;

  double s2 = p * (p - a) * (p - b) * (p - c);
  s2 = sqrt(s2);
  return s2;
}

int main() {
  ll n, q;
  cin >> n;
  vector < pll > pr;
  for (ll i = 0; i < n; i++) {
    pll a;
    cin >> a.first >> a.second;
    pr.push_back(a);
  }
  cin >> q;
  for (ll i = 0; i < q; i++) {
    double min_s = -1;
    ll a, b, c;
    for (ll j = 0; j < n - 2; j++) {
      for (ll k = j + 1; k < n - 1; k++) {
        for (ll o = k + 1; o < n; o++) {
          string answer;
          cout << "? 3 " << j + 1 << " " << k  + 1 << " " << o + 1 << endl;
          cin >> answer;
          if (answer[0] == 'Y') {
            double s1 = s(pr[j], pr[k], pr[o]);
            if (s1 < min_s || min_s == -1) {
              min_s = s1;
              a = j;
              b = k;
              c = o;
            }
          }
        }
      }
    }
    cout << "! 3 " << a + 1 << " " << b + 1 << " " << c + 1 << endl;
  }

  system("pause");
  return 0;
}
