#include <bits/stdc++.h>
#define x first
#define y second
#define pb push_back
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
 
using namespace std;
 
//const string FILENAME = "input";
const string FILENAME = "trains";
 
typedef pair <long long, long long> point;

int n, m;
pair <long long, long long> dist[1000001];
vector <pair <int, int>> p[1000001];
vector <int> s[1000001];
vector <int> t[1000001];

int main() {
	ios::sync_with_stdio(0);
	files(FILENAME);
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		dist[i] = {1e18, 1e18};
	}
	for (int i = 0; i < m; ++i) {
		int k = 0;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int a, b;
			cin >> a >> b;
			--a;
			p[a].pb({i, s[i].size()});
			s[i].pb(a);
			t[i].pb(b);
		}
		cin >> k;
		s[i].pb(k - 1);
	}
	dist[0] = {0, 0};
	for (int i = 0; i < n; ++i) {
		int u = -1;
		for (int j = 0; j < n; ++j) {
			if (dist[j].x != -1) {
				if (u == -1 || dist[u].x > dist[i].x) {
					u = i;
				}
			} 
		}
		if (u == (n - 1)) {
			cout << dist[u].x << ' ' << -dist[u].y << endl;
			return 0;
		}
		//cout << u + 1 << ' ' << dist[u].x << ' ' << dist[u].y << endl;
		for (auto j: p[u]) {
			long long cnt = 0;
			for (int k = j.y; (k + 1) < s[j.x].size(); ++k) {
				cnt += t[j.x][k];
				//cout << "?" << cnt << endl;
				dist[s[j.x][k + 1]] = min(dist[s[j.x][k + 1]], make_pair(dist[u].x + cnt, dist[u].y - cnt * cnt));
				//if (s[j.x][k + 1] == 4) cout << dist[u].x + cnt << '!' << -dist[u].y + cnt * cnt << endl;
			}
		}
		dist[u].x = -1;
	}
}