#include <bits/stdc++.h>
#define fi first
#define se second
#define pb push_back
#define all(x) x.begin(),x.end()

using namespace std;

typedef long long ll;

void Plus(stack< pair<int, int> > & plus1, stack< pair<int, int> > & minus1, int x) {
    int sum = x;
    while (minus1.size() && minus1.top().se == 1) {
        sum += minus1.top().fi;
        minus1.pop();
    }
    minus1.push({sum, 1});
    sum = x;
    while (plus1.size()) {
        int val = plus1.top().fi, type = plus1.top().se;
        if (type) {
            sum += val;
            plus1.pop();
        } else {
            if (sum > val) {
                sum += val;
                plus1.pop();
            } else {
                break;
            }
        }
    }
    plus1.push({sum, 1});
}


void Minus(stack< pair<int, int> > & plus1, stack< pair<int, int> > & minus1, int x) {
    int sum = x;
    while (plus1.size() && plus1.top().se == 0) {
        sum += plus1.top().fi;
        plus1.pop();
    }
    plus1.push({sum, 0});
    sum = x;
    while (minus1.size()) {
        int val = minus1.top().fi, type = minus1.top().se;
        if (!type) {
            sum += val;
            minus1.pop();
        } else {
            if (sum > val) {
                sum += val;
                minus1.pop();
            } else {
                break;
            }
        }
    }
    minus1.push({sum, 0});
}

int main() {
    int q;
    cin >> q;
    while (q--) {
        string s, t;
        cin >> s >> t;
        vector< pair<int, int> > a, b;
        int cnt = 1;
        for (int i = 1; i < s.size(); i++) {
            if (s[i] != s[i - 1]) {
                if (s[i - 1] == '-') {
                    a.pb({cnt, 0});
                    cnt = 0;
                } else {
                    a.pb({cnt, 1});
                    cnt = 0;
                }
            }
            cnt++;
        }
        if (s.back() == '+') {
            a.pb({cnt, 1});
        } else {
            a.pb({cnt, 0});
        }
        stack< pair<int, int> > plus1, minus1;
        for (int i = 0; i < a.size(); i++) {
            if (a[i].se) {
                Plus(plus1, minus1, a[i].fi);
            } else {
                Minus(plus1, minus1, a[i].fi);
            }
        }
        vector< pair<int, int> > a_plus1, a_minus1;
        while (plus1.size()) {
            a_plus1.pb(plus1.top());
            plus1.pop();
        }
        while (minus1.size()) {
            a_minus1.pb(minus1.top());
            minus1.pop();
        }
        stack< pair<int, int> > empt;
        for (int i = 0; i < a_plus1.size(); i++) {
            int sum = a_plus1[i].fi, type = a_plus1[i].se;
            if (type) {
                Plus(plus1, empt, sum);
            } else {
                plus1.push({sum, type});
            }
        }
        for (int i = 0; i < a_minus1.size(); i++) {
            int sum = a_minus1[i].fi, type = a_minus1[i].se;
            if (type) {
                minus1.push({sum, type});
            } else {
                Minus(empt, minus1, sum);
            }
        }
        vector< pair<int, int> > ans1_plus, ans1_minus;
        while (minus1.size()) {
            ans1_minus.pb(minus1.top());
            minus1.pop();
        }
        while (plus1.size()) {
            ans1_plus.pb(plus1.top());
            plus1.pop();
        }



        cnt = 1;
        for (int i = 1; i < s.size(); i++) {
            if (t[i] != t[i - 1]) {
                if (t[i - 1] == '-') {
                    b.pb({cnt, 0});
                    cnt = 0;
                } else {
                    b.pb({cnt, 1});
                    cnt = 0;
                }
            }
            cnt++;
        }
        if (t.back() == '+') {
            b.pb({cnt, 1});
        } else {
            b.pb({cnt, 0});
        }

        for (int i = 0; i < b.size(); i++) {
            if (b[i].se) {
                Plus(plus1, minus1, b[i].fi);
            } else {
                Minus(plus1, minus1, b[i].fi);
            }
        }
        vector< pair<int, int> > b_plus1, b_minus1;
        while (plus1.size()) {
            b_plus1.pb(plus1.top());
            plus1.pop();
        }
        while (minus1.size()) {
            b_minus1.pb(minus1.top());
            minus1.pop();
        }

        for (int i = 0; i < b_plus1.size(); i++) {
            int sum = b_plus1[i].fi, type = b_plus1[i].se;
            if (type) {
                Plus(plus1, empt, sum);
            } else {
                plus1.push({sum, type});
            }
        }
        for (int i = 0; i < b_minus1.size(); i++) {
            int sum = b_minus1[i].fi, type = b_minus1[i].se;
            if (type) {
                minus1.push({sum, type});
            } else {
                Minus(empt, minus1, sum);
            }
        }
        vector< pair<int, int> > ans2_plus, ans2_minus;
        while (minus1.size()) {
            ans2_minus.pb(minus1.top());
            minus1.pop();
        }
        while (plus1.size()) {
            ans2_plus.pb(plus1.top());
            plus1.pop();
        }

        if (ans1_plus == ans2_plus || ans1_minus == ans2_minus) {
            cout << "Yes" << endl;
        } else {
            cout << "No" << endl;
        }
    }
    return 0;
}