#include <iostream>
#include <string>
#include <stack>
#include <deque>
#include <vector>
#include <algorithm> 

using namespace std;

typedef long long ll;
typedef pair<ll, ll> llp;

vector<ll> stor;
vector<llp> win;
vector<ll> mint;
vector<ll> maxt;

vector<ll> rmint;
vector<ll> rmaxt;

int main() {
	ll n;
	cin >> n;

	if (n == 1) { cout << 0; return 0; }
	

	stor.resize(n);
	win.resize(n - 1);
	mint.resize(n);
	maxt.resize(n);
	rmint.resize(n);
	rmaxt.resize(n);

	for (ll i = 0; i < n; i++) {
		cin >> stor[i];
	}

	for (ll i = 0; i < n - 1; i++) {
		cin >> win[i].first >> win[i].second;
	}

	mint[n - 2] = max(win[n - 2].first - stor[n - 2], 0ll);
	maxt[n - 2] = win[n - 2].second;

	for (ll i = n - 3; i >= 0; i--) {
		if (mint[i + 1] == -1 || mint[i + 1] > win[i].second) { mint[i] = -1; }
		else {
			if (win[i].first <= mint[i + 1]) { 
				mint[i] = mint[i + 1];
			} else {
				mint[i] = win[i].first - stor[i];
			}
			mint[i] = max(mint[i], 0ll);
		}

		maxt[i] = min(win[i].second, maxt[i + 1]);
	}

	rmint[1] = max(win[0].first - stor[1], 0ll);
	rmaxt[1] = win[0].second;

	for (ll i = 2; i < n; i++) {
		if (rmint[i - 1] == -1 || rmint[i - 1] > win[i - 1].second) { rmint[i] = -1; }
		else {
			if (win[i - 1].first <= rmint[i - 1]) { rmint[i] = rmint[i - 1]; }
			else {
				rmint[i] = win[i - 1].first - stor[i];
			}
			rmint[i] = max(rmint[i], 0ll);
		}

		rmaxt[i] = min(win[i - 1].second, rmaxt[i- 1]);
	}

	if (maxt[0] < win[0].first || mint[0] == -1 || mint[0] > maxt[0]) {
		cout << "-1\n";
	}
	else {
		cout << mint[0] << "\n";
	}

	for (ll i = 1; i < n - 1; i++) {
		ll tans = max(mint[i], rmint[i]);
		if (mint[i] == -1 || rmint[i] == -1 || maxt[i] < win[i].first || rmaxt[i] < win[i - 1].first || tans > maxt[i] || tans > rmaxt[i]) {
			cout << "-1\n";
		}
		else {
			cout << tans << "\n";
		}
	}

	if (rmaxt[n - 1] < win[n - 2].first || rmint[n - 1] == -1 || rmint[n - 1] > rmaxt[n-1]) {
		cout << "-1\n";
	}
	else {
		cout << rmint[n - 1] << "\n";
	}

	return 0;
}