#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
typedef long long ll;
typedef pair <ll, ll> par;
typedef long double ld;

ll const LLINF = 1e18;

ll a[4010];
ll b[4010];
ll r1[4010];
ll r2[4010];
bool in[4010];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i < n; i++) cin >> r1[i];
	for (int i = 0; i < m; i++) cin >> b[i];
	for (int i = 0; i < m; i++) cin >> r2[i];
	ll ans = 0;
	int val[4];
	for (int l = 0; l < n; l++) for (int r = l; r <= n; r++) {
		ll cur = 0;
		for (int p = 0; p <= n + m; p++) in[p] = false;
		for (int p = l; p < r; p++) {
			in[a[p]] = true; cur += r1[p];
		}
		int p = 0, q = 0;
		while (p < m) {
			if (in[b[p]]) {
				p++;
				continue;
			}
			q = max(q, p);
			ll res = 0;
			while (q < m && !in[b[q]]) res += r2[q++];
			if (ans < cur + res) {
				ans = cur + res;
				if (r == l) val[0] = val[1] = 0; else { val[0] = l + 1; val[1] = r; }
				if (p == q) val[2] = val[3] = 0; else { val[2] = p + 1; val[3] = q; }
			}
			p = q;
		}
	}
	cout << ans << endl << val[0] << " " << val[1] << endl << val[2] << " " << val[3];
	return 0;
}