#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

struct edge
{
    long long to, w;
};

long long n, m;
vector <long long> d, sq;
set <pair <long long, long long> > s;
vector <vector <edge> > g;

inline void dij()
{
    long long node = (*s.begin()).second;
    s.erase(s.begin());

    for (long long i = 0; i < (long long)g[node].size(); i++)
    {
        long long to = g[node][i].to, w = g[node][i].w;
        if (d[to] > d[node] + w || (d[to] == d[node] + w && sq[to] < sq[node] + w * w))
        {
            s.erase({d[to], to});
            d[to] = d[node] + w;
            sq[to] = sq[node] + w * w;
            s.insert({d[to], to});
        }
    }

    if (!s.empty())
        dij();
}

int main()
{
    cin >> n >> m;
    g.resize(n + 1);
    d.resize(n + 1, 2e18);
    sq.resize(n + 1, -2e18);
    for (long long i = 0; i < m; i++)
    {
        long long a, from, w, to;
        cin >> a >> from;
        long long wnow = 0;
        for (long long j = 0; j < a; j++)
        {
            cin >> w >> to;
            wnow += w;
            g[from].push_back({to, wnow});
        }
    }

    s.insert({0, 1});
    d[1] = 0, sq[1] = 0;
    dij();

    cout << d[n] << ' ' << sq[n];
    return 0;
}

/*

2 1
1 1 3 2

*/
