#include <iostream>
#include <vector>
#include <string>
#include <stdio.h>
#include <algorithm>
#include <set>
#include <map>
#include <time.h>
#include <assert.h>
#pragma warning(disable: 4996)
typedef long long ll;
typedef long double ld;
using namespace std;

const ll SZ = 1e6 + 10;
const ll INF = 1e9;

bool v[SZ];
set<pair<pair<ll, ll>, ll>> dist;
vector<pair<ll, ll>> child[SZ];
pair<ll, ll> ans[SZ];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("trains.in", "r", stdin);
	freopen("trains.out", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	srand(time(NULL));

	ll n, m;
	cin >> n >> m;
	while (m--) {
		ll a, c, b;
		cin >> a >> c >> b;
		a--; b--;
		child[a].push_back({ b, c });
		//child[b].push_back({ a, c });
	}
	dist.insert({ { 0, -0 }, 0 });
	while (true) {
		while (dist.size() && v[dist.begin()->second])
			dist.erase(dist.begin());
		if (!dist.size())
			break;
		ll h = dist.begin()->second;
		auto x = dist.begin()->first;
		ans[h] = x;
		v[h] = true;
		for (auto i : child[h])
			dist.insert({ { x.first + i.second, x.second - i.second * i.second }, i.first });
	}
	
	cout << ans[n - 1].first << " " << -ans[n - 1].second;
	

	return 0;
}