#include <bits/stdc++.h>
#include <string>
#include <cstring>

using namespace std;

typedef long long ll;
typedef double ld;

vector<char> s, t;

struct Node
{
    int x;
    int priority;
    Node *left;
    Node *right;
    bool pl;
    int num;
    Node(int x, int num, bool plu):
        x(x),
        priority((rand() << 15) + rand()),
        left(0),
        right(0),
        num(num),
        pl(plu) {}
};

pair<Node*, Node*> split(Node *v, int x)
{
    if (!v)
        return {v, v};
    if (v->x <= x)
    {
        auto a = split(v->right, x);
        v->right = a.first;
        return {v, a.second};
    }
    auto a = split(v->left, x);
    v->left = a.second;
    return {a.first, v};
}

Node* merge(Node *l, Node *r)
{
    if (!l)
        return r;
    if (!r)
        return l;
    if (l->priority < r->priority)
    {
        l = merge(l, r->left);
        r->left = l;
        return r;
    }
    r = merge(l->right, r);
    l->right = r;
    return l;
}

int go_left(Node *v)
{
    if (v->left)
        return go_left(v->left);
    return v->num;
}

int go_right(Node *v)
{
    if (v->right)
        return go_right(v->right);
    return v->num;
}

int go_left1(Node *v)
{
    if (v->left)
        return go_left1(v->left);
    return v->x;
}

int go_right1(Node *v)
{
    if (v->right)
        return go_right1(v->right);
    return v->x;
}

vector<int> used;

void go(Node *v)
{
    if (!v)
        return;
    go(v->left);
    go(v->right);
}

bool tange(Node *v)
{
    if (!v)
        return 1;
    bool t = (tange(v->left) & tange(v->right));
    if (!v->pl)
        t = false;
    return t;
}

void func()
{
    int n = s.size();
        used.assign(n, 0);
        Node *root = 0;
        for (int i = 0; i < s.size();)
        {
            int j = i;
            while (j < n && s[j] == s[i])
                j++;
            bool pl = true;
            if (s[i] == '-')
                pl = false;
            else
            {
                for (int k = i; k < j; k++)
                    used[k] = 1;
            }
            root = merge(root, new Node(i, j - i, pl));
            i = j;
        }
        queue<int> q;
        for (int i = 0; i < n; i++)
        {
            if (used[i] || (i > 0 && s[i - 1] == s[i]))
                continue;
            auto a = split(root, i);
            auto b = split(a.first, i - 1);
            if (!b.second)
            {
                root = merge(merge(b.first, b.second), a.second);
                continue;
            }
            bool ok = false;
            if (b.first && go_right(b.first) > b.second->num)
                ok = true;
            if (a.second && go_left(a.second) > b.second->num)
                ok = true;
            if (ok)
            {
                q.push(i);
               // cout << i << endl;
                used[i] = 1;
            }
            root = merge(b.first, merge(b.second, a.second));
        }
      //  go(root);
       // cout << "---" << endl;
        while (!q.empty())
        {
            int i = q.front();
            q.pop();
            auto a = split(root, i);
            auto b = split(a.first, i - 1);
            int t = b.second->num;
            int X = b.second->x;
            if (b.first)
            {
                int tau = go_right(b.first);
                t += tau;
                int x = go_right1(b.first);
                auto c = split(b.first, x - 1);
                if (a.second)
                {
                    int tau = go_left(a.second);
                    t += tau;
                    int x = go_left1(a.second);
                    auto d = split(a.second, x);
                   // cout << "aaaaa " << t << endl;
                    root = merge(c.first, merge(new Node(X, t, true), d.second));
                   // go(root);
                  //  cout << "----" << endl;
                }
                else
                    root = merge(b.first, new Node(X, t, true));
            }
            else if (a.second)
            {
                int tau = go_left(a.second);
                t += tau;
                int x = go_left1(a.second);
                auto d = split(a.second, x);
                root = merge(new Node(X, t, true), d.second);
            }
            else
                root = b.second;
            a = split(root, X);
            b = split(a.first, X - 1);
            if (b.first)
            {
                if (!used[go_right1(b.first)] && go_right(b.first) < t)
                    q.push(go_right1(b.first)), used[go_right1(b.first)] = 1;
            }
            if (a.second)
            {
                if (!used[go_left1(a.second)] && go_left(a.second) < t)
                    q.push(go_left1(a.second)), used[go_left1(a.second)] = 1;
            }
            root = merge(merge(b.first, b.second), a.second);
           // go(root);
           // cout << "---" << endl;
        }
       // go(root);
        //cout << s << " ";
        cout << (!root || !tange(root) ? "No" : "Yes") << endl;
}

int num(int i)
{
    int j = i;
    while (j < s.size() && s[j] == s[i])
        j++;
    int ans = j - i;
    j = i;
    while (j >= 0 && s[j] == s[i])
        j--;
    ans += i - j;
    return ans;
}

void rev(int i)
{
    char c = (s[i] == '+' ? '-' : '+');
    int j = i;
    while (j < s.size() && s[j] != c)
        s[j] = c, j++;
    j = i - 1;
    while (j >= 0 && s[j] != c)
        s[j] = c, j--;
}

int find_right(int i)
{
    int j = i;
    while (i < s.size() && s[i] == s[j])
        i++;
    return i;
}

int find_left(int i)
{
    int j = i;
    while (i >= 0 && s[i] == s[j])
        i--;
    return i;
}

int main()
{
   // ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int q;
    cin >> q;
    string S;
    getline(cin, S);
    for (int ui = 0; ui < q; ui++)
    {
        getline(cin, S);
        s.clear();
        t.clear();
        int I = 0;
        while (S[I] != ' ')
            s.push_back(S[I]), I++;
        I++;
        bool koko = true;
        for (; I < S.size(); I++)
        {
            t.push_back(S[I]);
            if (S[I] != '+')
                koko = false;
        }
        if (koko)
        {
            func();
            continue;
        }
        int n = s.size();
        bool ok = true;
        for (int i = 1; i < n; i++)
            if (t[i] != t[i - 1] && s[i] == s[i - 1])
                ok = false;
        if (!ok)
        {
            cout << "No" << endl;
            continue;
        }
        for (int i = 0; ok && i < n; i++)
        {
            if (s[i] == t[i])
                continue;
            int j = i;
            while (s[i] != t[i])
            {
                if (j < 0 || j >= n)
                {
                    ok = false;
                    break;
                }
                int k = find_left(j), l = find_right(j);
                if ((k >= 0 && num(k) > num(j)) || (l < n && num(l) > num(j)))
                {
                    rev(j);
                    if (k >= 0)
                        j = find_left(k);
                    continue;
                }
                if (l >= n)
                {
                    ok = false;
                    break;
                }
                j = find_right(l);
            }
        }
        if (s != t)
            ok = false;
        cout << (ok ? "Yes\n" : "No\n");
    }
    return 0;
}
/*
3
++- +++
++-- ++++
++-+--+- ++++++++
*/
