#include <bits/stdc++.h>

using namespace std;

struct MM
{
    deque<long long> val;
    deque<int> ind;

    void add(long long v, int i)
    {
        while (!val.empty() && val.front() >= v)
            val.pop_front(), ind.pop_front();

        val.push_front(v);
        ind.push_front(i);
    }

    void del(int i)
    {
        if (ind.back() == i)
            val.pop_back(), ind.pop_back();
    }

    long long getMin()
    {
        return (val.back());
    }
};

int main()
{
    ///freopen("c.txt", "r", stdin);

    int n, a;
    scanf("%d %d", &n, &a);

    vector<long long> l(n), r(n), c(n);
    vector<long long> ans(a + 1, 0);

    for (int i = 0; i < n; i++)
        scanf("%lld %lld %lld", &l[i], &r[i], &c[i]);

    vector< MM > last(n);

    for (int w = a - 1; w >= 0; w--)
    {
        for (int i = 0; i < n; i++)
        {
            if (w + r[i] > a)
                continue;

            if (w + r[i] == a)
            {
                for (int d = l[i]; d <= r[i]; d++)
                    last[i].add((-c[i]) + ans[w + d] + (long long)(w + d - a) * (long long)(1e9), w + d);
            }
            else
            {
                last[i].add((-c[i]) + ans[w + l[i]] + (long long)(w + l[i] - a) * (long long)(1e9), w + l[i]);
                last[i].del(w + r[i] + 1);
            }

            ans[w] = max(ans[w], last[i].getMin() + (a - w) * (long long)(1e9));
        }
    }

    printf("%lld", ans[0]);

    return 0;
}
