#include<iostream>
#include<vector>
#include<string>
#include<queue>
#include<set>
#include<algorithm>
using namespace std;
long long f(string s) {
	vector<pair<long long, char>>groups;
	groups.push_back({ 1,s[0] });
	for (long long i = 1; i < s.size(); i++) {
		if (s[i] != s[i - 1])
			groups.push_back({ 1, s[i] });
		else
			groups[groups.size() - 1].first++;
	}
	queue<pair<long long, long long>>q;
	vector<long long>cnt(s.size() + 10, 0);
	for (long long i = 0; i < groups.size(); i++) {
		cnt[i] = groups[i].first;
		groups[i].first = i;
		if (groups[i].second == '+') {
			q.push({ i,1 });
			q.push({ i,-1 });
		}
	}
	while (!q.empty()) {
		long long id = q.front().first;
		long long napr = q.front().second;
		q.pop();
		long long to = id + napr;
		if (to < groups.size() && to >= 0) {
			if (groups[to].second != groups[id].second && cnt[groups[id].first] > cnt[groups[to].first]) {
				groups[to].second = groups[id].second;
				q.push({ to,napr });
			}
			long long last_id = -1;
			for (long long i = to; i < groups.size() && i >= 0; i = i + napr) {
				if (groups[i].second != groups[id].second) {
					if (i - napr != id)
						q.push({ i - napr,napr });
					break;
				}
				if (groups[id].first != groups[i].first) {
					if (last_id != groups[i].first)
						cnt[groups[id].first] += cnt[groups[i].first];
					last_id = groups[i].first;
					groups[i].first = id;
				}
			}
			napr *= -1;
			last_id = -1;
			for (long long i = id + napr; i < groups.size() && i >= 0; i = i + napr) {
				if (groups[i].second != groups[id].second) {
					if (i - napr != id)
						q.push({ i - napr,napr });
					break;
				}
				if (groups[id].first != groups[i].first) {
					if (last_id != groups[i].first)
						cnt[groups[id].first] += cnt[groups[i].first];
					last_id = groups[i].first;
					groups[i].first = id;
				}
			}

		}
	}
	long long fl = 1;
	for (long long i = 0; i < groups.size(); i++) {
		if (groups[i].second == '-') {
			fl = 0;
			break;
		}
	}
	if (fl == 1)
		return 1;
	else
		return 0;
}

int main()
{
	long long q;
	cin >> q;
	for (long long k = 0; k < q; k++) {
		string s, t;
		cin >> s >> t;
		if (s.size() != t.size()) {
			cout << "No" << endl;
			continue;
		}
			vector<pair<long long, char>>groups;
			groups.push_back({ 1,s[0] });
			for (long long i = 1; i < s.size(); i++) {
				if (s[i] != s[i - 1])
					groups.push_back({ 1, s[i] });
				else
					groups[groups.size() - 1].first++;
			}
		set<pair<long long,long long>>q;
		vector<long long>cnt(s.size()+10,0);
		for (long long i = 0; i < groups.size(); i++) {
			cnt[i] = groups[i].first;
			groups[i].first = i;
			if (groups[i].second == '+') {
				q.insert({ i,1});
				q.insert({ i,-1 });
			}
		}
		while (!q.empty()) {
			long long id = q.begin()->first;
			long long napr = q.begin()->second;
			q.erase(q.begin());
			long long to = id + napr;
			if (to < groups.size() && to >= 0) {
				if (groups[to].second != groups[id].second && cnt[groups[id].first] > cnt[groups[to].first]) {
					groups[to].second = groups[id].second;
					q.insert({to,napr});
				}
				long long last_id = id;
				for (long long i = to; i < groups.size() && i >= 0; i = i + napr) {
					if (groups[i].second != groups[id].second) {
						if (i - napr != id)
							q.insert({ i - napr,napr });
						break;
					}
					if (groups[id].first != groups[i].first) {
						if (last_id != groups[i].first)
							cnt[groups[id].first] += cnt[groups[i].first];
						last_id = groups[i].first;
						groups[i].first = id;
					}
				}
				napr *= -1;
				last_id = id;
				for (long long i = id+napr; i < groups.size() && i >= 0; i = i + napr) {
					if (groups[i].second != groups[id].second) {
						if (i - napr != id)
							q.insert({ i - napr,napr });
						break;
					}
					if (groups[id].first != groups[i].first) {
						if (last_id != groups[i].first)
							cnt[groups[id].first] += cnt[groups[i].first];
						last_id = groups[i].first;
						groups[i].first = id;
					}
				}

			}
		}
		long long fl = 1;
		for (long long i = 0; i < groups.size(); i++) {
			if (groups[i].second == '-') {
				fl = 0;
				break;
			}
		}
		if (fl == 1 || f(s) == 1)
			cout << "Yes" << endl;
		else
			cout << "No" << endl;
	}
	return 0;
}