#include <iostream>
#include <set>
#include <string>
#include <algorithm>
#include <unordered_map>
#include <vector>
using namespace std;
typedef long long ll;
void fill(vector<vector<ll> > &suma, ll a[500], ll n) {
	for (int i = 0; i < n; i++)
		suma[i][i] = a[i];
	for (int len = 2; len <= n; len++) {
		for (int l = 0; l <= n - len; l++)
			suma[l][l + len - 1] = suma[l][l + len - 2] + a[l + len - 1];
	}
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	ll a[500], b[500], x[500], y[500];
	int flag = 0;
	if (n < m) {
		for (int i = 0; i < n; i++)
			cin >> b[i];
		for (int i = 0; i < n; i++)
			cin >> y[i];
		for (int i = 0; i < m; i++)
			cin >> a[i];
		for (int i = 0; i < m; i++)
			cin >> x[i];
		swap(n, m);
		flag = 1;
	}
	else {
		for (int i = 0; i < n; i++)
			cin >> a[i];
		for (int i = 0; i < n; i++)
			cin >> x[i];
		for (int i = 0; i < m; i++)
			cin >> b[i];
		for (int i = 0; i < m; i++)
			cin >> y[i];
	}
	//vector<vector<ll> > suma(n, vector<ll>(n)), sumb(m, vector<ll>(m));
	//fill(suma, x, n);
	//fill(sumb, y, m);
	ll ans = 0, lla = -1, rra = -1, llb = -1, rrb = -1;
	vector<int> used(n + m + 1);
	for (int la = 0; la < n; la++) {
		used[a[la]] = 1;
		ll suma = x[la];
		for (int ra = la; ra < n; ra++) {
			if (suma > ans) {
				ans = suma, lla = la, rra = ra, llb = -1, rrb = -1;
			}
			used[a[ra]] = 1;
			int lb = 0;
			ll sumb = 0;
			while(lb < m){
				sumb = y[lb];
				if (used[b[lb]]) {
					lb++;
					continue;
				}
				for (int rb = lb; rb < m; rb++) {
					if (used[b[rb]]) {
						lb = rb;
						break;
					}
					else {
						ll sum = suma + sumb;
						if (sum > ans) {
							ans = sum, lla = la, rra = ra, llb = lb, rrb = rb;
						}
					}
					sumb += (rb + 1 < m ? y[rb + 1] : 0);
				}
				lb++;
			}
			suma += (ra + 1 < n ? x[ra + 1] : 0);
		}
		used.assign(n + m + 1, 0);
	}
	for (int la = 0; la < m; la++) {
		ll sumb = y[la];
		for (int ra = la; ra < m; ra++) {
			if (sumb > ans) {
				ans = sumb, llb = la, rrb = ra, lla = -1, rra = -1;
			}
			sumb += (ra + 1 < m ? y[ra + 1] : 0);
		}
	}
	if(!flag)
		cout << ans << '\n' << lla + 1 << ' ' << rra + 1 << '\n' << llb + 1 << ' ' << rrb + 1;
	else

		cout << ans << '\n' << llb + 1 << ' ' << rrb + 1 << '\n' << lla + 1 << ' ' << rra + 1;
}