#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <fstream>
#include <algorithm>
#include <cmath>
#include <utility>
using namespace std;
typedef long long int ll;
#define v vector

#ifdef _MSC_VER
#define DEB(x) cout << x
#else
#define DEB(x)
#endif

void pause() {
#ifdef _MSC_VER
	std::system("pause");
#endif
}

struct point {
	int x;
	int y;
	
	point(int _x, int _y) {
		x = _x;
		y = _y;
	}

	point() : point(0, 0) {}

	ll dist(point p) {
		ll xx = p.x - x;
		ll yy = p.y - y;
		return xx * xx + yy * yy;
	}
};

int main() {
	int n;
	cin >> n;
	vector<point> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].x >> arr[i].y;
	}
	int q;
	cin >> q;
	for (int qq = 0; qq < q; qq++) {
		ll sqr = 1e18;
		int ansi = 0;
		int ansj = 1;
		int ansk = 2;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i == j) continue;
				for (int k = 0; k < n; k++) {
					if (i == k || j == k) continue;
					cout << "? 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
					string s;
					cin >> s;
					bool res = s[0] == 'Y';
					if (res) {
						ll nsq = arr[i].dist(arr[j]) + arr[j].dist(arr[k]) + arr[k].dist(arr[i]);
						if (sqr > nsq) {
							sqr = nsq;
							ansi = i;
							ansj = j;
							ansk = k;
						}
					}
				}
			}
		}
		cout << "! 3 " << ansi + 1 << " " << ansj + 1 << " " << ansk + 1 << endl;
	}
	pause();
	return 0;
}