#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;
const int mdv = 4194304 / 8;

int tre[mdv + mdv];

int l[100], r[100], c[100];

long long INF = 1e9;

int lz, rz;
inline int get() {
	lz += mdv;
	rz += mdv;
	int ans = min(tre[lz], tre[rz]);
	while (rz / 2 != lz / 2) {
		if ((lz & 1) == 0) {
			ans = min(ans, tre[lz + 1]);
		}
		lz = lz / 2;
		if ((rz & 1) == 1) {

			ans = min(ans, tre[rz - 1]);
		}
		rz = rz / 2;
	}
	return ans;
}

inline void add(int nom, int x) {
	nom += mdv;
	if (x > tre[nom]) {
		tre[nom] = x;
	}
	else {
		return;
	}
	nom = nom / 2;
	while (nom != 0) {
		tre[nom] = min(tre[nom * 2], tre[nom * 2 + 1]);
		nom = nom / 2;
	}
}


int tre1[mdv + mdv];

inline int get1() {
	lz += mdv;
	rz += mdv;
	int ans = max(tre1[lz], tre1[rz]);
	while (rz / 2 != lz / 2) {
		if ((lz & 1) == 0) {
			ans = max(ans, tre1[lz + 1]);
		}
		lz = lz / 2;
		if ((rz & 1) == 1) {
			
			ans = max(ans, tre1[rz  - 1]);
		}
		rz = rz / 2;
	}
	return ans;
}

inline void add1(int nom, int x) {
	nom += mdv;
	tre1[nom] = x;
	nom = nom / 2;
	while (nom != 0) {
		tre1[nom] = max(tre1[nom * 2], tre1[nom * 2 + 1]);
		nom = nom / 2;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cerr.tie(0);
	int n;
	int ms;
	cin >> n >> ms;
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i] >> c[i];
	}
	int x;
	for (int i = ms; i >= 0; i--) {
		add(i, i);
		for (int j = 0; j < n; j++) {
			if (r[j] + i > ms) {
				continue;
			}
			lz = l[j] + i;
			rz = r[j] + i;
			if (i == 4) {
				int dfdfdf = 990;
			}
			x = get();
			add(i, x);
		}
	}
	lz = rz = 0;
	long long ans = get();

	for (int i = ms; i >= 0; i--) {
		if (tre[i + mdv] > ans) {
			continue;
		}
		if (i == ans) {
			continue;
		}
		add1(i, INF);
		for (int j = 0; j < n; j++) {
			if (r[j] + i > ms) {
				continue;
			}
			lz = l[j] + i;
			rz = r[j] + i;
			x = get1();
			add1(i, min(tre1[i + mdv], x + c[j]));
		}
	}

	lz = rz = 0;
	x = get1();
	ans = INF * ans - (long long)(x);
	//ans = max(ans, INF * (long long)(lfr[i]) - (long long)(sumfr[i]));
	cout << ans;
}