#include <bits/stdc++.h>

using namespace std;
#define ll long long

void print(vector<auto> k)
{
    for (auto i : k)
        cout << i << " ";
    cout << endl;
}

void init(vector<int> &parts, vector<int> &signs, string &s)
{
    parts.clear();
    signs.clear();
    int curr = 0, curs = 0;
    for (int i = 0; i < s.size(); ++i)
    {
        if (curr > 0 && s[i - 1] != s[i])
        {
            parts.push_back(curr);
            signs.push_back(curs);
            curs *= -1;
            curr = 0;
        }
        else if (curr > 0 && s[i - 1] == s[i])
            curr++;
        if (curr == 0)
        {
            if (s[i] == '+')
                curs = 1;
            else
                curs = -1;
            curr = 1;
        }
    }
    if (curr > 0)
    {
        parts.push_back(curr);
        signs.push_back(curs);
        curr = 0;
    }
}

bool do_ans(vector<int> &parts, vector<int> &signs, int need)
{
    int good = 0;
    for (int i = 0; i < parts.size(); ++i)
        good += parts[i];
    int left, right, cursize, maxsize = 0;
    bool b;
    for (int i = 0; i < parts.size(); ++i)
    {
        left = i, right = i, cursize = parts[i];
        //cout << i << " " << parts[i] << endl;
        b = true;
        while (b)
        {
            b = false;
            while (left > 0)
            {
                if (cursize > parts[left - 1])
                {
                    cursize += parts[left - 1];
                    left--;
                    if (left > 0) {left--; cursize += parts[left];}
                    b = true;
                }
                else
                    break;
            }
            while (right < parts.size() - 1)
            {
                //cout << left << " " << right << endl;
                if (cursize > parts[right + 1])
                {
                    cursize += parts[right + 1];
                    right++;
                    if (right < parts.size() - 1) {right++; cursize += parts[right];}
                    b = true;
                }
                else
                    break;
            }
        }
        maxsize = max(maxsize, cursize);
    }
    if (maxsize == good)
        return true;
    return false;

}

int main()
{
    //freopen("file.in", "r", stdin);
    ios_base::sync_with_stdio(0);
    int q;
    cin >> q;
    vector<int> parts1;
    vector<int> signs1;
    vector<int> parts2;
    vector<int> signs2;
    vector<int> dp1;
    vector<int> dp2;
    string s1, s2;
    bool ans;
    int need_here = 1;
    for (int k = 0; k < q; ++k)
    {
        cin >> s1 >> s2;
        init(parts1, signs1, s1);
        init(parts2, signs2, s2);
        //print(parts1); print(signs1); cout << s1 << endl;
        //print(parts2); print(signs2); cout << s2 << endl << endl;

        //print(parts1); print(signs1); cout << s1 << endl;
        if (do_ans(parts1, signs1, 1))
            cout << "Yes\n";
        else
            cout << "No\n";
        //cout << endl;
    }
    return 0;
}
