#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>

using namespace std;

string s, t;
stack <int> q;

int main()
{
    cin >> s;
    cin >> t;
    int i = s.size() - 1, j = t.size() - 1, d = 0;
    while (i >= 0 || j >= 0 || d > 0)
    {
        if (i >= 0 && j >= 0)
            d += s[i] - '0' + t[j] - '0';
        else if (i >= 0)
            d = s[i] - '0';
        else if (j >= 0)
            d = t[j] - '0';
        q.push(d % 10);
        d /= 10;
        --i, --j;
    }
    while (!q.empty())
    {
        cout << q.top();
        q.pop();
    }
    cout << endl;
    return 0;
}
