#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

vector<int> v(100000);
vector<int> tec(31, -1);

void f1(int l, int r, int rasr) {
    //cout << l << " " << r << " " << rasr << endl;
    if (l >= r or rasr < 0) return;
    vector<int> a(0);
    int q = 0, u1;

    if ((v[l] | (1 << rasr)) == v[l]) a.push_back(1);
    else a.push_back(0);

    for (int i = l; i < r; i++) {
        if (((v[i] | (1 << rasr)) == v[i])  != a[q]) {
            u1 = i;
            a.push_back((a[q] + 1) % 2);
            //cout << "a:  " << (v[i] | (1 << rasr)) << endl;
            q++;
        }
    }
    //cout << a.size() << endl;
    if (a.size() > 2) tec[rasr] = -2;
    if (a.size() == 2) {
        if (tec[rasr] == -2 or tec[rasr] == (a[0] + 1) % 2) tec[rasr] = -2;
        else {
            tec[rasr] = a[0];
            f1(l, u1, rasr - 1);
            f1(u1, r, rasr - 1);
        }
    }
    if (a.size() == 1 and tec[rasr] != -2) {
        f1(l, r, rasr - 1);
    }
    return;
}

int f(vector<int> y, int n, int mmax) {
    for (int i = 0; i < 31; i++) {
        tec[i] = -1;
    }
    f1(0, n, mmax);
    long long h = 0;
    bool f = true;
    for (int i = 0; i < 31; i++) {
        if (tec[i] == -2) f = false;
        if (tec[i] == 1) h |= (1 << i);
    }
    if (f) return h;
    else return -1;
}




int main() {
    int n, a, b;
    cin >> n;
    int mmax = 0;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        for (int j = 31; j >= 0; j--) {
            if (((1 << j) & v[i]) > 0) {
                mmax = max(j, mmax);
                break;
            }
        }
    }
    cout << f(v, n, mmax) << endl;
    //cout << mmax << endl;
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        cin >> a >> b ;
        v[a - 1] = b;
        for (int j = 31; j >= 0; j--) {
            if (((1 << j) & v[a - 1]) > 0) {
                mmax = max(j, mmax);
                break;
            }
        }
        cout << f(v, n, mmax) << endl;
    }



    return 0;
}
