#include <deque>
#include <iostream>
#include <vector>

using namespace std;

struct three
{
	int first, second, third;
};

int main()
{
	int n, m, inf, i, j;
	vector<vector<three>> g;
	cin >> n >> m;
	inf = 1000000000;

	for (i = 0; i < n; i++)
	{
		vector<three> v;
		vector<int> vi;
		g.push_back(v);
	}

	for (i = 0; i < m; i++)
	{
		int gg, a, t, b;
		cin >> gg >> a >> t >> b;
		three th;
		th.first = b - 1;
		th.second = t;
		th.third = t * t;
		g[a - 1].push_back(th);
	}

	deque<int> d;
	vector<deque<int>> q;
	for (i = 0; i < 1001; i++)
		q.push_back(d);
	q[0].push_back(0);
	vector<bool> used;
	vector<int> ssq;
	vector<int> dist;
	for (i = 0; i < n; i++)
	{
		used.push_back(false);
		ssq.push_back(-1);
		dist.push_back(inf);
	}
	ssq[0] = 0;
	dist[0] = 0;
	int mindist = inf;
	int maxsq = -1;

	while (true)
	{
		int f = -1;
		int j;
		for (j = 0; j < 1001; j++)
		{
			if (q[j].size() > 0)
			{
				f = j;
				break;
			}
		}
		if (f == -1)
			break;
		int v = q[f].front();
		q[f].pop_front();
		if (v == n - 1)
		{
			if (dist[v] == mindist)
			{
				if (ssq[v] > maxsq)
					maxsq = ssq[v];
			}
			else if (dist[v] < mindist)
			{
				mindist = dist[v];
				maxsq = ssq[v];
			}
			continue;
		}
		used[v] = true;
		for (i = 0; i < g[v].size(); i++)
		{
			int u = g[v][i].first;
			int t = g[v][i].second;
			int sq = g[v][i].third;

			if (!used[u])
			{
				if (dist[u] == dist[v] + t)
				{
					if (ssq[v] + sq > ssq[u])
					{
						ssq[u] = ssq[v] + sq;
					}
				}
				else if (dist[u] > dist[v] + t)
				{
					dist[u] = dist[v] + t;
					ssq[u] = ssq[v] + sq;
				}
				q[t].push_back(u);
			}
		}
	}

	cout << mindist << " " << maxsq << endl;

    return 0;
}

