#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long q;
vector<pair<int, int> > lst;
string s1, s2;

int tr(int lef, int rig) {
    int ind1 = lef - 1;
    while (ind1 >= 0 && s1[ind1] != s1[lef]) {
        ind1--;
    }
    if  (rig - lef + 1 < lef - ind1 - 1) {
        for (int i = lef; i <= rig; i++) {
            s1[i] = s2[i];
        }
        return 1;
    }
    ind1 = rig + 1;
    while (ind1 < s1.size() && s1[ind1] != s1[rig]) {
        ind1++;
    }
    //cout << ind1 << lef;
    if  (rig - lef + 1 < ind1 - rig - 1) {
        //cout << lef << endl;
        for (int i = lef; i <= rig; i++) {
            s1[i] = s2[i];
        }
        return 1;
    }
    return 0;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> q;
    for (int h = 0; h < q; h++) {
        vector<pair<int, int> > problems;
        problems.resize(0);
        cin >> s1 >> s2;
        int i = 0;
        while (i < s1.size()) {
            if (s1[i] != s2[i]) {
                int l1 = i;
                i++;
                while (i < s1.size() && s1[i] != s2[i]) {
                    i++;
                }
                int l2 = i - 1;
                if (tr(l1, l2) == 1) {
                    //cout << l1 << l2 << endl;
                    while (problems.size() > 0) {
                        long long x = tr(problems[problems.size() - 1].first, problems[problems.size() - 1].second);
                        if (x == 0) {
                            break;
                        } else {
                            problems.pop_back();
                        }
                    }
                } else {
                    problems.push_back(make_pair(l1, l2));
                }
            } else {
                i++;
            }
        }
        //cout << s1;
        if (s1 != s2) {
            cout << "No" << endl;
        } else {
            cout << "Yes" << endl;
        }
    }
    return 0;
}
