#include <iostream>
#include <string>
using namespace std;
const int MAXN = 60;

pair <int, int> pts[MAXN];
bool corr[MAXN][MAXN][MAXN];
long long vect(pair <int, int> p1, pair <int, int> p2){
    return (long long)p1.first * p2.second - (long long)p1.second * p2.first;
}

long long S(int a, int b, int x){
    pair <int, int> v1 = make_pair(pts[a].first - pts[x].first, pts[a].second - pts[x].second);
    pair <int, int> v2 = make_pair(pts[b].first - pts[x].first, pts[b].second - pts[x].second);
    return vect(v1, v2);
}

bool check(int a, int b, int c, int x){

    long long s1 = S(a, b, x);
    long long s2 = S(b, c, x);
    long long s3 = S(c, a, x);
    if ((a == 0) and (b == 1) and (c == 2) and (x == 3)){
        //cout << a << ' ' << b << ' ' << c << ' ' << x << ' ' << ' ' << s1 << ' ' << s2 << ' ' << s3 << endl;
    }
    if ((s1 > 0) and (s2 > 0) and (s3 > 0)){
        return true;
    }
    if ((s1 < 0) and (s2 < 0) and (s3 < 0)){
        return true;
    }
    return false;
}

int main(){
    int n;
    cin >> n;
    for (int i = 0; i < n; i++){
        cin >> pts[i].first >> pts[i].second;
    }
    for (int a = 0; a < n; a++){
        for (int b = 0; b < n; b++){
            if (b == a){
                continue;
            }
            for (int c = 0; c < n; c++){
                if ((c == a) or (c == b)){
                    continue;
                }
                bool flag = true;
                for (int x = 0; x < n; x++){
                    if ((x == a) or (x == b) or (x == c)){
                        continue;
                    }

                    if (check(a, b, c, x)){

                        flag = false;
                        break;
                    }
                }
                if (flag){
                    corr[a][b][c] = true;
                }
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++){
        bool flag = false;
        for (int a = 0; a < n; a++){
            for (int b = a + 1; b < n; b++){
                for (int c = b + 1; c < n; c++){
                    if (corr[a][b][c]){
                        cout << '?' << ' ' << 3 << ' ' << a + 1 << ' ' << b + 1 << ' ' << c + 1 << endl;
                        string s;
                        cin >> s;
                        if (s == "Yes"){
                            cout << '!' << ' ' << 3 << ' ' << a + 1 << ' ' << b + 1 << ' ' << c + 1 << endl;
                            flag = true;
                            break;
                        }
                    }
                }
                if (flag){
                    break;
                }
            }
            if (flag){
                break;
            }
        }
    }
}
