import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class E {
	
	private class Node {
		public Node p, n;
		public int v;
		public boolean t;
		
		public Node(Node p, Node n, int v, boolean t) {
			this.p = p;
			this.n = n;
			this.v = v;
			this.t = t;
		}
		
	}
	
	private void solve() throws IOException {
		final int n = nextInt();
		test : for (int i = 0; i < n; i++) {
			final char[] s1 = nextToken().toCharArray(), s2 = nextToken().toCharArray();
			int s2si = 0;
			for (int j = 1; j <= s2.length; j++) {
				if (j == s2.length || s2[j] != s2[s2si]) {
					boolean st = s2[s2si] == '+';
					if (s2si != 0 && s2[s2si] != s1[s2si] || j != s2.length && s2[j] != s1[j]) {
						out.println("No");
						continue test;
					}
					Node x = new Node(null, null, 1, s1[s2si] == '+'), f = x;
					for (int k = s2si + 1; k < j; k++) {
						if (s1[k] == '+' == x.t) {
							x.v++;
						} else {
							Node y = x;
							x = new Node(y, null, 1, !y.t);
							y.n = x;
						}
					}
					x = f.t == st ? f : f.n;
					while (f.p != null || f.n != null || f.t != st) {
						if (x == null) {
							out.println("No");
							continue test;
						}
						if (x.p == null && x != f) {
							f = x;
							continue;
						}
						if (x.p != null && x.v > x.p.v) {
							if (x.p.p != null) {
								x.v += x.p.v + x.p.p.v;
								x.p = x.p.p.p;
							} else {
								x.v += x.p.v;
								x.p = null;
							}
							continue;
						}
						if (x.n != null && x.v > x.n.v) {
							if (x.n.n != null) {
								x.v += x.n.v + x.n.n.v;
								x.n = x.n.n.n;
							} else {
								x.v += x.n.v;
								x.n = null;
							}
							continue;
						}
						if (x.n == null) {
							out.println("No");
							continue test;
						}
						x = x.n.n;
					}
					s2si = j;
				}
			}
			out.println("Yes");
		}
	}
	
	private E() throws IOException {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		
		solve();
		
		in.close();
		out.close();
	}
	
	public static void main(final String[] args) throws IOException {
		new E();
	}

	private final BufferedReader in;
	private final PrintWriter out;
	private StringTokenizer st;
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
}
/*
3
++- +++
++-- ++++
++-+--+- ++++++++

3
++-+-- ++----
++-+-- +++---
-++- -++-

1
+ -

*/

