#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int pr1(int n, vector <int> &T, vector <int> &L, vector <int> &R, vector <int> &Ans)
{
    Ans.resize(0);
    int mr = *min_element(R.begin(), R.end());
    vector <int> AL(n), BL(n), AR(n), BR(n);
    AL[0] = 0;
    AR[0] = 2e9;
    BR[n - 1] = 2e9;
    for (int i = 1; i < n; ++i)
    {
        if (AL[i - 1] > L[i - 1])
        {
            AL[i] = AL[i - 1];
        }
        else
        {
            AL[i] = L[i - 1] - T[i];
        }
        if (L[i - 1] > AR[i - 1] || AL[i - 1] > R[i - 1])
        {
            AL[i] = 2e9;
        }
        AR[i] = min(AR[i - 1], R[i - 1]);
    }
    BL[n - 1] = 0;
    for (int i = n - 2; i >= 0; --i)
    {
        if (BL[i + 1] > L[i])
        {
            BL[i] = BL[i + 1];
        } else{
            BL[i] = L[i] - T[i];
        }
        if (L[i] > BR[i + 1] || BL[i + 1] > R[i])
        {
            BL[i] = 2e9;
        }
        BR[i] = min(BR[i + 1], R[i]);
    }
    for (int i = 0; i < n; ++i)
    {
        int ll = max(AL[i], BL[i]);
        if (ll > mr)
        {
            Ans.push_back(-1);
        }
        else
        {
            Ans.push_back(abs(ll));
        }
    }
    return 0;
}

int pr2(int n, vector <int> &T, vector <int> &L, vector <int> &R, vector <int> &Ans)
{
    Ans.resize(0);
    int mr = *min_element(R.begin(), R.end());
    for (int i = 0; i < n; ++i)
    {
        bool fl1 = true;
        for (int t = 0; t <= mr; ++t)
        {
            int tim = t;
            fl1 = true;
            for (int j = i + 1; j < n; ++j) {
                if (L[j - 1] <= tim) {
                    if (R[j - 1] < tim) {
                        fl1 = false;
                        break;
                    }
                } else {
                    if (L[j - 1] > tim + T[j - 1]) {
                        fl1 = false;
                        break;
                    } else {
                        tim = L[j - 1];
                    }
                }
            }
            tim = t;
            for (int j = i - 1; j >= 0; --j) {
                if (L[j] <= tim) {
                    if (R[j] < tim) {
                        fl1 = false;
                        break;
                    }
                } else {
                    if (L[j] > tim + T[j + 1]) {
                        fl1 = false;
                        break;
                    } else {
                        tim = L[j];
                    }
                }
            }
            if (fl1)
            {
                Ans.push_back(t);
                break;
            }
        }
        if (!fl1)
        {
            Ans.push_back(-1);
        }
    }
    return 0;
}

int main() {
    int n;
    cin >> n;
    if (n == 1)
    {
        cout << 0 << endl;
        return 0;
    }
    vector <int> T(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> T[i];
    }
    vector <int> L(n - 1), R(n - 1);
    for (int i = 0; i < n - 1; ++i)
    {
        cin >> L[i] >> R[i];
    }
    vector <int> Ans;
    pr1(n, T, L, R, Ans);
    for (int i = 0; i < n; ++i)
    {
        cout << Ans[i] << endl;
    }
    /*while (true)
    {
        int n = 3;
        vector <int> T(n);
        vector <int> L(n - 1), R(n - 1);
        for (int i = 0; i < n; ++i)
        {
            T[i] = rand() % 501;
        }
        for (int i = 0; i < n - 1; ++i)
        {
            R[i] = rand() % 501;
            L[i] = rand() % (R[i] + 1);
        }
        vector <int> Ans1, Ans2;
        pr1(n, T, L, R, Ans1);
        pr2(n, T, L, R, Ans2);
        if (Ans1 != Ans2)
        {
            for (int i = 0; i < n; ++i)
            {
                cout << T[i] << " ";
            }
            cout << endl;
            for (int i = 0; i < n - 1; ++i){
                cout << L[i] << " " << R[i] << endl;
            }
            for (int i = 0; i < n; ++i)
            {
                cout << Ans1[i] << " ";
            }
            for (int i = 0; i < n; ++i)
            {
                cout << Ans2[i] << " ";
            }
            return 0;
        }
    }
    return 0;*/
}