#include <bits/stdc++.h>
typedef long long ll;
using namespace std;

struct St {
    int l, r, dl, par;
    bool good;
};

vector <St> a;

bool solve(string s, char c) {
    a.clear();
    int t = 0;
    vector <int> w(s.size(), -1);
    for (int i = 1; i < s.size(); i++) {
        if (s[i] != s[i - 1]) {
            w[i - 1] = t;
            w[t] = i - 1;
            t = i;
        }
    }
    w[s.size() - 1] = t;
    w[t] = s.size() - 1;

    queue <pair <int, int> > q;
    for (int i = 0; i < s.size(); i++) {
        if (w[i] == -1 || w[i] < i) continue;
        if (s[i] == c) {
            q.push({i, w[i]});
        }
    }

    while (q.size()) {
        int l = q.front().first;
        int r = q.front().second;
        q.pop();
        if (w[l] != r || w[r] != l) continue;
        bool fl = false;
        if (l != 0) {
            if (s[l - 1] == c) {
                w[r] = w[l - 1];
                w[w[l - 1]] = r;
                l = w[r];
                q.push({l, r});
                fl = true;
            } else {
                int d2 = (l - w[l - 1]);
                if (d2 < r - l + 1) {
                    s[l - 1] = c;
                    s[w[l - 1]] = c;

                    w[r] = w[l - 1];
                    w[w[l - 1]] = r;
                    l = w[r];
                    q.push({l, r});
                    fl = true;
                }
            }
        }
        if (!fl && r != s.size() - 1) {
            if (s[r + 1] == c) {
                w[l] = w[r + 1];
                w[w[l]] = l;
                r = w[l];
                q.push({l, r});
                fl = true;
            } else {
                int d2 = (w[r + 1] - r);
                if (d2 < r - l + 1) {
                    w[l] = w[r + 1];
                    w[w[l]] = l;
                    r = w[l];
                    s[r] = c;
                    q.push({l, r});
                    fl = true;
                }
            }
        }
    }

    return (w[0] == s.size() - 1 && w[s.size() - 1] == 0 && s[0] == c);
}

int main() {

    freopen("storage.in", "r", stdin);
    freopen("storage.out", "w", stdout);

    int q;
    cin >> q;

    while (q--) {
        string a, b;
        cin >> a >> b;
        vector <pair <int, int> > w;
        int c = 0;
        int n = a.size();
        for (int i = 1; i < n; i++) {
            if (b[i] != b[i - 1]) {
                w.push_back({c, i - 1});
                c = i;
            }
        }
        w.push_back({c, n - 1});
        bool ans = true;
        for (auto p : w) {
            char c = b[p.first];
            if ((c != a[p.first] && p.first != 0) || (c != a[p.second] && p.second != n - 1)) ans = false;
        }
        if (!ans) {
            cout << "No" << endl;
            continue;
        }
        for (auto p : w) {
            string s = "";
            for (int i = p.first; i <= p.second; i++) s.push_back(a[i]);
            if (!solve(s, b[p.first])) {
                ans = false;
                break;
            }
        }
        if (ans) {
            cout << "Yes" << endl;
        } else {
            cout << "No" << endl;
        }
    }

    return 0;
}