#include <bits/stdc++.h>

using namespace std;
typedef long long nagai;

struct seg
{
	nagai l, r;
	seg(nagai l, nagai r)
		: l(l), r(r)
	{}
	seg()
		: l(-1), r(-1)
	{}
	bool good()
	{
		return r >= l;
	}
};
seg inter(seg a, seg b)
{
	return seg(max(a.l, b.l), min(a.r, b.r));
}

int main()
{
	int n;
	scanf("%d", &n);
	vector<int> t(n);
	for (auto& x : t)
		scanf("%d", &x);
	vector<seg> bou(n - 1);
	for (int i = 0; i < n - 1; ++i)
		scanf("%lld %lld", &bou[i].l, &bou[i].r);
	vector<seg> dpl(n), dpr(n);
	nagai INF = 2000000000LL;
	seg BAD(1000000 * INF, 1000000 * -INF);
	dpl[0] = seg(0, INF);
	dpr[n - 1] = seg(0, INF);
	for (int i = 1; i < n; ++i)
	{
		auto b1 = inter(bou[i - 1], dpl[i - 1]);
		if (!b1.good())
			b1 = BAD;
		if (dpl[i - 1].l <= bou[i - 1].l)
			b1.l -= t[i];
		dpl[i] = b1;
	}
	for (int i = n - 2; i >= 0; --i)
	{
		auto b1 = inter(bou[i], dpr[i + 1]);
		if (!b1.good())
			b1 = BAD;
		if (dpr[i + 1].l <= bou[i].l)
			b1.l -= t[i];
		dpr[i] = b1;
	}
	bool deb = false;
	for (int i = 0; i < n; ++i)
	{
		if (!deb)
		{
			auto mem = inter(dpl[i], dpr[i]);
			if (!mem.good())
				cout << -1 << '\n';
			else
				cout << max(0, mem.l) << '\n';
		}
		else
		{
			if (!dpl[i].good())
				cout << -1 << endl;
			else
				cout << dpl[i].l << ' ' << dpl[i].r << endl;
			if (!dpr[i].good())
				cout << -1 << endl;
			else
				cout << dpr[i].l << ' ' << dpr[i].r << endl;
			cout << endl;
		}
	}
}
