#include <iostream>
#include <vector>
#include <string>

using namespace std;

vector<char> v;

bool ask(int l, int r)
{
	cout << "? " << l << " " << r << endl;
	string s;
	cin >> s;
	return s == "Yes";
}

void solve(int l, int r)
{
	if (l + 1 >= r)
	{
		if (l + 1 == r)
		{
			v[l] = '(';
			v[r] = ')';
		}
		return;
	}
	bool flag = false;
	
	{
		for (int i = l + 1; i <= r - 2; i++)
			if (ask(l, i))
			{
				v[l] = '(';
				v[i] = ')';
				solve(l + 1, i - 1);
				solve(i + 1, r);
				flag = true;
				break;
			}
	}
	if (flag && ask(l + 1, r - 1))
	{
		v[l] = '(';
		v[r] = ')';
		solve(l + 1, r - 1);
	}
}

signed main()
{
	int n;
	cin >> n;
	v.resize(n + 1);
	solve(1, n);
	cout << "! ";
	for (int i = 1; i <= n; i++)
		cout << v[i];
	cout << endl;
	//system("pause");
}