#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
using namespace std;

bool full(string &s) {
	for (int i = 0; i < s.length(); i++) {
		if (s[i] != '+')
			return false;
	}
	return true;
}

const int len = 1000000;
bool dl[len];
bool dr[len];

bool can(string &l, string &r) {
	if (full(r)) {
		vector < pair < int, int > > v;
		for (int i = 0; i < l.size(); i++) {
			int pos = i;
			while (pos + 1 < l.length() && l[pos] == l[pos + 1])
				pos++;
			v.push_back({ l[i] == '+' ? 1 : 0, pos - i + 1 });
			i = pos;
		}
		for (int i = 0; i < v.size(); i++) {
			if (v[i].first == 1) {
				int l = i - 1;
				int r = i + 1;
				int sz = v[i].second;
				while (true) {
					if (l < 0 && r >= v.size())
						break;
					if (l >= 0 && sz > v[l].second) {
						sz += v[l].second;
						l--;
						if (l >= 0)
							sz += v[l].second;
						l--;
						continue;
					}
					if (r < v.size() && sz > v[r].second) {
						sz += v[r].second;
						r++;
						if (r < v.size())
							sz += v[r].second;
						r++;
						continue;
					}
					break;
				}
				if (r >= v.size() && l < 0)
					return true;
			}
		}
	}
	return false;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("storage.in", "r", stdin);
	freopen("storage.out", "w", stdout);
#endif
	int t;
	cin >> t;
	while (t--) {
		string a, b;
		cin >> a >> b;
		if (can(a, b))
			cout << "Yes" << endl;
		else
			cout << "No" << endl;
	}
}