#include <iostream>
#include <unordered_map>
#include <vector>
#include <queue>

#define long long long

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wsign-conversion"
using namespace std;

int n;

int main() {

    freopen("trains.in", "r", stdin);
    freopen("trains.out", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int m;
    cin >> n >> m;
    vector<unordered_map<int, int>> graph(n);
    for (int i = 0; i < m; i++) {
        int s;
        cin >> s;

        int v, t, u;
        cin >> v >> t >> u;
        v--;
        u--;
        cerr << graph[v].count(u);
        if (graph[v].count(u) == 0) {
            graph[v][u] = t;
        } else {
            graph[v][u] = min(graph[v][u], t);
        }
    }

    vector<int> dist(n, 1001 * n);
    vector<long> sq(n, 0);
    dist[0] = 0;
    for (int i = 0; i < n; i++) {
        for (int t = 0; t < n; t++) {
            for (auto u : graph[t]) {
                if (dist[u.first] > dist[t] + u.second) {
                    dist[u.first] = dist[t] + u.second;
                    sq[u.first] = sq[t] + (long) u.second * u.second;
                } else if (dist[u.first] == dist[t] + u.second) {
                    if (sq[u.first] < sq[t] + (long) u.second * u.second) {
                        sq[u.first] = sq[t] + (long) u.second * u.second;
                    }
                }
            }
        }
    }

    cout << dist[n - 1] << " " << sq[n - 1] << '\n';

    cout << dist[n - 1] << " " << sq[n - 1];

    return 0;

}

#pragma clang diagnostic pop