#ifdef _DEBUG
#	include <iostream>
#	include <vector>
#	include <string>
#	include <list>
#	include <algorithm>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;

const ll PR = (ll)1e9;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	const int SIZE = 2000;
#else
	const int SIZE = 2000001;
#endif

	ll n, a;
	cin >> n >> a;

	vector<ll> l(n), r(n), c(n);
	for (ll i = 0; i < n; i++)
		cin >> l[i] >> r[i] >> c[i];

	ll res[SIZE];
	ll cost[SIZE];

	ll l_res = 0, r_res = a + 1;
	while (l_res + 1 < r_res)
	{
		ll m = (r_res - l_res) / 2 + l_res;

		for (ll i = 0; i < a + 1; i++)
			res[i] = i, cost[i] = 0;

		int f = 0;
		for (ll i = a; i >= 0; i--)
		{
			for (ll j = 0; j < n; j++)
				if (i + r[j] < a + 1)
				{
					ll t = a + 1, cs = 0;
					for (ll k = i + l[j]; k <= i + r[j]; k++)
					{
						if (res[k] < t)
							t = res[k];
						if (res[k] == m && cost[k] + c[j] > cs)
							cs = cost[k] + c[j];
					}

					if (t >= m && (cs < cost[i] || cost[i] == 0))
					{
						res[i] = t;
						cost[i] = cs;
					}
				}
		}

		if (res[0] >= m)
			l_res = m;
		else
			r_res = m;
	}

	for (ll i = 0; i < a + 1; i++)
		res[i] = i, cost[i] = 0;

	int m = l_res;
	for (ll i = a; i >= 0; i--)
	{
		for (ll j = 0; j < n; j++)
			if (i + r[j] < a + 1)
			{
				ll t = a + 1, cs = 0;
				for (ll k = i + l[j]; k <= i + r[j]; k++)
				{
					if (res[k] < t)
						t = res[k];
					if (res[k] == m && cost[k] + c[j] > cs)
						cs = cost[k] + c[j];
				}

				if (t >= m && (cs < cost[i] || cost[i] == 0))
				{
					res[i] = t;
					cost[i] = cs;
				}
			}
	}

	cout << res[0] * PR - cost[0] << endl;

	int _r = 0;
}