#include <iostream>
#include <fstream>

using namespace std;

struct sig {
    int l, r;
    sig(int a = 0, int b = 2e9): l(a), r(b) {}
};

ostream & operator<<(ostream & out, sig a) {
    out << '(' << a.l << ' ' << a.r << ")";
    return out;
}

sig cross(sig a, sig b) {
    return sig(max(a.l, b.l), min(a.r, b.r));
}

sig extend_d(sig a, int d) {
    if (a.l > a.r)
        d = 0;
    return sig(a.l - d, a.r);
}

int main() {
    //ifstream cin("servers.in");
    int n;
    cin >> n;
    int buf[n];
    sig d[n], trans[n - 1], rd[n];
    for (int i = 0; i < n; i++) {
        cin >> buf[i];
    }
    for (int i = 0; i < n - 1; i++)
        cin >> trans[i].l >> trans[i].r;
    for (int i = 1; i < n; i++) {
        //cout << "d[" << i << "] = cross " <<d[i - 1] << trans[i - 1] << endl;
        d[i] = cross(d[i], cross(d[i - 1], trans[i - 1]));
        if (d[i].l == trans[i - 1].l)
            d[i] = extend_d(d[i], buf[i]);
    }
    for (int i = n - 2; i >= 0; i--) {

        //cout << "rd[" << i << "] = cross " <<d[i + 1] << trans[i] << endl;
        rd[i] = cross(rd[i], cross(rd[i + 1], trans[i]));
        if (rd[i].l == trans[i].l)
            rd[i] = extend_d(rd[i], buf[i]);
    }
    for (int i = 0; i < n; i++) {
        //cout << "D: " << d[i] << " rD: " << rd[i] << endl;
        sig cur = cross(cross(d[i], sig()), rd[i]);
        if (cur.l > cur.r)
            cout << "-1\n";
        else
            cout << cur.l << '\n';
    }
    return 0;
}
