#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define pb push_back

struct point {
    int x, y, id;
    point() {}
    point(int x, int y): x(x), y(y) {}
    void read() { cin >> x >> y; }
    void print() { cout << "(" << x << "; " << y << "), "; }
};
bool operator ==(const point a, const point b) {
    return a.x == b.x && a.y == b.y;
}

struct vec {
    ll x, y;
    vec() {}
    vec(point a, point b): x(b.x - a.x), y(b.y - a.y) {}
    ll operator %(const vec b) { return x * b.y - y * b.x; }
    void print() { cout << "{" << x << "; " << y << "}, "; }
};

int low = -1;
point tmp;
vector<point> arr;
bool cmp(point a, point b) {
    return vec(tmp, a) % vec(tmp, b) < 0;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    arr.resize(n);

    for (int k = 0; k < n; k++) {
        arr[k].read();
        arr[k].id = k;
        if (low == -1 || (arr[k].y < arr[low].y || (arr[k].y == arr[low].y && arr[k].x < arr[low].y))) { low = k; }
    }
    tmp = arr[low];
    arr.erase(arr.begin() + low);
    sort(arr.begin(), arr.end(), cmp);
    arr.pb(tmp);
    reverse(arr.begin(), arr.end());

    vector<vector<int> > tr;
    stack<int> st;
    st.push(0); st.push(1);
    for (int k = 2; k < n; k++) {
        int pr = st.top(); st.pop();
        vector<int> a(3);
        a[0] = low; a[1] = pr; a[2] = k;
        tr.pb(a);
        while (vec(arr[st.top()], arr[pr]) % vec(arr[pr], arr[k]) < 0) {
            vector<int> a(3);
            a[0] = st.top(); a[1] = pr; a[2] = k;
            tr.pb(a);

            pr = st.top();
            st.pop();
        }
        st.push(pr); st.push(k);
    }

    int m;
    cin >> m;
    for (int k = 0; k < m; k++) {
        for (int i = 0; i < (int)tr.size(); i++) {
            cout << "? 3 ";
            for (int j : tr[i]) { cout << arr[j].id + 1 << " "; }
            cout << endl;

            string s;
            cin >> s;
            if (s[0] == 'Y') {
                cout << "! 3 ";
                for (int j : tr[i]) { cout << arr[j].id + 1 << " "; }
                cout << endl;
                break;
            }
        }
    }
    return 0;
}
