#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include<fstream>
#include<algorithm>
#include <vector>
#include <string>
#include <set>


using namespace std;

typedef long long ll;

#define X first
#define Y second

const int MAXN = (int)1e5 + 7;

int a[MAXN], b[MAXN];

int x[MAXN];

int y[MAXN];

int n, m;

ll prefa[MAXN], prefb[MAXN];

ll get(int l, int r)
{
	if (l == 0)
		return prefb[r];
	else
		return prefb[r] - prefb[l - 1];
}

ll get1(int l, int r)
{
	if (l == 0)
		return prefa[r];
	else
		return prefa[r] - prefa[l - 1];
}


set < pair<ll, pair<int, int>>> s1, s2;

bool check(int l, int r, int l1, int r1)
{
	set<int> cur;
	for (int i = l; i <= r; i++)
	{
		cur.insert(a[i]);
		for (int j = l1; j <= r1; j++)
			if (cur.count(b[j]))
				return false;
	}
	return true;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++)
		cin >> x[i];
	for (int i = 0; i < m; i++)
		cin >> b[i];
	for (int i = 0; i < m; i++)
		cin >> y[i];
	prefa[0] = x[0];
	prefb[0] = y[0];
	ll ans = 0;
	ll ansl = -1;
	ll ansr = -1;
	ll ansl1 = -1;
	ll ansr1 = -1;
	for (int l1 = 0; l1 < m; l1++)
		for (int r1 = 0; r1 < m; r1++)
		{
			if (ans < get(l1, r1))
			{
				ans = get(l1, r1);
				ansl = -1;
				ansr = -1;
				ansl1 = l1;
				ansr1 = r1;

			}
		}
	for (int l1 = 0; l1 < n; l1++)
		for (int r1 = 0; r1 < n; r1++)
		{
			if (ans < get1(l1, r1))
			{
				ans = get(l1, r1);
				ansl = l1;
				ansr = r1;
				ansl1 = -1;
				ansr1 = -1;

			}
		}
	for (int i = 1; i < n; i++)
		prefa[i] = prefa[i - 1] + x[i];
	for (int i = 1; i < m; i++)
		prefb[i] = prefb[i - 1] + y[i];
	for (int i = 0; i < n; i++)
		for (int j = i; j < n; j++)
			s1.insert({ -get1(i, j), {i, j} });
	for (int i = 0; i < m; i++)
		for (int j = i; j < m; j++)
			s2.insert({ -get(i, j),{ i, j } });

	for (int l1 = 0; l1 < m; l1++)
		for (int r1 = 0; r1 < m; r1++)
		{
			if (ans < get(l1, r1))
			{
				ans = get(l1, r1);
				ansl = -1;
				ansr = -1;
				ansl1 = l1;
				ansr1 = r1;

			}
		}
	for (int l1 = 0; l1 < n; l1++)
		for (int r1 = 0; r1 < n; r1++)
		{
			if (ans < get1(l1, r1))
			{
				ans = get(l1, r1);
				ansl = l1;
				ansr = r1;
				ansl1 = -1;
				ansr1 = -1;

			}
		}
	int cnt = 0;
	for (auto it : s1)
		for (auto it1 : s2)
		{
			if (check(it.Y.X, it.Y.Y, it1.Y.X, it1.Y.Y))
			{
				if (ans < -it.X -it1.X)
				{
					ans = -it.X - it1.X;
					ansl = it.Y.X;
					ansr = it.Y.Y;
					ansl1 = it1.Y.X;
					ansr1 = it1.Y.Y;
				}
				cnt++;
				if (cnt == 10)
					break;
			}
		}
	cnt = 0;
	for (auto it1 : s2)
		for (auto it : s1)
		{
			if (check(it.Y.X, it.Y.Y, it1.Y.X, it1.Y.Y))
			{
				if (ans < -it.X - it1.X)
				{
					ans = -it.X - it1.X;
					ansl = it.Y.X;
					ansr = it.Y.Y;
					ansl1 = it1.Y.X;
					ansr1 = it1.Y.Y;
				}
				cnt++;
				if (cnt >= 10)
					break;
			}
		}
	cout << ans << "\n";
	cout << ansl + 1 << ' ' << ansr + 1 << "\n";
	cout << ansl1 + 1 << ' ' << ansr1 + 1 << "\n";
}