#include <iostream>
#include <vector>
#include <string>
#include <bitset>
using namespace std;

struct node
{
	int l, r;
	int m;
	node *left = nullptr, *right = nullptr;
	node(vector<vector<int>> & res) {

	}
};

int rc(vector<int> & res, vector<int> & a, int l, int r, int x)
{
	if ((a[l] & (1 << x)) == (a[r - 1] & (1 << x))) {
		for (int i = l; i < r; ++i) {
			if ((a[i] & (1 << x)) != (a[l] & (1 << x)))
				return -1;
		}
		if (x) {
			int ans = rc(res, a, l, r, x - 1);
			if (ans == -1)
				return -1;
		}
		return 0;
	}
	if ((a[l] & (1 << x)) < (a[r - 1] & (1 << x))) {
		int j = -1;
		for (int i = l + 1; i < r; ++i) {
			if ((a[i - 1] & (1 << x)) != (a[i] & (1 << x)))
				if (j == -1)
					j = i;
				else
					return -1;
		}
		if (x) {
			int ans = rc(res, a, l, j, x - 1);
			if (ans == -1)
				return -1;
			ans = rc(res, a, j, r, x - 1);
			if (ans == -1)
				return -1;
		}
		if (res[x] == -1 || res[x] == 0)
			res[x] = 0;
		else
			return -1;
		return 0;
	}
	if ((a[l] & (1 << x)) > (a[r - 1] & (1 << x))) {
		int j = -1;
		for (int i = l + 1; i < r; ++i) {
			if ((a[i - 1] & (1 << x)) != (a[i] & (1 << x)))
				if (j == -1)
					j = i;
				else
					return -1;
		}
		if (x) {
			int ans = rc(res, a, l, j, x - 1);
			if (ans == -1)
				return -1;
			ans = rc(res, a, j, r, x - 1);
			if (ans == -1)
				return -1;
		}
		if (res[x] == -1 || res[x] == 1)
			res[x] = 1;
		else
			return -1;
		return 0;
	}
}

void pr(vector<int> & a)
{
	bitset<31> r;
	vector<int> res(31, -1);
	if (rc(res, a, 0, a.size(), 30) == -1)
		cout << -1 << '\n';
	else {
		for (int i = 0; i < 31; ++i)
			if (res[i] == 1)
				r[i] = true;
		cout << r.to_ulong() << '\n';
	}
}

void uc(vector<int> & a, vector<vector<int>> & cnt, int x)
{
	for (int i = 1; i < a.size(); ++i) {
		if ((a[i] >> (x + 1)) == (a[i - 1] >> (x + 1))) {
			if ((a[i] & (1 << x)) > (a[i - 1] & (1 << x))) {
				++cnt[x][0];
			}
			if ((a[i] & (1 << x)) < (a[i - 1] & (1 << x))) {
				++cnt[x][1];
			}
		}
	}
}

void rf(vector<int> & a) {
	vector<vector<int>> cnt(30, vector<int>(2));
	for (int i = 0; i < 30; ++i)
		uc(a, cnt, i);
	for (int i = 0; i < 30; ++i)
		if (cnt[i][0] && cnt[i][1]) {
			cout << -1 << '\n';
			return;
		}
	bitset<31> r;
	for (int i = 0; i < 30; ++i)
		if (cnt[i][1])
			r[i] = true;
	cout << r.to_ulong() << '\n';
}

int main()
{
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	rf(a);
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int j, x;
		cin >> j >> x;
		a[j - 1] = x;
		rf(a);
	}
}
